---
title: Developer Resources
tags: [devdocs]
permalink: pmd_devdocs_development.html
last_updated: March 2024
---

## Source Code

The complete source code can be found on Github:

*   [github.com/pmd/pmd](https://github.com/pmd/pmd) - main PMD repository. Includes all the code to support all languages, including this documentation.
*   [github.com/pmd/pmd.github.io](https://github.com/pmd/pmd.github.io) - Contains the landing page [https://pmd.github.io](https://pmd.github.io)
*   [github.com/pmd/build-tools](https://github.com/pmd/build-tools) - Contains the checkstyle rules we use
*   [github.com/pmd/pmd-eclipse-plugin](https://github.com/pmd/pmd-eclipse-plugin) - The PMD eclipse plugin
*   [github.com/pmd](https://github.com/pmd) - PMD Organization at github. There are a couple of more repositories

## Continuous Integration

We use [GitHub Actions](https://github.com/pmd/pmd/actions) as our ci service. The main repo and the eclipse plugin are built for
every push. Each pull request is built as well.

The maven snapshot artifacts are deployed at [Sonatypes OSS snapshot repository](https://oss.sonatype.org/content/repositories/snapshots/net/sourceforge/pmd/pmd/).

Ready-to-use binary packages are uploaded to sourceforge at <https://sourceforge.net/projects/pmd/files/pmd/>.

## Documentation and Webpages

Main documentation server is [docs.pmd-code.org](https://docs.pmd-code.org).

A [snapshot](http://docs.pmd-code.org/snapshot/) of the web site for the new version is generated by the ci job as well.

The latest release documentation is always available under [docs.pmd-code.org/latest](https://docs.pmd-code.org/latest/)

## Contributing

First off, thanks for taking the time to contribute!

Please have a look at [CONTRIBUTING.md](https://github.com/pmd/pmd/blob/master/CONTRIBUTING.md) and
[BUILDING.md](https://github.com/pmd/pmd/blob/master/BUILDING.md).
