---
title: PMD in the press
permalink: pmd_projectdocs_trivia_news.html
author: Tom Copeland <tom@infoether.org>
---

## Sites/Articles about PMD


### Salesforce / Apex Language Module

*   October 2020 - [Salesforce CLI Scanner Custom XPath Rules - Part 1](https://bobbuzzard.blogspot.com/2020/10/salesforce-cli-scanner-custom-xpath.html),
    [Salesforce CLI Scanner Custom XPath Rules - Part 2](http://bobbuzzard.blogspot.com/2020/10/salesforce-cli-scanner-custom-xpath_11.html)
    by [Keir Bowden](https://twitter.com/bob_buzzard)

*   March 2020 - [Helping Salesforce developers create readable and maintainable Apex code](https://gearset.com/blog/helping-sf-developers-create-readable-and-maintainable-apex-code)

*   July 2019 - [Apex PMD \| Static code analysis - Apex Hours](https://youtu.be/34PxAHtAavU)

*   June 2019 - [Pluralsight](https://www.pluralsight.com/authors/don-robins) Course about leveraging PMD usage for
    Salesforce by [Robert Sösemann](https://github.com/rsoesemann) (Apex Language Module Contributor)
    [Play by Play: Automated Code Analysis in Salesforce - a Tools Deep-Dive](https://www.pluralsight.com/courses/play-by-play-automated-code-analysis-in-salesforce)

*   June 2018 - [Salesforce Way Podcast](https://salesforceway.com/podcast/podcast/) with
    [Robert Sösemann](https://github.com/rsoesemann) [Static Code Analysis with PMD for Apex](https://salesforceway.com/podcast/podcast/static-code-analysis-with-pmd-for-apex/)

*   January 2018 - [Webinar: How to contribute Apex rules to PMD with Robert Sösemann](https://www.youtube.com/watch?v=7_Ex9WWS_3Q)

*   August 2017 - Webinar about how to use PMD with The Welkin Suite Salesforce IDE - Author
    [Robert Sösemann](https://github.com/rsoesemann) - [Improving your Apex Code Quality with PMD in The Welkin Suite](https://www.youtube.com/watch?v=Ypyiy5b6huc)

*   November 2016 - Recording of [Robert Sösemann](https://github.com/rsoesemann)'s Session at Salesforce Dreamforce
    Conference about enforcing Clean Code in the Salesforce world using PMD and other tools
    [Clean Apex Code with Automatic Code Metrics](https://www.youtube.com/watch?v=bW7m6y6bEug)


### PMD in general and other Language Modules

*   April 2022 - Prediction of who should refactor the code, research available at
    <https://github.com/rkipp/DSCI644-2022-RefactoringRanking>.

*   February 2021 - Artem Krosheninnikov's talk about Quality Assurance Automation:
    [Artem Krosheninnikov, Wrike - How static analysis can help in QAA processes](
    https://www.youtube.com/watch?v=L42zH5ne074)

*   December 2020 - Jeroen Borgers' talk about finding performance bugs with PMD:
    [J-Fall Virtual 2020: Jeroen Borgers - Fixing your performance and concurrency bugs before they bite you](
    https://www.youtube.com/watch?v=Z_sT38KTRNk)

*   May 2019 - [Code quality assurance with PMD – An extensible static code analyser for Java and other languages](
    https://www.datarespons.com/code-quality-assurance-with-pmd/)

*   February 2012 - Romain Pelisse's lightning talk at FOSDEM 2012 about "PMD5: What can it do for you?".
    [Video recording is available](http://video.fosdem.org/2012/lightningtalks/PMD5.webm).

*   May 2008 - Romain Pelisse's article in LinuxMagazin: [An introduction
        to PMD (in French)](http://connect.ed-diamond.com/GNU-Linux-Magazine/GLMF-105/Verifier-votre-code-Java-avec-PMD)

*   July 2007 - Ryan Slobojan's article on [InfoQ](http://www.infoq.com/news/2007/07/pmd)
    discusses the PMD 4.0 release.

*   July 2006 - Paul Duvall's article "Automation for the people: Continuous Inspection" on
    [developerWorks](http://www-128.ibm.com/developerworks/java/library/j-ap08016/index.html) discusses CPD.

*   June 2006 - Andrew Glover's article "In pursuit of code quality: Tame the chatterbox" on
    [developerWorks](http://www-128.ibm.com/developerworks/java/library/j-cq06306/index.html?ca=drs-)
    discusses PMD and JavaNCSS.

*   June 2006 - Tom Copeland's article "Static Electricity: Better Living with Static Code Analysis" in
    [Better Software](http://tomcopeland.blogs.com/juniordeveloper/2006/06/a_pmd_analysis_.html) discusses
    PMD/CPD analyses of Azureus and Columba.

*   April 2006 - John Ferguson Smart's article "PMD Squashes Code Bugs" on
    [DevX](https://web.archive.org/web/20140214143838/http://www.devx.com/Java/Article/31286) discusses PMD and the Eclipse plugin. Lots of screenshots!

*   November 2005 - Mike Clark's article "Staying Out of Code Debt" on
    [StickyMinds](http://www.stickyminds.com/sitewide.asp?Function=edetail&amp;ObjectType=ART&amp;ObjectId=9860&amp;tth=DYN&amp;tt=siteemail&amp;iDyn=2)
    mentions both PMD and CPD as useful code-checking tools.

*   October 2005 - Levent Gurses' article "Improving Code Quality with PMD and Eclipse" in
    [EclipseZone](https://web.archive.org/web/20080807160502/http://www.eclipsezone.com/articles/pmd/) talks about the PMD Eclipse plugin and explains many
    different facets of PMD - XPath, writing rules, the AST, all that.  Good stuff!

*   June 2005 - Amit Chaturvedi's article "Java & Static Analysis" in
    [Doctor Dobb's Journal](http://www.drdobbs.com/jvm/java-static-analysis/184406143) talks about PMD and shows a
    screenshot of the rule designer

*   March 2005 - Kirk Knoernschild's article "Benefits of the Build" in
    [Doctor Dobb's Journal](http://www.drdobbs.com/benefits-of-the-build/184415286) mentions PMD as a way
    to automate code reviews

*   February 2005 - [Java Is Well-Suited for Open-Source Projects](https://webcache.googleusercontent.com/search?q=cache:aEL-9Ncx2RgJ:https://www.eweek.com/development/java-is-well-suited-for-open-source-projects) -
    Peter Coffee's eWeek article on open source, Java, and PMD

*   January 2005 - [Zap bugs with PMD](http://www.ibm.com/developerworks/java/library/j-pmd/) - Elliotte Rusty
    Harold's article on installing, configuring, and running PMD

*   November 2004 - [PMD: A code analyzer for Java programmers](http://archive09.linux.com/feature/40235) - Daniel
    Rubio's article about PMD; includes some notes on XPath rules

*   June 2004 - [Code Improvement Through Cyclomatic Complexity](http://onjava.com/pub/a/onjava/2004/06/16/ccunittest.html) -
    Andrew Glover's CCM article featuring PMD

*   June 2004 - [Open Source-Perlen](http://tinyurl.com/3dgpe) - A German article on PMD in Java Magazin

*   June 2004 - [Improving Project Quality with PMD](https://web.archive.org/web/20211203041417/http://jnb.ociweb.com/jnb/jnbJun2004.html) - Tom Wheeler's
    "Java News Brief", June 2004 issue

*   February 2004 - [Software Development](http://www.drdobbs.com/free-as-in-freedom/184415103) - Listed as one of
    their 'Open-Source Projects to Watch'

*   November 2003 - [JavaWorld: "Bug patrol"](http://www.javaworld.com/javaworld/jw-11-2003/jw-1121-quality.html) -
    Various code inspection tools

*   June 2003 - [Software Development Times](https://web.archive.org/web/20070914023950/http://www.sdtimes.com/article/story-20030615-15.html) - PMD is embedded in QStudio.

*   May 2003 - [techrepublic.com](http://www.techrepublic.com/article/three-tools-that-make-java-code-review-painless-and-effective/5031836) -
    PMD, Checkstyle, and Jalopy

*   April 2003 - [O'Reilly OnJava.com](https://web.archive.org/web/20180505093751/http://www.onjava.com/pub/a/onjava/2003/04/09/pmd_rules.html) - PMD custom rules

*   March 2003 - [O'Reilly OnJava.com](https://web.archive.org/web/20180505092514/http://www.onjava.com/pub/a/onjava/2003/03/12/pmd_cpd.html) - overview of CPD

*   February 2003 - [O'Reilly OnJava.com](https://web.archive.org/web/20180506055525/http://www.onjava.com/pub/a/onjava/2003/02/12/static_analysis.html) - overview of PMD

*   January 2003 - [Sprout](https://netbeans.org/community/articles/interviews/tom_copeland_ole-martin_fr.html) -
    interview with Ole-Martin and Tom
