/**
 * Copyright (c), FinancialForce.com, inc
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 *   are permitted provided that the following conditions are met:
 *
 * - Redistributions of source code must retain the above copyright notice,
 *      this list of conditions and the following disclaimer.
 * - Redistributions in binary form must reproduce the above copyright notice,
 *      this list of conditions and the following disclaimer in the documentation
 *      and/or other materials provided with the distribution.
 * - Neither the name of the FinancialForce.com, inc nor the names of its contributors
 *      may be used to endorse or promote products derived from this software without
 *      specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 *  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 *  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 *  THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 *  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 *  OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 *  OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 *  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**/

//Patched by MetadataServicePatcher v35.0 2015-12-11 00:00:00

//Generated by wsdl2apex

public class MetadataService {
    public class ReportTypeColumnTranslation {
        public String label;
        public String name;
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'label','name'};
    }
    public class DomainWhitelist {
        public String[] domain;
        private String[] domain_type_info = new String[]{'domain','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'domain'};
    }
    public class LiveChatDeployment extends Metadata {
        public String type = 'LiveChatDeployment';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String brandingImage;
        public Boolean displayQueuePosition;
        public MetadataService.LiveChatDeploymentDomainWhitelist domainWhiteList;
        public Boolean enablePrechatApi;
        public Boolean enableTranscriptSave;
        public String label;
        public String mobileBrandingImage;
        public String site;
        public String windowTitle;
        private String[] brandingImage_type_info = new String[]{'brandingImage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] displayQueuePosition_type_info = new String[]{'displayQueuePosition','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] domainWhiteList_type_info = new String[]{'domainWhiteList','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enablePrechatApi_type_info = new String[]{'enablePrechatApi','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableTranscriptSave_type_info = new String[]{'enableTranscriptSave','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] mobileBrandingImage_type_info = new String[]{'mobileBrandingImage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] site_type_info = new String[]{'site','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] windowTitle_type_info = new String[]{'windowTitle','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'brandingImage','displayQueuePosition','domainWhiteList','enablePrechatApi','enableTranscriptSave','label','mobileBrandingImage','site','windowTitle'};
    }
    public class ReportFilterItem {
        public String column;
        public Boolean columnToColumn;
        public String operator;
        public String snapshot;
        public String value;
        private String[] column_type_info = new String[]{'column','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] columnToColumn_type_info = new String[]{'columnToColumn','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] operator_type_info = new String[]{'operator','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] snapshot_type_info = new String[]{'snapshot','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] value_type_info = new String[]{'value','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'column','columnToColumn','operator','snapshot','value'};
    }
    public class FlowElementReferenceOrValue {
        public Boolean booleanValue;
        public DateTime dateTimeValue;
        public Date dateValue;
        public String elementReference;
        public Double numberValue;
        public String stringValue;
        private String[] booleanValue_type_info = new String[]{'booleanValue','http://soap.sforce.com/2006/04/metadata',null,'0','1','true'};
        private String[] dateTimeValue_type_info = new String[]{'dateTimeValue','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] dateValue_type_info = new String[]{'dateValue','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] elementReference_type_info = new String[]{'elementReference','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] numberValue_type_info = new String[]{'numberValue','http://soap.sforce.com/2006/04/metadata',null,'0','1','true'};
        private String[] stringValue_type_info = new String[]{'stringValue','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'booleanValue','dateTimeValue','dateValue','elementReference','numberValue','stringValue'};
    }
    public class FlowWaitEventOutputParameter extends FlowBaseElement {
        public String type = 'FlowWaitEventOutputParameter';
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        public String assignToReference;
        public String name;
        private String[] assignToReference_type_info = new String[]{'assignToReference','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'processMetadataValues', 'assignToReference','name'};
    }
    public class SaveResult {
        public MetadataService.Error[] errors;
        public String fullName;
        public Boolean success;
        private String[] errors_type_info = new String[]{'errors','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] success_type_info = new String[]{'success','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'errors','fullName','success'};
    }
    public class SessionSettings {
        public Boolean disableTimeoutWarning;
        public Boolean enableCSPOnEmail;
        public Boolean enableCSRFOnGet;
        public Boolean enableCSRFOnPost;
        public Boolean enableCacheAndAutocomplete;
        public Boolean enableClickjackNonsetupSFDC;
        public Boolean enableClickjackNonsetupUser;
        public Boolean enableClickjackNonsetupUserHeaderless;
        public Boolean enableClickjackSetup;
        public Boolean enablePostForSessions;
        public Boolean enableSMSIdentity;
        public Boolean enforceIpRangesEveryRequest;
        public Boolean forceLogoutOnSessionTimeout;
        public Boolean forceRelogin;
        public Boolean lockSessionsToDomain;
        public Boolean lockSessionsToIp;
        public String logoutURL;
        public String sessionTimeout;
        private String[] disableTimeoutWarning_type_info = new String[]{'disableTimeoutWarning','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableCSPOnEmail_type_info = new String[]{'enableCSPOnEmail','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableCSRFOnGet_type_info = new String[]{'enableCSRFOnGet','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableCSRFOnPost_type_info = new String[]{'enableCSRFOnPost','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableCacheAndAutocomplete_type_info = new String[]{'enableCacheAndAutocomplete','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableClickjackNonsetupSFDC_type_info = new String[]{'enableClickjackNonsetupSFDC','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableClickjackNonsetupUser_type_info = new String[]{'enableClickjackNonsetupUser','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableClickjackNonsetupUserHeaderless_type_info = new String[]{'enableClickjackNonsetupUserHeaderless','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableClickjackSetup_type_info = new String[]{'enableClickjackSetup','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enablePostForSessions_type_info = new String[]{'enablePostForSessions','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableSMSIdentity_type_info = new String[]{'enableSMSIdentity','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enforceIpRangesEveryRequest_type_info = new String[]{'enforceIpRangesEveryRequest','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] forceLogoutOnSessionTimeout_type_info = new String[]{'forceLogoutOnSessionTimeout','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] forceRelogin_type_info = new String[]{'forceRelogin','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] lockSessionsToDomain_type_info = new String[]{'lockSessionsToDomain','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] lockSessionsToIp_type_info = new String[]{'lockSessionsToIp','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] logoutURL_type_info = new String[]{'logoutURL','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] sessionTimeout_type_info = new String[]{'sessionTimeout','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'disableTimeoutWarning','enableCSPOnEmail','enableCSRFOnGet','enableCSRFOnPost','enableCacheAndAutocomplete','enableClickjackNonsetupSFDC','enableClickjackNonsetupUser','enableClickjackNonsetupUserHeaderless','enableClickjackSetup','enablePostForSessions','enableSMSIdentity','enforceIpRangesEveryRequest','forceLogoutOnSessionTimeout','forceRelogin','lockSessionsToDomain','lockSessionsToIp','logoutURL','sessionTimeout'};
    }
    public class SharingOwnerRule extends SharingBaseRule {
        public String type = 'SharingOwnerRule';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String accessLevel;
        public MetadataService.AccountSharingRuleSettings accountSettings;
        public String description;
        public String label;
        public MetadataService.SharedTo sharedTo;
        private String[] accessLevel_type_info = new String[]{'accessLevel','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] accountSettings_type_info = new String[]{'accountSettings','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] sharedTo_type_info = new String[]{'sharedTo','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        public MetadataService.SharedTo sharedFrom;
        private String[] sharedFrom_type_info = new String[]{'sharedFrom','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName','accessLevel','accountSettings','description','label','sharedTo', 'sharedFrom'};
    }
    public class CaseSettings extends Metadata {
        public String type = 'CaseSettings';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String caseAssignNotificationTemplate;
        public String caseCloseNotificationTemplate;
        public String caseCommentNotificationTemplate;
        public String caseCreateNotificationTemplate;
        public MetadataService.FeedItemSettings[] caseFeedItemSettings;
        public Boolean closeCaseThroughStatusChange;
        public String defaultCaseOwner;
        public String defaultCaseOwnerType;
        public String defaultCaseUser;
        public String emailActionDefaultsHandlerClass;
        public MetadataService.EmailToCaseSettings emailToCase;
        public Boolean enableCaseFeed;
        public Boolean enableDraftEmails;
        public Boolean enableEarlyEscalationRuleTriggers;
        public Boolean enableEmailActionDefaultsHandler;
        public Boolean enableSuggestedArticlesApplication;
        public Boolean enableSuggestedArticlesCustomerPortal;
        public Boolean enableSuggestedArticlesPartnerPortal;
        public Boolean enableSuggestedSolutions;
        public Boolean keepRecordTypeOnAssignmentRule;
        public Boolean notifyContactOnCaseComment;
        public Boolean notifyDefaultCaseOwner;
        public Boolean notifyOwnerOnCaseComment;
        public Boolean notifyOwnerOnCaseOwnerChange;
        public Boolean showFewerCloseActions;
        public Boolean useSystemEmailAddress;
        public MetadataService.WebToCaseSettings webToCase;
        private String[] caseAssignNotificationTemplate_type_info = new String[]{'caseAssignNotificationTemplate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] caseCloseNotificationTemplate_type_info = new String[]{'caseCloseNotificationTemplate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] caseCommentNotificationTemplate_type_info = new String[]{'caseCommentNotificationTemplate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] caseCreateNotificationTemplate_type_info = new String[]{'caseCreateNotificationTemplate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] caseFeedItemSettings_type_info = new String[]{'caseFeedItemSettings','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] closeCaseThroughStatusChange_type_info = new String[]{'closeCaseThroughStatusChange','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] defaultCaseOwner_type_info = new String[]{'defaultCaseOwner','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] defaultCaseOwnerType_type_info = new String[]{'defaultCaseOwnerType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] defaultCaseUser_type_info = new String[]{'defaultCaseUser','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] emailActionDefaultsHandlerClass_type_info = new String[]{'emailActionDefaultsHandlerClass','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] emailToCase_type_info = new String[]{'emailToCase','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableCaseFeed_type_info = new String[]{'enableCaseFeed','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableDraftEmails_type_info = new String[]{'enableDraftEmails','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableEarlyEscalationRuleTriggers_type_info = new String[]{'enableEarlyEscalationRuleTriggers','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableEmailActionDefaultsHandler_type_info = new String[]{'enableEmailActionDefaultsHandler','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableSuggestedArticlesApplication_type_info = new String[]{'enableSuggestedArticlesApplication','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableSuggestedArticlesCustomerPortal_type_info = new String[]{'enableSuggestedArticlesCustomerPortal','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableSuggestedArticlesPartnerPortal_type_info = new String[]{'enableSuggestedArticlesPartnerPortal','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableSuggestedSolutions_type_info = new String[]{'enableSuggestedSolutions','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] keepRecordTypeOnAssignmentRule_type_info = new String[]{'keepRecordTypeOnAssignmentRule','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] notifyContactOnCaseComment_type_info = new String[]{'notifyContactOnCaseComment','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] notifyDefaultCaseOwner_type_info = new String[]{'notifyDefaultCaseOwner','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] notifyOwnerOnCaseComment_type_info = new String[]{'notifyOwnerOnCaseComment','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] notifyOwnerOnCaseOwnerChange_type_info = new String[]{'notifyOwnerOnCaseOwnerChange','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showFewerCloseActions_type_info = new String[]{'showFewerCloseActions','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] useSystemEmailAddress_type_info = new String[]{'useSystemEmailAddress','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] webToCase_type_info = new String[]{'webToCase','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'caseAssignNotificationTemplate','caseCloseNotificationTemplate','caseCommentNotificationTemplate','caseCreateNotificationTemplate','caseFeedItemSettings','closeCaseThroughStatusChange','defaultCaseOwner','defaultCaseOwnerType','defaultCaseUser','emailActionDefaultsHandlerClass','emailToCase','enableCaseFeed','enableDraftEmails','enableEarlyEscalationRuleTriggers','enableEmailActionDefaultsHandler','enableSuggestedArticlesApplication','enableSuggestedArticlesCustomerPortal','enableSuggestedArticlesPartnerPortal','enableSuggestedSolutions','keepRecordTypeOnAssignmentRule','notifyContactOnCaseComment','notifyDefaultCaseOwner','notifyOwnerOnCaseComment','notifyOwnerOnCaseOwnerChange','showFewerCloseActions','useSystemEmailAddress','webToCase'};
    }
    public class readMetadataResponse_element {
        public MetadataService.ReadResult result;
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class MiniLayout {
        public String[] fields;
        public MetadataService.RelatedListItem[] relatedLists;
        private String[] fields_type_info = new String[]{'fields','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] relatedLists_type_info = new String[]{'relatedLists','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'fields','relatedLists'};
    }
    public class FieldValue {
        public String name;
        public String value;
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] value_type_info = new String[]{'value','http://soap.sforce.com/2006/04/metadata',null,'1','1','true'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'name','value'};
    }
    public class LicensedCustomPermissions {
        public String customPermission;
        public String licenseDefinition;
        private String[] customPermission_type_info = new String[]{'customPermission','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] licenseDefinition_type_info = new String[]{'licenseDefinition','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'customPermission','licenseDefinition'};
    }
    public class UpsertResult {
        public Boolean created;
        public MetadataService.Error[] errors;
        public String fullName;
        public Boolean success;
        private String[] created_type_info = new String[]{'created','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] errors_type_info = new String[]{'errors','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] success_type_info = new String[]{'success','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'created','errors','fullName','success'};
    }
    public class ConnectedAppAttribute {
        public String formula;
        public String key;
        private String[] formula_type_info = new String[]{'formula','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] key_type_info = new String[]{'key','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'formula','key'};
    }
    public class WorkflowFieldUpdate extends WorkflowAction {
        public String type = 'WorkflowFieldUpdate';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String description;
        public String field;
        public String formula;
        public String literalValue;
        public String lookupValue;
        public String lookupValueType;
        public String name;
        public Boolean notifyAssignee;
        public String operation;
        public Boolean protected_x;
        public Boolean reevaluateOnChange;
        public String targetObject;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] field_type_info = new String[]{'field','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] formula_type_info = new String[]{'formula','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] literalValue_type_info = new String[]{'literalValue','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] lookupValue_type_info = new String[]{'lookupValue','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] lookupValueType_type_info = new String[]{'lookupValueType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] notifyAssignee_type_info = new String[]{'notifyAssignee','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] operation_type_info = new String[]{'operation','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] protected_x_type_info = new String[]{'protected','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] reevaluateOnChange_type_info = new String[]{'reevaluateOnChange','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] targetObject_type_info = new String[]{'targetObject','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'description','field','formula','literalValue','lookupValue','lookupValueType','name','notifyAssignee','operation','protected_x','reevaluateOnChange','targetObject'};
    }
    public class AssignmentRule extends Metadata {
        public String type = 'AssignmentRule';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Boolean active;
        public MetadataService.RuleEntry[] ruleEntry;
        private String[] active_type_info = new String[]{'active','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] ruleEntry_type_info = new String[]{'ruleEntry','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'active','ruleEntry'};
    }
    public class PushNotifications {
        public MetadataService.PushNotification[] pushNotification;
        private String[] pushNotification_type_info = new String[]{'pushNotification','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'pushNotification'};
    }
    public class LiveChatButtonDeployments {
        public String[] deployment;
        private String[] deployment_type_info = new String[]{'deployment','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'deployment'};
    }
    public class DataCategoryGroup extends Metadata {
        public String type = 'DataCategoryGroup';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Boolean active;
        public MetadataService.DataCategory dataCategory;
        public String description;
        public String label;
        public MetadataService.ObjectUsage objectUsage;
        private String[] active_type_info = new String[]{'active','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] dataCategory_type_info = new String[]{'dataCategory','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] objectUsage_type_info = new String[]{'objectUsage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'active','dataCategory','description','label','objectUsage'};
    }
    public class DashboardGridComponent {
        public Integer colSpan;
        public Integer columnIndex;
        public MetadataService.DashboardComponent dashboardComponent;
        public Integer rowIndex;
        public Integer rowSpan;
        private String[] colSpan_type_info = new String[]{'colSpan','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] columnIndex_type_info = new String[]{'columnIndex','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] dashboardComponent_type_info = new String[]{'dashboardComponent','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] rowIndex_type_info = new String[]{'rowIndex','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] rowSpan_type_info = new String[]{'rowSpan','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'colSpan','columnIndex','dashboardComponent','rowIndex','rowSpan'};
    }
    public class CustomDataTypeComponent {
        public String developerSuffix;
        public Boolean enforceFieldRequiredness;
        public String label;
        public Integer length;
        public Integer precision;
        public Integer scale;
        public String sortOrder;
        public Integer sortPriority;
        public String type_x;
        private String[] developerSuffix_type_info = new String[]{'developerSuffix','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] enforceFieldRequiredness_type_info = new String[]{'enforceFieldRequiredness','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] length_type_info = new String[]{'length','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] precision_type_info = new String[]{'precision','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] scale_type_info = new String[]{'scale','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] sortOrder_type_info = new String[]{'sortOrder','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] sortPriority_type_info = new String[]{'sortPriority','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] type_x_type_info = new String[]{'type','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'developerSuffix','enforceFieldRequiredness','label','length','precision','scale','sortOrder','sortPriority','type_x'};
    }
    public class KnowledgeSitesSettings {
        public String[] site;
        private String[] site_type_info = new String[]{'site','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'site'};
    }
    public class SearchLayouts {
        public String[] customTabListAdditionalFields;
        public String[] excludedStandardButtons;
        public String[] listViewButtons;
        public String[] lookupDialogsAdditionalFields;
        public String[] lookupFilterFields;
        public String[] lookupPhoneDialogsAdditionalFields;
        public String[] searchFilterFields;
        public String[] searchResultsAdditionalFields;
        public String[] searchResultsCustomButtons;
        private String[] customTabListAdditionalFields_type_info = new String[]{'customTabListAdditionalFields','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] excludedStandardButtons_type_info = new String[]{'excludedStandardButtons','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] listViewButtons_type_info = new String[]{'listViewButtons','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] lookupDialogsAdditionalFields_type_info = new String[]{'lookupDialogsAdditionalFields','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] lookupFilterFields_type_info = new String[]{'lookupFilterFields','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] lookupPhoneDialogsAdditionalFields_type_info = new String[]{'lookupPhoneDialogsAdditionalFields','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] searchFilterFields_type_info = new String[]{'searchFilterFields','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] searchResultsAdditionalFields_type_info = new String[]{'searchResultsAdditionalFields','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] searchResultsCustomButtons_type_info = new String[]{'searchResultsCustomButtons','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'customTabListAdditionalFields','excludedStandardButtons','listViewButtons','lookupDialogsAdditionalFields','lookupFilterFields','lookupPhoneDialogsAdditionalFields','searchFilterFields','searchResultsAdditionalFields','searchResultsCustomButtons'};
    }
    public class retrieve_element {
        public MetadataService.RetrieveRequest retrieveRequest;
        private String[] retrieveRequest_type_info = new String[]{'retrieveRequest','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'retrieveRequest'};
    }
    public class AssignmentRules extends Metadata {
        public String type = 'AssignmentRules';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public MetadataService.AssignmentRule[] assignmentRule;
        private String[] assignmentRule_type_info = new String[]{'assignmentRule','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'assignmentRule'};
    }
    public class DeleteResult {
        public MetadataService.Error[] errors;
        public String fullName;
        public Boolean success;
        private String[] errors_type_info = new String[]{'errors','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] success_type_info = new String[]{'success','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'errors','fullName','success'};
    }
    public class PackageTypeMembers {
        public String[] members;
        public String name;
        private String[] members_type_info = new String[]{'members','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'members','name'};
    }
    public class DashboardFilter {
        public MetadataService.DashboardFilterOption[] dashboardFilterOptions;
        public String name;
        private String[] dashboardFilterOptions_type_info = new String[]{'dashboardFilterOptions','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'dashboardFilterOptions','name'};
    }
    public class ProfileApplicationVisibility {
        public String application;
        public Boolean default_x;
        public Boolean visible;
        private String[] application_type_info = new String[]{'application','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] default_x_type_info = new String[]{'default','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] visible_type_info = new String[]{'visible','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'application','default_x','visible'};
    }
    public class ReportParam {
        public String name;
        public String value;
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] value_type_info = new String[]{'value','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'name','value'};
    }
    public class RelatedListItem {
        public String[] customButtons;
        public String[] excludeButtons;
        public String[] fields;
        public String relatedList;
        public String sortField;
        public String sortOrder;
        private String[] customButtons_type_info = new String[]{'customButtons','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] excludeButtons_type_info = new String[]{'excludeButtons','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] fields_type_info = new String[]{'fields','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] relatedList_type_info = new String[]{'relatedList','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] sortField_type_info = new String[]{'sortField','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] sortOrder_type_info = new String[]{'sortOrder','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'customButtons','excludeButtons','fields','relatedList','sortField','sortOrder'};
    }
    public class SynonymDictionary extends Metadata {
        public String type = 'SynonymDictionary';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public MetadataService.SynonymGroup[] groups;
        public Boolean isProtected;
        public String label;
        private String[] groups_type_info = new String[]{'groups','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] isProtected_type_info = new String[]{'isProtected','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'groups','isProtected','label'};
    }
    public class WebLinkTranslation {
        public String label;
        public String name;
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'label','name'};
    }
    public class CustomTabTranslation {
        public String label;
        public String name;
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'label','name'};
    }
    public class PackageVersion {
        public Integer majorNumber;
        public Integer minorNumber;
        public String namespace;
        private String[] majorNumber_type_info = new String[]{'majorNumber','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] minorNumber_type_info = new String[]{'minorNumber','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] namespace_type_info = new String[]{'namespace','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'majorNumber','minorNumber','namespace'};
    }
    public class DescribeMetadataObject {
        public String[] childXmlNames;
        public String directoryName;
        public Boolean inFolder;
        public Boolean metaFile;
        public String suffix;
        public String xmlName;
        private String[] childXmlNames_type_info = new String[]{'childXmlNames','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] directoryName_type_info = new String[]{'directoryName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] inFolder_type_info = new String[]{'inFolder','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] metaFile_type_info = new String[]{'metaFile','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] suffix_type_info = new String[]{'suffix','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] xmlName_type_info = new String[]{'xmlName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'childXmlNames','directoryName','inFolder','metaFile','suffix','xmlName'};
    }
    public class LiveAgentSettings extends Metadata {
        public String type = 'LiveAgentSettings';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Boolean enableLiveAgent;
        private String[] enableLiveAgent_type_info = new String[]{'enableLiveAgent','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'enableLiveAgent'};
    }
    public class WorkflowFlowAction {
        public String description;
        public String flow;
        public MetadataService.WorkflowFlowActionParameter[] flowInputs;
        public String label;
        public String language;
        public Boolean protected_x;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] flow_type_info = new String[]{'flow','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] flowInputs_type_info = new String[]{'flowInputs','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] language_type_info = new String[]{'language','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] protected_x_type_info = new String[]{'protected','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'description','flow','flowInputs','label','language','protected_x'};
    }
    public class AllOrNoneHeader_element {
        public Boolean allOrNone;
        private String[] allOrNone_type_info = new String[]{'allOrNone','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'allOrNone'};
    }
    public class WorkflowTaskTranslation {
        public String description;
        public String name;
        public String subject;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] subject_type_info = new String[]{'subject','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'description','name','subject'};
    }
    public class listMetadata_element {
        public MetadataService.ListMetadataQuery[] queries;
        public Double asOfVersion;
        private String[] queries_type_info = new String[]{'queries','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] asOfVersion_type_info = new String[]{'asOfVersion','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'queries','asOfVersion'};
    }
    public class AuraDefinitionBundle extends Metadata {
        public String type = 'AuraDefinitionBundle';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String SVGContent;
        public Double apiVersion;
        public String controllerContent;
        public String description;
        public String designContent;
        public String documentationContent;
        public String helperContent;
        public String markup;
        public String modelContent;
        public MetadataService.PackageVersion[] packageVersions;
        public String rendererContent;
        public String styleContent;
        public String testsuiteContent;
        public String type_x;
        private String[] SVGContent_type_info = new String[]{'SVGContent','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apiVersion_type_info = new String[]{'apiVersion','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] controllerContent_type_info = new String[]{'controllerContent','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] designContent_type_info = new String[]{'designContent','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] documentationContent_type_info = new String[]{'documentationContent','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] helperContent_type_info = new String[]{'helperContent','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] markup_type_info = new String[]{'markup','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] modelContent_type_info = new String[]{'modelContent','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] packageVersions_type_info = new String[]{'packageVersions','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] rendererContent_type_info = new String[]{'rendererContent','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] styleContent_type_info = new String[]{'styleContent','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] testsuiteContent_type_info = new String[]{'testsuiteContent','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] type_x_type_info = new String[]{'type','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'SVGContent','apiVersion','controllerContent','description','designContent','documentationContent','helperContent','markup','modelContent','packageVersions','rendererContent','styleContent','testsuiteContent','type_x'};
    }
    public class Queue extends Metadata {
        public String type = 'Queue';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Boolean doesSendEmailToMembers;
        public String email;
        public String name;
        public MetadataService.QueueSobject[] queueSobject;
        private String[] doesSendEmailToMembers_type_info = new String[]{'doesSendEmailToMembers','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] email_type_info = new String[]{'email','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] queueSobject_type_info = new String[]{'queueSobject','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'doesSendEmailToMembers','email','name','queueSobject'};
    }
    public class HomePageLayout extends Metadata {
        public String type = 'HomePageLayout';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String[] narrowComponents;
        public String[] wideComponents;
        private String[] narrowComponents_type_info = new String[]{'narrowComponents','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] wideComponents_type_info = new String[]{'wideComponents','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'narrowComponents','wideComponents'};
    }
    public class MilestoneType extends Metadata {
        public String type = 'MilestoneType';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String description;
        public String recurrenceType;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] recurrenceType_type_info = new String[]{'recurrenceType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'description','recurrenceType'};
    }
    public class WeightedSourceCategory {
        public String sourceCategoryApiName;
        public Double weight;
        private String[] sourceCategoryApiName_type_info = new String[]{'sourceCategoryApiName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] weight_type_info = new String[]{'weight','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'sourceCategoryApiName','weight'};
    }
    public class ApprovalProcess extends Metadata {
        public String type = 'ApprovalProcess';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Boolean active;
        public Boolean allowRecall;
        public MetadataService.ApprovalSubmitter[] allowedSubmitters;
        public MetadataService.ApprovalPageField approvalPageFields;
        public MetadataService.ApprovalStep[] approvalStep;
        public String description;
        public String emailTemplate;
        public Boolean enableMobileDeviceAccess;
        public MetadataService.ApprovalEntryCriteria entryCriteria;
        public MetadataService.ApprovalAction finalApprovalActions;
        public Boolean finalApprovalRecordLock;
        public MetadataService.ApprovalAction finalRejectionActions;
        public Boolean finalRejectionRecordLock;
        public MetadataService.ApprovalAction initialSubmissionActions;
        public String label;
        public MetadataService.NextAutomatedApprover nextAutomatedApprover;
        public String postTemplate;
        public MetadataService.ApprovalAction recallActions;
        public String recordEditability;
        public Boolean showApprovalHistory;
        private String[] active_type_info = new String[]{'active','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] allowRecall_type_info = new String[]{'allowRecall','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] allowedSubmitters_type_info = new String[]{'allowedSubmitters','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] approvalPageFields_type_info = new String[]{'approvalPageFields','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] approvalStep_type_info = new String[]{'approvalStep','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] emailTemplate_type_info = new String[]{'emailTemplate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableMobileDeviceAccess_type_info = new String[]{'enableMobileDeviceAccess','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] entryCriteria_type_info = new String[]{'entryCriteria','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] finalApprovalActions_type_info = new String[]{'finalApprovalActions','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] finalApprovalRecordLock_type_info = new String[]{'finalApprovalRecordLock','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] finalRejectionActions_type_info = new String[]{'finalRejectionActions','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] finalRejectionRecordLock_type_info = new String[]{'finalRejectionRecordLock','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] initialSubmissionActions_type_info = new String[]{'initialSubmissionActions','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] nextAutomatedApprover_type_info = new String[]{'nextAutomatedApprover','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] postTemplate_type_info = new String[]{'postTemplate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] recallActions_type_info = new String[]{'recallActions','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] recordEditability_type_info = new String[]{'recordEditability','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] showApprovalHistory_type_info = new String[]{'showApprovalHistory','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'active','allowRecall','allowedSubmitters','approvalPageFields','approvalStep','description','emailTemplate','enableMobileDeviceAccess','entryCriteria','finalApprovalActions','finalApprovalRecordLock','finalRejectionActions','finalRejectionRecordLock','initialSubmissionActions','label','nextAutomatedApprover','postTemplate','recallActions','recordEditability','showApprovalHistory'};
    }
    public class EntitlementProcess extends Metadata {
        public String type = 'EntitlementProcess';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Boolean active;
        public String businessHours;
        public String description;
        public String entryStartDateField;
        public String exitCriteriaBooleanFilter;
        public MetadataService.FilterItem[] exitCriteriaFilterItems;
        public String exitCriteriaFormula;
        public Boolean isVersionDefault;
        public MetadataService.EntitlementProcessMilestoneItem[] milestones;
        public String name;
        public String versionMaster;
        public String versionNotes;
        public Integer versionNumber;
        private String[] active_type_info = new String[]{'active','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] businessHours_type_info = new String[]{'businessHours','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] entryStartDateField_type_info = new String[]{'entryStartDateField','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] exitCriteriaBooleanFilter_type_info = new String[]{'exitCriteriaBooleanFilter','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] exitCriteriaFilterItems_type_info = new String[]{'exitCriteriaFilterItems','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] exitCriteriaFormula_type_info = new String[]{'exitCriteriaFormula','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] isVersionDefault_type_info = new String[]{'isVersionDefault','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] milestones_type_info = new String[]{'milestones','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] versionMaster_type_info = new String[]{'versionMaster','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] versionNotes_type_info = new String[]{'versionNotes','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] versionNumber_type_info = new String[]{'versionNumber','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'active','businessHours','description','entryStartDateField','exitCriteriaBooleanFilter','exitCriteriaFilterItems','exitCriteriaFormula','isVersionDefault','milestones','name','versionMaster','versionNotes','versionNumber'};
    }
    public class FlowRecordDelete extends FlowNode {
        public String type = 'FlowRecordDelete';
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        public String description;
        public String name;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        public String label;
        public Integer locationX;
        public Integer locationY;
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] locationX_type_info = new String[]{'locationX','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] locationY_type_info = new String[]{'locationY','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        public MetadataService.FlowConnector connector;
        public MetadataService.FlowConnector faultConnector;
        public MetadataService.FlowRecordFilter[] filters;
        public String inputReference;
        public String object_x;
        private String[] connector_type_info = new String[]{'connector','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] faultConnector_type_info = new String[]{'faultConnector','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] filters_type_info = new String[]{'filters','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] inputReference_type_info = new String[]{'inputReference','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] object_x_type_info = new String[]{'object','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'processMetadataValues','description','name','label','locationX','locationY', 'connector','faultConnector','filters','inputReference','object_x'};
    }
    public class CustomApplicationComponents {
        public String alignment;
        public String[] customApplicationComponent;
        private String[] alignment_type_info = new String[]{'alignment','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] customApplicationComponent_type_info = new String[]{'customApplicationComponent','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'alignment','customApplicationComponent'};
    }
    public class GlobalQuickActionTranslation {
        public String label;
        public String name;
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'label','name'};
    }
    public class Holiday {
        public Date activityDate;
        public String[] businessHours;
        public String description;
        public DateTime endTime;
        public Boolean isRecurring;
        public String name;
        public Integer recurrenceDayOfMonth;
        public String[] recurrenceDayOfWeek;
        public Integer recurrenceDayOfWeekMask;
        public Date recurrenceEndDate;
        public String recurrenceInstance;
        public Integer recurrenceInterval;
        public String recurrenceMonthOfYear;
        public Date recurrenceStartDate;
        public String recurrenceType;
        public DateTime startTime;
        private String[] activityDate_type_info = new String[]{'activityDate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] businessHours_type_info = new String[]{'businessHours','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] endTime_type_info = new String[]{'endTime','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] isRecurring_type_info = new String[]{'isRecurring','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] recurrenceDayOfMonth_type_info = new String[]{'recurrenceDayOfMonth','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] recurrenceDayOfWeek_type_info = new String[]{'recurrenceDayOfWeek','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] recurrenceDayOfWeekMask_type_info = new String[]{'recurrenceDayOfWeekMask','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] recurrenceEndDate_type_info = new String[]{'recurrenceEndDate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] recurrenceInstance_type_info = new String[]{'recurrenceInstance','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] recurrenceInterval_type_info = new String[]{'recurrenceInterval','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] recurrenceMonthOfYear_type_info = new String[]{'recurrenceMonthOfYear','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] recurrenceStartDate_type_info = new String[]{'recurrenceStartDate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] recurrenceType_type_info = new String[]{'recurrenceType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] startTime_type_info = new String[]{'startTime','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'activityDate','businessHours','description','endTime','isRecurring','name','recurrenceDayOfMonth','recurrenceDayOfWeek','recurrenceDayOfWeekMask','recurrenceEndDate','recurrenceInstance','recurrenceInterval','recurrenceMonthOfYear','recurrenceStartDate','recurrenceType','startTime'};
    }
    public class Layout extends Metadata {
        public String type = 'Layout';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String[] customButtons;
        public MetadataService.CustomConsoleComponents customConsoleComponents;
        public Boolean emailDefault;
        public String[] excludeButtons;
        public MetadataService.FeedLayout feedLayout;
        public String[] headers;
        public MetadataService.LayoutSection[] layoutSections;
        public MetadataService.MiniLayout miniLayout;
        public String[] multilineLayoutFields;
        public MetadataService.PlatformActionList platformActionList;
        public MetadataService.QuickActionList quickActionList;
        public MetadataService.RelatedContent relatedContent;
        public MetadataService.RelatedListItem[] relatedLists;
        public String[] relatedObjects;
        public Boolean runAssignmentRulesDefault;
        public Boolean showEmailCheckbox;
        public Boolean showHighlightsPanel;
        public Boolean showInteractionLogPanel;
        public Boolean showKnowledgeComponent;
        public Boolean showRunAssignmentRulesCheckbox;
        public Boolean showSolutionSection;
        public Boolean showSubmitAndAttachButton;
        public MetadataService.SummaryLayout summaryLayout;
        private String[] customButtons_type_info = new String[]{'customButtons','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] customConsoleComponents_type_info = new String[]{'customConsoleComponents','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] emailDefault_type_info = new String[]{'emailDefault','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] excludeButtons_type_info = new String[]{'excludeButtons','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] feedLayout_type_info = new String[]{'feedLayout','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] headers_type_info = new String[]{'headers','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] layoutSections_type_info = new String[]{'layoutSections','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] miniLayout_type_info = new String[]{'miniLayout','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] multilineLayoutFields_type_info = new String[]{'multilineLayoutFields','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] platformActionList_type_info = new String[]{'platformActionList','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] quickActionList_type_info = new String[]{'quickActionList','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] relatedContent_type_info = new String[]{'relatedContent','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] relatedLists_type_info = new String[]{'relatedLists','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] relatedObjects_type_info = new String[]{'relatedObjects','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] runAssignmentRulesDefault_type_info = new String[]{'runAssignmentRulesDefault','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showEmailCheckbox_type_info = new String[]{'showEmailCheckbox','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showHighlightsPanel_type_info = new String[]{'showHighlightsPanel','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showInteractionLogPanel_type_info = new String[]{'showInteractionLogPanel','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showKnowledgeComponent_type_info = new String[]{'showKnowledgeComponent','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showRunAssignmentRulesCheckbox_type_info = new String[]{'showRunAssignmentRulesCheckbox','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showSolutionSection_type_info = new String[]{'showSolutionSection','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showSubmitAndAttachButton_type_info = new String[]{'showSubmitAndAttachButton','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] summaryLayout_type_info = new String[]{'summaryLayout','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'customButtons','customConsoleComponents','emailDefault','excludeButtons','feedLayout','headers','layoutSections','miniLayout','multilineLayoutFields','platformActionList','quickActionList','relatedContent','relatedLists','relatedObjects','runAssignmentRulesDefault','showEmailCheckbox','showHighlightsPanel','showInteractionLogPanel','showKnowledgeComponent','showRunAssignmentRulesCheckbox','showSolutionSection','showSubmitAndAttachButton','summaryLayout'};
    }
    public class LiveChatButton extends Metadata {
        public String type = 'LiveChatButton';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String animation;
        public String autoGreeting;
        public Integer chasitorIdleTimeout;
        public Integer chasitorIdleTimeoutWarning;
        public String chatPage;
        public String customAgentName;
        public MetadataService.LiveChatButtonDeployments deployments;
        public Boolean enableQueue;
        public String inviteEndPosition;
        public String inviteImage;
        public String inviteStartPosition;
        public Boolean isActive;
        public String label;
        public Integer numberOfReroutingAttempts;
        public String offlineImage;
        public String onlineImage;
        public Boolean optionsCustomRoutingIsEnabled;
        public Boolean optionsHasChasitorIdleTimeout;
        public Boolean optionsHasInviteAfterAccept;
        public Boolean optionsHasInviteAfterReject;
        public Boolean optionsHasRerouteDeclinedRequest;
        public Boolean optionsIsAutoAccept;
        public Boolean optionsIsInviteAutoRemove;
        public Integer overallQueueLength;
        public Integer perAgentQueueLength;
        public String postChatPage;
        public String postChatUrl;
        public String preChatFormPage;
        public String preChatFormUrl;
        public Integer pushTimeOut;
        public String routingType;
        public String site;
        public MetadataService.LiveChatButtonSkills skills;
        public Integer timeToRemoveInvite;
        public String type_x;
        public String windowLanguage;
        private String[] animation_type_info = new String[]{'animation','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] autoGreeting_type_info = new String[]{'autoGreeting','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] chasitorIdleTimeout_type_info = new String[]{'chasitorIdleTimeout','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] chasitorIdleTimeoutWarning_type_info = new String[]{'chasitorIdleTimeoutWarning','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] chatPage_type_info = new String[]{'chatPage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] customAgentName_type_info = new String[]{'customAgentName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] deployments_type_info = new String[]{'deployments','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableQueue_type_info = new String[]{'enableQueue','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] inviteEndPosition_type_info = new String[]{'inviteEndPosition','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] inviteImage_type_info = new String[]{'inviteImage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] inviteStartPosition_type_info = new String[]{'inviteStartPosition','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] isActive_type_info = new String[]{'isActive','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] numberOfReroutingAttempts_type_info = new String[]{'numberOfReroutingAttempts','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] offlineImage_type_info = new String[]{'offlineImage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] onlineImage_type_info = new String[]{'onlineImage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] optionsCustomRoutingIsEnabled_type_info = new String[]{'optionsCustomRoutingIsEnabled','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] optionsHasChasitorIdleTimeout_type_info = new String[]{'optionsHasChasitorIdleTimeout','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] optionsHasInviteAfterAccept_type_info = new String[]{'optionsHasInviteAfterAccept','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] optionsHasInviteAfterReject_type_info = new String[]{'optionsHasInviteAfterReject','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] optionsHasRerouteDeclinedRequest_type_info = new String[]{'optionsHasRerouteDeclinedRequest','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] optionsIsAutoAccept_type_info = new String[]{'optionsIsAutoAccept','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] optionsIsInviteAutoRemove_type_info = new String[]{'optionsIsInviteAutoRemove','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] overallQueueLength_type_info = new String[]{'overallQueueLength','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] perAgentQueueLength_type_info = new String[]{'perAgentQueueLength','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] postChatPage_type_info = new String[]{'postChatPage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] postChatUrl_type_info = new String[]{'postChatUrl','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] preChatFormPage_type_info = new String[]{'preChatFormPage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] preChatFormUrl_type_info = new String[]{'preChatFormUrl','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] pushTimeOut_type_info = new String[]{'pushTimeOut','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] routingType_type_info = new String[]{'routingType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] site_type_info = new String[]{'site','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] skills_type_info = new String[]{'skills','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] timeToRemoveInvite_type_info = new String[]{'timeToRemoveInvite','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] type_x_type_info = new String[]{'type','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] windowLanguage_type_info = new String[]{'windowLanguage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'animation','autoGreeting','chasitorIdleTimeout','chasitorIdleTimeoutWarning','chatPage','customAgentName','deployments','enableQueue','inviteEndPosition','inviteImage','inviteStartPosition','isActive','label','numberOfReroutingAttempts','offlineImage','onlineImage','optionsCustomRoutingIsEnabled','optionsHasChasitorIdleTimeout','optionsHasInviteAfterAccept','optionsHasInviteAfterReject','optionsHasRerouteDeclinedRequest','optionsIsAutoAccept','optionsIsInviteAutoRemove','overallQueueLength','perAgentQueueLength','postChatPage','postChatUrl','preChatFormPage','preChatFormUrl','pushTimeOut','routingType','site','skills','timeToRemoveInvite','type_x','windowLanguage'};
    }
    public class Territory2SettingsOpportunityFilter {
        public String apexClassName;
        public Boolean enableFilter;
        public Boolean runOnCreate;
        private String[] apexClassName_type_info = new String[]{'apexClassName','http://soap.sforce.com/2006/04/metadata',null,'1','1','true'};
        private String[] enableFilter_type_info = new String[]{'enableFilter','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] runOnCreate_type_info = new String[]{'runOnCreate','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'apexClassName','enableFilter','runOnCreate'};
    }
    public class ActivitiesSettings extends Metadata {
        public String type = 'ActivitiesSettings';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Boolean allowUsersToRelateMultipleContactsToTasksAndEvents;
        public Boolean enableActivityReminders;
        public Boolean enableClickCreateEvents;
        public Boolean enableDragAndDropScheduling;
        public Boolean enableEmailTracking;
        public Boolean enableGroupTasks;
        public Boolean enableListViewScheduling;
        public Boolean enableLogNote;
        public Boolean enableMultidayEvents;
        public Boolean enableRecurringEvents;
        public Boolean enableRecurringTasks;
        public Boolean enableSidebarCalendarShortcut;
        public Boolean enableSimpleTaskCreateUI;
        public Boolean enableUNSTaskDelegatedToNotifications;
        public String meetingRequestsLogo;
        public Boolean showCustomLogoMeetingRequests;
        public Boolean showEventDetailsMultiUserCalendar;
        public Boolean showHomePageHoverLinksForEvents;
        public Boolean showMyTasksHoverLinks;
        public Boolean showRequestedMeetingsOnHomePage;
        private String[] allowUsersToRelateMultipleContactsToTasksAndEvents_type_info = new String[]{'allowUsersToRelateMultipleContactsToTasksAndEvents','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableActivityReminders_type_info = new String[]{'enableActivityReminders','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableClickCreateEvents_type_info = new String[]{'enableClickCreateEvents','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableDragAndDropScheduling_type_info = new String[]{'enableDragAndDropScheduling','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableEmailTracking_type_info = new String[]{'enableEmailTracking','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableGroupTasks_type_info = new String[]{'enableGroupTasks','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableListViewScheduling_type_info = new String[]{'enableListViewScheduling','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableLogNote_type_info = new String[]{'enableLogNote','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableMultidayEvents_type_info = new String[]{'enableMultidayEvents','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableRecurringEvents_type_info = new String[]{'enableRecurringEvents','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableRecurringTasks_type_info = new String[]{'enableRecurringTasks','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableSidebarCalendarShortcut_type_info = new String[]{'enableSidebarCalendarShortcut','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableSimpleTaskCreateUI_type_info = new String[]{'enableSimpleTaskCreateUI','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableUNSTaskDelegatedToNotifications_type_info = new String[]{'enableUNSTaskDelegatedToNotifications','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] meetingRequestsLogo_type_info = new String[]{'meetingRequestsLogo','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showCustomLogoMeetingRequests_type_info = new String[]{'showCustomLogoMeetingRequests','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showEventDetailsMultiUserCalendar_type_info = new String[]{'showEventDetailsMultiUserCalendar','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showHomePageHoverLinksForEvents_type_info = new String[]{'showHomePageHoverLinksForEvents','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showMyTasksHoverLinks_type_info = new String[]{'showMyTasksHoverLinks','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showRequestedMeetingsOnHomePage_type_info = new String[]{'showRequestedMeetingsOnHomePage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'allowUsersToRelateMultipleContactsToTasksAndEvents','enableActivityReminders','enableClickCreateEvents','enableDragAndDropScheduling','enableEmailTracking','enableGroupTasks','enableListViewScheduling','enableLogNote','enableMultidayEvents','enableRecurringEvents','enableRecurringTasks','enableSidebarCalendarShortcut','enableSimpleTaskCreateUI','enableUNSTaskDelegatedToNotifications','meetingRequestsLogo','showCustomLogoMeetingRequests','showEventDetailsMultiUserCalendar','showHomePageHoverLinksForEvents','showMyTasksHoverLinks','showRequestedMeetingsOnHomePage'};
    }
    public class FlowWaitEvent extends FlowElement {
        public String type = 'FlowWaitEvent';
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        public String description;
        public String name;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        public String conditionLogic;
        public MetadataService.FlowCondition[] conditions;
        public MetadataService.FlowConnector connector;
        public String eventType;
        public MetadataService.FlowWaitEventInputParameter[] inputParameters;
        public String label;
        public MetadataService.FlowWaitEventOutputParameter[] outputParameters;
        private String[] conditionLogic_type_info = new String[]{'conditionLogic','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] conditions_type_info = new String[]{'conditions','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] connector_type_info = new String[]{'connector','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] eventType_type_info = new String[]{'eventType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] inputParameters_type_info = new String[]{'inputParameters','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] outputParameters_type_info = new String[]{'outputParameters','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'processMetadataValues','description','name', 'conditionLogic','conditions','connector','eventType','inputParameters','label','outputParameters'};
    }
    public class ApexComponent extends MetadataWithContent {
        public String type = 'ApexComponent';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String content;
        private String[] content_type_info = new String[]{'content','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Double apiVersion;
        public String description;
        public String label;
        public MetadataService.PackageVersion[] packageVersions;
        private String[] apiVersion_type_info = new String[]{'apiVersion','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] packageVersions_type_info = new String[]{'packageVersions','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName','content', 'apiVersion','description','label','packageVersions'};
    }
    public class AutoResponseRule extends Metadata {
        public String type = 'AutoResponseRule';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Boolean active;
        public MetadataService.RuleEntry[] ruleEntry;
        private String[] active_type_info = new String[]{'active','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] ruleEntry_type_info = new String[]{'ruleEntry','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'active','ruleEntry'};
    }
    public class NamedCredential extends Metadata {
        public String type = 'NamedCredential';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String authProvider;
        public String certificate;
        public String endpoint;
        public String label;
        public String oauthRefreshToken;
        public String oauthScope;
        public String oauthToken;
        public String password;
        public String principalType;
        public String protocol;
        public String username;
        private String[] authProvider_type_info = new String[]{'authProvider','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] certificate_type_info = new String[]{'certificate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] endpoint_type_info = new String[]{'endpoint','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] oauthRefreshToken_type_info = new String[]{'oauthRefreshToken','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] oauthScope_type_info = new String[]{'oauthScope','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] oauthToken_type_info = new String[]{'oauthToken','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] password_type_info = new String[]{'password','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] principalType_type_info = new String[]{'principalType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] protocol_type_info = new String[]{'protocol','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] username_type_info = new String[]{'username','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'authProvider','certificate','endpoint','label','oauthRefreshToken','oauthScope','oauthToken','password','principalType','protocol','username'};
    }
    public class QuickAction extends Metadata {
        public String type = 'QuickAction';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String canvas;
        public String description;
        public MetadataService.FieldOverride[] fieldOverrides;
        public Integer height;
        public String icon;
        public Boolean isProtected;
        public String label;
        public String page_x;
        public MetadataService.QuickActionLayout quickActionLayout;
        public String standardLabel;
        public String targetObject;
        public String targetParentField;
        public String targetRecordType;
        public String type_x;
        public Integer width;
        private String[] canvas_type_info = new String[]{'canvas','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] fieldOverrides_type_info = new String[]{'fieldOverrides','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] height_type_info = new String[]{'height','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] icon_type_info = new String[]{'icon','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] isProtected_type_info = new String[]{'isProtected','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] page_x_type_info = new String[]{'page','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] quickActionLayout_type_info = new String[]{'quickActionLayout','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] standardLabel_type_info = new String[]{'standardLabel','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] targetObject_type_info = new String[]{'targetObject','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] targetParentField_type_info = new String[]{'targetParentField','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] targetRecordType_type_info = new String[]{'targetRecordType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] type_x_type_info = new String[]{'type','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] width_type_info = new String[]{'width','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'canvas','description','fieldOverrides','height','icon','isProtected','label','page_x','quickActionLayout','standardLabel','targetObject','targetParentField','targetRecordType','type_x','width'};
    }
    public class SharingCriteriaRule extends SharingBaseRule {
        public String type = 'SharingCriteriaRule';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String accessLevel;
        public MetadataService.AccountSharingRuleSettings accountSettings;
        public String description;
        public String label;
        public MetadataService.SharedTo sharedTo;
        private String[] accessLevel_type_info = new String[]{'accessLevel','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] accountSettings_type_info = new String[]{'accountSettings','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] sharedTo_type_info = new String[]{'sharedTo','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        public String booleanFilter;
        public MetadataService.FilterItem[] criteriaItems;
        private String[] booleanFilter_type_info = new String[]{'booleanFilter','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] criteriaItems_type_info = new String[]{'criteriaItems','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName','accessLevel','accountSettings','description','label','sharedTo', 'booleanFilter','criteriaItems'};
    }
    public class FlowAssignment extends FlowNode {
        public String type = 'FlowAssignment';
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        public String description;
        public String name;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        public String label;
        public Integer locationX;
        public Integer locationY;
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] locationX_type_info = new String[]{'locationX','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] locationY_type_info = new String[]{'locationY','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        public MetadataService.FlowAssignmentItem[] assignmentItems;
        public MetadataService.FlowConnector connector;
        private String[] assignmentItems_type_info = new String[]{'assignmentItems','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] connector_type_info = new String[]{'connector','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'processMetadataValues','description','name','label','locationX','locationY', 'assignmentItems','connector'};
    }
    public class MatchingRules extends Metadata {
        public String type = 'MatchingRules';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public MetadataService.MatchingRule[] matchingRules;
        private String[] matchingRules_type_info = new String[]{'matchingRules','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'matchingRules'};
    }
    public class Attachment {
        public String content;
        public String name;
        private String[] content_type_info = new String[]{'content','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'content','name'};
    }
    public class PathAssistantStep {
        public String[] fieldNames;
        public String info;
        public String picklistValueName;
        private String[] fieldNames_type_info = new String[]{'fieldNames','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] info_type_info = new String[]{'info','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] picklistValueName_type_info = new String[]{'picklistValueName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'fieldNames','info','picklistValueName'};
    }
    public class ChannelLayoutItem {
        public String field;
        private String[] field_type_info = new String[]{'field','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'field'};
    }
    public class ListView extends Metadata {
        public String type = 'ListView';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String booleanFilter;
        public String[] columns;
        public String division;
        public String filterScope;
        public MetadataService.ListViewFilter[] filters;
        public String label;
        public String language;
        public String queue;
        public MetadataService.SharedTo sharedTo;
        private String[] booleanFilter_type_info = new String[]{'booleanFilter','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] columns_type_info = new String[]{'columns','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] division_type_info = new String[]{'division','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] filterScope_type_info = new String[]{'filterScope','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] filters_type_info = new String[]{'filters','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] language_type_info = new String[]{'language','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] queue_type_info = new String[]{'queue','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] sharedTo_type_info = new String[]{'sharedTo','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'booleanFilter','columns','division','filterScope','filters','label','language','queue','sharedTo'};
    }
    public class CustomApplicationTranslation {
        public String label;
        public String name;
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'label','name'};
    }
    public class KnowledgeCaseSettings {
        public String articlePDFCreationProfile;
        public MetadataService.KnowledgeCommunitiesSettings articlePublicSharingCommunities;
        public MetadataService.KnowledgeSitesSettings articlePublicSharingSites;
        public MetadataService.KnowledgeSitesSettings articlePublicSharingSitesChatterAnswers;
        public String assignTo;
        public String customizationClass;
        public String defaultContributionArticleType;
        public String editor;
        public Boolean enableArticleCreation;
        public Boolean enableArticlePublicSharingSites;
        public Boolean useProfileForPDFCreation;
        private String[] articlePDFCreationProfile_type_info = new String[]{'articlePDFCreationProfile','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] articlePublicSharingCommunities_type_info = new String[]{'articlePublicSharingCommunities','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] articlePublicSharingSites_type_info = new String[]{'articlePublicSharingSites','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] articlePublicSharingSitesChatterAnswers_type_info = new String[]{'articlePublicSharingSitesChatterAnswers','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] assignTo_type_info = new String[]{'assignTo','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] customizationClass_type_info = new String[]{'customizationClass','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] defaultContributionArticleType_type_info = new String[]{'defaultContributionArticleType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] editor_type_info = new String[]{'editor','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableArticleCreation_type_info = new String[]{'enableArticleCreation','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableArticlePublicSharingSites_type_info = new String[]{'enableArticlePublicSharingSites','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] useProfileForPDFCreation_type_info = new String[]{'useProfileForPDFCreation','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'articlePDFCreationProfile','articlePublicSharingCommunities','articlePublicSharingSites','articlePublicSharingSitesChatterAnswers','assignTo','customizationClass','defaultContributionArticleType','editor','enableArticleCreation','enableArticlePublicSharingSites','useProfileForPDFCreation'};
    }
    public class FiscalYearSettings {
        public String fiscalYearNameBasedOn;
        public String startMonth;
        private String[] fiscalYearNameBasedOn_type_info = new String[]{'fiscalYearNameBasedOn','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] startMonth_type_info = new String[]{'startMonth','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'fiscalYearNameBasedOn','startMonth'};
    }
    public class Approver {
        public String name;
        public String type_x;
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] type_x_type_info = new String[]{'type','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'name','type_x'};
    }
    public class ObjectNameCaseValue {
        public String article;
        public String caseType;
        public Boolean plural;
        public String possessive;
        public String value;
        private String[] article_type_info = new String[]{'article','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] caseType_type_info = new String[]{'caseType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] plural_type_info = new String[]{'plural','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] possessive_type_info = new String[]{'possessive','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] value_type_info = new String[]{'value','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'article','caseType','plural','possessive','value'};
    }
    public class SiteWebAddress {
        public String certificate;
        public String domainName;
        public Boolean primary;
        private String[] certificate_type_info = new String[]{'certificate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] domainName_type_info = new String[]{'domainName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] primary_type_info = new String[]{'primary','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'certificate','domainName','primary'};
    }
    public class FlowInputValidationRule {
        public String errorMessage;
        public String formulaExpression;
        private String[] errorMessage_type_info = new String[]{'errorMessage','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] formulaExpression_type_info = new String[]{'formulaExpression','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'errorMessage','formulaExpression'};
    }
    public class CompanySettings extends Metadata {
        public String type = 'CompanySettings';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public MetadataService.FiscalYearSettings fiscalYear;
        private String[] fiscalYear_type_info = new String[]{'fiscalYear','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'fiscalYear'};
    }
    public class FlowScreenField extends FlowElement {
        public String type = 'FlowScreenField';
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        public String description;
        public String name;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        public String[] choiceReferences;
        public String dataType;
        public String defaultSelectedChoiceReference;
        public MetadataService.FlowElementReferenceOrValue defaultValue;
        public String fieldText;
        public String fieldType;
        public String helpText;
        public Boolean isRequired;
        public Integer scale;
        public MetadataService.FlowInputValidationRule validationRule;
        private String[] choiceReferences_type_info = new String[]{'choiceReferences','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] dataType_type_info = new String[]{'dataType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] defaultSelectedChoiceReference_type_info = new String[]{'defaultSelectedChoiceReference','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] defaultValue_type_info = new String[]{'defaultValue','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] fieldText_type_info = new String[]{'fieldText','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] fieldType_type_info = new String[]{'fieldType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] helpText_type_info = new String[]{'helpText','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] isRequired_type_info = new String[]{'isRequired','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] scale_type_info = new String[]{'scale','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] validationRule_type_info = new String[]{'validationRule','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'processMetadataValues','description','name', 'choiceReferences','dataType','defaultSelectedChoiceReference','defaultValue','fieldText','fieldType','helpText','isRequired','scale','validationRule'};
    }
    public class LookupFilterTranslation {
        public String errorMessage;
        public String informationalMessage;
        private String[] errorMessage_type_info = new String[]{'errorMessage','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] informationalMessage_type_info = new String[]{'informationalMessage','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'errorMessage','informationalMessage'};
    }
    public class LetterheadLine {
        public String color;
        public Integer height;
        private String[] color_type_info = new String[]{'color','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] height_type_info = new String[]{'height','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'color','height'};
    }
    public class ValidationRule extends Metadata {
        public String type = 'ValidationRule';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Boolean active;
        public String description;
        public String errorConditionFormula;
        public String errorDisplayField;
        public String errorMessage;
        private String[] active_type_info = new String[]{'active','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] errorConditionFormula_type_info = new String[]{'errorConditionFormula','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] errorDisplayField_type_info = new String[]{'errorDisplayField','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] errorMessage_type_info = new String[]{'errorMessage','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'active','description','errorConditionFormula','errorDisplayField','errorMessage'};
    }
    public class ChatterAnswersReputationLevel {
        public String name;
        public Integer value;
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] value_type_info = new String[]{'value','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'name','value'};
    }
    public class Role {
        public String parentRole;
        private String[] parentRole_type_info = new String[]{'parentRole','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'parentRole'};
    }
    public class FeedLayoutFilter {
        public String feedFilterName;
        public String feedFilterType;
        public String feedItemType;
        private String[] feedFilterName_type_info = new String[]{'feedFilterName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] feedFilterType_type_info = new String[]{'feedFilterType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] feedItemType_type_info = new String[]{'feedItemType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'feedFilterName','feedFilterType','feedItemType'};
    }
    public virtual class WorkflowAction extends Metadata {
    }
    public class State {
        public Boolean active;
        public String integrationValue;
        public String isoCode;
        public String label;
        public Boolean standard;
        public Boolean visible;
        private String[] active_type_info = new String[]{'active','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] integrationValue_type_info = new String[]{'integrationValue','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] isoCode_type_info = new String[]{'isoCode','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] standard_type_info = new String[]{'standard','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] visible_type_info = new String[]{'visible','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'active','integrationValue','isoCode','label','standard','visible'};
    }
    public class SupervisorAgentConfigSkills {
        public String[] skill;
        private String[] skill_type_info = new String[]{'skill','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'skill'};
    }
    public class describeValueTypeResponse_element {
        public MetadataService.DescribeValueTypeResult result;
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ActionOverride {
        public String actionName;
        public String comment;
        public String content;
        public Boolean skipRecordTypeSelect;
        public String type_x;
        private String[] actionName_type_info = new String[]{'actionName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] comment_type_info = new String[]{'comment','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] content_type_info = new String[]{'content','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] skipRecordTypeSelect_type_info = new String[]{'skipRecordTypeSelect','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] type_x_type_info = new String[]{'type','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'actionName','comment','content','skipRecordTypeSelect','type_x'};
    }
    public class Translations extends Metadata {
        public String type = 'Translations';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public MetadataService.CustomApplicationTranslation[] customApplications;
        public MetadataService.CustomDataTypeTranslation[] customDataTypeTranslations;
        public MetadataService.CustomLabelTranslation[] customLabels;
        public MetadataService.CustomPageWebLinkTranslation[] customPageWebLinks;
        public MetadataService.CustomTabTranslation[] customTabs;
        public MetadataService.GlobalQuickActionTranslation[] quickActions;
        public MetadataService.ReportTypeTranslation[] reportTypes;
        public MetadataService.ScontrolTranslation[] scontrols;
        private String[] customApplications_type_info = new String[]{'customApplications','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] customDataTypeTranslations_type_info = new String[]{'customDataTypeTranslations','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] customLabels_type_info = new String[]{'customLabels','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] customPageWebLinks_type_info = new String[]{'customPageWebLinks','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] customTabs_type_info = new String[]{'customTabs','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] quickActions_type_info = new String[]{'quickActions','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] reportTypes_type_info = new String[]{'reportTypes','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] scontrols_type_info = new String[]{'scontrols','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'customApplications','customDataTypeTranslations','customLabels','customPageWebLinks','customTabs','quickActions','reportTypes','scontrols'};
    }
    public class WebToCaseSettings {
        public String caseOrigin;
        public String defaultResponseTemplate;
        public Boolean enableWebToCase;
        private String[] caseOrigin_type_info = new String[]{'caseOrigin','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] defaultResponseTemplate_type_info = new String[]{'defaultResponseTemplate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableWebToCase_type_info = new String[]{'enableWebToCase','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'caseOrigin','defaultResponseTemplate','enableWebToCase'};
    }
    public class CustomMetadata extends Metadata {
        public String type = 'CustomMetadata';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String description;
        public String label;
        public Boolean protected_x;
        public MetadataService.CustomMetadataValue[] values;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] protected_x_type_info = new String[]{'protected','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] values_type_info = new String[]{'values','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'description','label','protected_x','values'};
    }
    public virtual class FlowNode extends FlowElement {
        public String label;
        public Integer locationX;
        public Integer locationY;
    }
    public class FileProperties {
        public String createdById;
        public String createdByName;
        public DateTime createdDate;
        public String fileName;
        public String fullName;
        public String id;
        public String lastModifiedById;
        public String lastModifiedByName;
        public DateTime lastModifiedDate;
        public String manageableState;
        public String namespacePrefix;
        public String type_x;
        private String[] createdById_type_info = new String[]{'createdById','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] createdByName_type_info = new String[]{'createdByName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] createdDate_type_info = new String[]{'createdDate','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] fileName_type_info = new String[]{'fileName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] id_type_info = new String[]{'id','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] lastModifiedById_type_info = new String[]{'lastModifiedById','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] lastModifiedByName_type_info = new String[]{'lastModifiedByName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] lastModifiedDate_type_info = new String[]{'lastModifiedDate','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] manageableState_type_info = new String[]{'manageableState','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] namespacePrefix_type_info = new String[]{'namespacePrefix','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] type_x_type_info = new String[]{'type','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'createdById','createdByName','createdDate','fileName','fullName','id','lastModifiedById','lastModifiedByName','lastModifiedDate','manageableState','namespacePrefix','type_x'};
    }
    public class OrderSettings extends Metadata {
        public String type = 'OrderSettings';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Boolean enableNegativeQuantity;
        public Boolean enableOrders;
        public Boolean enableReductionOrders;
        private String[] enableNegativeQuantity_type_info = new String[]{'enableNegativeQuantity','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableOrders_type_info = new String[]{'enableOrders','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableReductionOrders_type_info = new String[]{'enableReductionOrders','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'enableNegativeQuantity','enableOrders','enableReductionOrders'};
    }
    public class ReportTimeFrameFilter {
        public String dateColumn;
        public Date endDate;
        public String interval;
        public Date startDate;
        private String[] dateColumn_type_info = new String[]{'dateColumn','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] endDate_type_info = new String[]{'endDate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] interval_type_info = new String[]{'interval','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] startDate_type_info = new String[]{'startDate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'dateColumn','endDate','interval','startDate'};
    }
    public class ProductSettings extends Metadata {
        public String type = 'ProductSettings';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Boolean enableCascadeActivateToRelatedPrices;
        public Boolean enableQuantitySchedule;
        public Boolean enableRevenueSchedule;
        private String[] enableCascadeActivateToRelatedPrices_type_info = new String[]{'enableCascadeActivateToRelatedPrices','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableQuantitySchedule_type_info = new String[]{'enableQuantitySchedule','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableRevenueSchedule_type_info = new String[]{'enableRevenueSchedule','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'enableCascadeActivateToRelatedPrices','enableQuantitySchedule','enableRevenueSchedule'};
    }
    public class WorkflowTask extends WorkflowAction {
        public String type = 'WorkflowTask';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String assignedTo;
        public String assignedToType;
        public String description;
        public Integer dueDateOffset;
        public Boolean notifyAssignee;
        public String offsetFromField;
        public String priority;
        public Boolean protected_x;
        public String status;
        public String subject;
        private String[] assignedTo_type_info = new String[]{'assignedTo','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] assignedToType_type_info = new String[]{'assignedToType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] dueDateOffset_type_info = new String[]{'dueDateOffset','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] notifyAssignee_type_info = new String[]{'notifyAssignee','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] offsetFromField_type_info = new String[]{'offsetFromField','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] priority_type_info = new String[]{'priority','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] protected_x_type_info = new String[]{'protected','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] status_type_info = new String[]{'status','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] subject_type_info = new String[]{'subject','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'assignedTo','assignedToType','description','dueDateOffset','notifyAssignee','offsetFromField','priority','protected_x','status','subject'};
    }
    public class deployResponse_element {
        public MetadataService.AsyncResult result;
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class FeedItemSettings {
        public Integer characterLimit;
        public Boolean collapseThread;
        public String displayFormat;
        public String feedItemType;
        private String[] characterLimit_type_info = new String[]{'characterLimit','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] collapseThread_type_info = new String[]{'collapseThread','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] displayFormat_type_info = new String[]{'displayFormat','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] feedItemType_type_info = new String[]{'feedItemType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'characterLimit','collapseThread','displayFormat','feedItemType'};
    }
    public class AgentConfigAssignments {
        public MetadataService.AgentConfigProfileAssignments profiles;
        public MetadataService.AgentConfigUserAssignments users;
        private String[] profiles_type_info = new String[]{'profiles','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] users_type_info = new String[]{'users','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'profiles','users'};
    }
    public class ApprovalStepApprover {
        public MetadataService.Approver[] approver;
        public String whenMultipleApprovers;
        private String[] approver_type_info = new String[]{'approver','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] whenMultipleApprovers_type_info = new String[]{'whenMultipleApprovers','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'approver','whenMultipleApprovers'};
    }
    public class ApexTrigger extends MetadataWithContent {
        public String type = 'ApexTrigger';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String content;
        private String[] content_type_info = new String[]{'content','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Double apiVersion;
        public MetadataService.PackageVersion[] packageVersions;
        public String status;
        private String[] apiVersion_type_info = new String[]{'apiVersion','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] packageVersions_type_info = new String[]{'packageVersions','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] status_type_info = new String[]{'status','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName','content', 'apiVersion','packageVersions','status'};
    }
    public class CustomConsoleComponents {
        public MetadataService.PrimaryTabComponents primaryTabComponents;
        public MetadataService.SubtabComponents subtabComponents;
        private String[] primaryTabComponents_type_info = new String[]{'primaryTabComponents','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] subtabComponents_type_info = new String[]{'subtabComponents','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'primaryTabComponents','subtabComponents'};
    }
    public class TouchMobileSettings {
        public Boolean enableTouchAppIPad;
        public Boolean enableTouchAppIPhone;
        public Boolean enableTouchBrowserIPad;
        public Boolean enableTouchIosPhone;
        public Boolean enableVisualforceInTouch;
        private String[] enableTouchAppIPad_type_info = new String[]{'enableTouchAppIPad','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableTouchAppIPhone_type_info = new String[]{'enableTouchAppIPhone','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableTouchBrowserIPad_type_info = new String[]{'enableTouchBrowserIPad','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableTouchIosPhone_type_info = new String[]{'enableTouchIosPhone','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableVisualforceInTouch_type_info = new String[]{'enableVisualforceInTouch','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'enableTouchAppIPad','enableTouchAppIPhone','enableTouchBrowserIPad','enableTouchIosPhone','enableVisualforceInTouch'};
    }
    public class AppMenu extends Metadata {
        public String type = 'AppMenu';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public MetadataService.AppMenuItem[] appMenuItems;
        private String[] appMenuItems_type_info = new String[]{'appMenuItems','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'appMenuItems'};
    }
    public class DebuggingInfo_element {
        public String debugLog;
        private String[] debugLog_type_info = new String[]{'debugLog','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'debugLog'};
    }
    public class Report extends Metadata {
        public String type = 'Report';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public MetadataService.ReportAggregate[] aggregates;
        public MetadataService.Report[] block;
        public MetadataService.ReportBlockInfo blockInfo;
        public MetadataService.ReportBucketField[] buckets;
        public MetadataService.ReportChart chart;
        public MetadataService.ReportColorRange[] colorRanges;
        public MetadataService.ReportColumn[] columns;
        public MetadataService.ReportCrossFilter[] crossFilters;
        public String currency_x;
        public MetadataService.ReportDataCategoryFilter[] dataCategoryFilters;
        public String description;
        public String division;
        public MetadataService.ReportFilter filter;
        public String folderName;
        public String format;
        public MetadataService.ReportGrouping[] groupingsAcross;
        public MetadataService.ReportGrouping[] groupingsDown;
        public MetadataService.ReportHistoricalSelector historicalSelector;
        public String name;
        public MetadataService.ReportParam[] params;
        public String reportType;
        public String roleHierarchyFilter;
        public Integer rowLimit;
        public String scope;
        public Boolean showCurrentDate;
        public Boolean showDetails;
        public String sortColumn;
        public String sortOrder;
        public String territoryHierarchyFilter;
        public MetadataService.ReportTimeFrameFilter timeFrameFilter;
        public String userFilter;
        private String[] aggregates_type_info = new String[]{'aggregates','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] block_type_info = new String[]{'block','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] blockInfo_type_info = new String[]{'blockInfo','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] buckets_type_info = new String[]{'buckets','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] chart_type_info = new String[]{'chart','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] colorRanges_type_info = new String[]{'colorRanges','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] columns_type_info = new String[]{'columns','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] crossFilters_type_info = new String[]{'crossFilters','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] currency_x_type_info = new String[]{'currency','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] dataCategoryFilters_type_info = new String[]{'dataCategoryFilters','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] division_type_info = new String[]{'division','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] filter_type_info = new String[]{'filter','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] folderName_type_info = new String[]{'folderName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] format_type_info = new String[]{'format','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] groupingsAcross_type_info = new String[]{'groupingsAcross','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] groupingsDown_type_info = new String[]{'groupingsDown','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] historicalSelector_type_info = new String[]{'historicalSelector','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] params_type_info = new String[]{'params','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] reportType_type_info = new String[]{'reportType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] roleHierarchyFilter_type_info = new String[]{'roleHierarchyFilter','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] rowLimit_type_info = new String[]{'rowLimit','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] scope_type_info = new String[]{'scope','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showCurrentDate_type_info = new String[]{'showCurrentDate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showDetails_type_info = new String[]{'showDetails','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] sortColumn_type_info = new String[]{'sortColumn','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] sortOrder_type_info = new String[]{'sortOrder','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] territoryHierarchyFilter_type_info = new String[]{'territoryHierarchyFilter','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] timeFrameFilter_type_info = new String[]{'timeFrameFilter','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] userFilter_type_info = new String[]{'userFilter','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'aggregates','block','blockInfo','buckets','chart','colorRanges','columns','crossFilters','currency_x','dataCategoryFilters','description','division','filter','folderName','format','groupingsAcross','groupingsDown','historicalSelector','name','params','reportType','roleHierarchyFilter','rowLimit','scope','showCurrentDate','showDetails','sortColumn','sortOrder','territoryHierarchyFilter','timeFrameFilter','userFilter'};
    }
    public class KnowledgeSettings extends Metadata {
        public String type = 'KnowledgeSettings';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public MetadataService.KnowledgeAnswerSettings answers;
        public MetadataService.KnowledgeCaseSettings cases;
        public String defaultLanguage;
        public Boolean enableChatterQuestionKBDeflection;
        public Boolean enableCreateEditOnArticlesTab;
        public Boolean enableExternalMediaContent;
        public Boolean enableKnowledge;
        public MetadataService.KnowledgeLanguageSettings languages;
        public Boolean showArticleSummariesCustomerPortal;
        public Boolean showArticleSummariesInternalApp;
        public Boolean showArticleSummariesPartnerPortal;
        public Boolean showValidationStatusField;
        private String[] answers_type_info = new String[]{'answers','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] cases_type_info = new String[]{'cases','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] defaultLanguage_type_info = new String[]{'defaultLanguage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableChatterQuestionKBDeflection_type_info = new String[]{'enableChatterQuestionKBDeflection','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableCreateEditOnArticlesTab_type_info = new String[]{'enableCreateEditOnArticlesTab','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableExternalMediaContent_type_info = new String[]{'enableExternalMediaContent','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableKnowledge_type_info = new String[]{'enableKnowledge','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] languages_type_info = new String[]{'languages','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showArticleSummariesCustomerPortal_type_info = new String[]{'showArticleSummariesCustomerPortal','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showArticleSummariesInternalApp_type_info = new String[]{'showArticleSummariesInternalApp','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showArticleSummariesPartnerPortal_type_info = new String[]{'showArticleSummariesPartnerPortal','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showValidationStatusField_type_info = new String[]{'showValidationStatusField','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'answers','cases','defaultLanguage','enableChatterQuestionKBDeflection','enableCreateEditOnArticlesTab','enableExternalMediaContent','enableKnowledge','languages','showArticleSummariesCustomerPortal','showArticleSummariesInternalApp','showArticleSummariesPartnerPortal','showValidationStatusField'};
    }
    public class StaticResource extends MetadataWithContent {
        public String type = 'StaticResource';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String content;
        private String[] content_type_info = new String[]{'content','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String cacheControl;
        public String contentType;
        public String description;
        private String[] cacheControl_type_info = new String[]{'cacheControl','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] contentType_type_info = new String[]{'contentType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName','content', 'cacheControl','contentType','description'};
    }
    public class ReportTypeColumn {
        public Boolean checkedByDefault;
        public String displayNameOverride;
        public String field;
        public String table;
        private String[] checkedByDefault_type_info = new String[]{'checkedByDefault','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] displayNameOverride_type_info = new String[]{'displayNameOverride','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] field_type_info = new String[]{'field','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] table_type_info = new String[]{'table','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'checkedByDefault','displayNameOverride','field','table'};
    }
    public class ApprovalStep {
        public Boolean allowDelegate;
        public MetadataService.ApprovalAction approvalActions;
        public MetadataService.ApprovalStepApprover assignedApprover;
        public String description;
        public MetadataService.ApprovalEntryCriteria entryCriteria;
        public String ifCriteriaNotMet;
        public String label;
        public String name;
        public MetadataService.ApprovalStepRejectBehavior rejectBehavior;
        public MetadataService.ApprovalAction rejectionActions;
        private String[] allowDelegate_type_info = new String[]{'allowDelegate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] approvalActions_type_info = new String[]{'approvalActions','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] assignedApprover_type_info = new String[]{'assignedApprover','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] entryCriteria_type_info = new String[]{'entryCriteria','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] ifCriteriaNotMet_type_info = new String[]{'ifCriteriaNotMet','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] rejectBehavior_type_info = new String[]{'rejectBehavior','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] rejectionActions_type_info = new String[]{'rejectionActions','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'allowDelegate','approvalActions','assignedApprover','description','entryCriteria','ifCriteriaNotMet','label','name','rejectBehavior','rejectionActions'};
    }
    public class RecordTypeTranslation {
        public String label;
        public String name;
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'label','name'};
    }
    public class FlowInputFieldAssignment extends FlowBaseElement {
        public String type = 'FlowInputFieldAssignment';
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        public String field;
        public MetadataService.FlowElementReferenceOrValue value;
        private String[] field_type_info = new String[]{'field','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] value_type_info = new String[]{'value','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'processMetadataValues', 'field','value'};
    }
    public class WorkflowActionReference {
        public String name;
        public String type_x;
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] type_x_type_info = new String[]{'type','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'name','type_x'};
    }
    public class FilterItem {
        public String field;
        public String operation;
        public String value;
        public String valueField;
        private String[] field_type_info = new String[]{'field','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] operation_type_info = new String[]{'operation','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] value_type_info = new String[]{'value','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] valueField_type_info = new String[]{'valueField','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'field','operation','value','valueField'};
    }
    public class ReportChartComponentLayoutItem {
        public Boolean cacheData;
        public String contextFilterableField;
        public String error;
        public Boolean hideOnError;
        public Boolean includeContext;
        public String reportName;
        public Boolean showTitle;
        public String size;
        private String[] cacheData_type_info = new String[]{'cacheData','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] contextFilterableField_type_info = new String[]{'contextFilterableField','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] error_type_info = new String[]{'error','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] hideOnError_type_info = new String[]{'hideOnError','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] includeContext_type_info = new String[]{'includeContext','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] reportName_type_info = new String[]{'reportName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] showTitle_type_info = new String[]{'showTitle','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] size_type_info = new String[]{'size','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'cacheData','contextFilterableField','error','hideOnError','includeContext','reportName','showTitle','size'};
    }
    public class ChatterAnswersSettings extends Metadata {
        public String type = 'ChatterAnswersSettings';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Boolean emailFollowersOnBestAnswer;
        public Boolean emailFollowersOnReply;
        public Boolean emailOwnerOnPrivateReply;
        public Boolean emailOwnerOnReply;
        public Boolean enableAnswerViaEmail;
        public Boolean enableChatterAnswers;
        public Boolean enableFacebookSSO;
        public Boolean enableInlinePublisher;
        public Boolean enableReputation;
        public Boolean enableRichTextEditor;
        public String facebookAuthProvider;
        public Boolean showInPortals;
        private String[] emailFollowersOnBestAnswer_type_info = new String[]{'emailFollowersOnBestAnswer','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] emailFollowersOnReply_type_info = new String[]{'emailFollowersOnReply','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] emailOwnerOnPrivateReply_type_info = new String[]{'emailOwnerOnPrivateReply','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] emailOwnerOnReply_type_info = new String[]{'emailOwnerOnReply','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableAnswerViaEmail_type_info = new String[]{'enableAnswerViaEmail','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableChatterAnswers_type_info = new String[]{'enableChatterAnswers','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] enableFacebookSSO_type_info = new String[]{'enableFacebookSSO','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableInlinePublisher_type_info = new String[]{'enableInlinePublisher','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableReputation_type_info = new String[]{'enableReputation','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableRichTextEditor_type_info = new String[]{'enableRichTextEditor','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] facebookAuthProvider_type_info = new String[]{'facebookAuthProvider','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showInPortals_type_info = new String[]{'showInPortals','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'emailFollowersOnBestAnswer','emailFollowersOnReply','emailOwnerOnPrivateReply','emailOwnerOnReply','enableAnswerViaEmail','enableChatterAnswers','enableFacebookSSO','enableInlinePublisher','enableReputation','enableRichTextEditor','facebookAuthProvider','showInPortals'};
    }
    public class ConnectedAppCanvasConfig {
        public String accessMethod;
        public String canvasUrl;
        public String lifecycleClass;
        public String[] locations;
        public String[] options;
        public String samlInitiationMethod;
        private String[] accessMethod_type_info = new String[]{'accessMethod','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] canvasUrl_type_info = new String[]{'canvasUrl','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] lifecycleClass_type_info = new String[]{'lifecycleClass','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] locations_type_info = new String[]{'locations','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] options_type_info = new String[]{'options','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] samlInitiationMethod_type_info = new String[]{'samlInitiationMethod','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'accessMethod','canvasUrl','lifecycleClass','locations','options','samlInitiationMethod'};
    }
    public class QuotasSettings {
        public Boolean showQuotas;
        private String[] showQuotas_type_info = new String[]{'showQuotas','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'showQuotas'};
    }
    public class Community extends Metadata {
        public String type = 'Community';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Boolean active;
        public String communityFeedPage;
        public String description;
        public String emailFooterDocument;
        public String emailHeaderDocument;
        public String emailNotificationUrl;
        public Boolean enableChatterAnswers;
        public Boolean enablePrivateQuestions;
        public String expertsGroup;
        public String portal;
        public MetadataService.ReputationLevels reputationLevels;
        public Boolean showInPortal;
        public String site;
        private String[] active_type_info = new String[]{'active','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] communityFeedPage_type_info = new String[]{'communityFeedPage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] emailFooterDocument_type_info = new String[]{'emailFooterDocument','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] emailHeaderDocument_type_info = new String[]{'emailHeaderDocument','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] emailNotificationUrl_type_info = new String[]{'emailNotificationUrl','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableChatterAnswers_type_info = new String[]{'enableChatterAnswers','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enablePrivateQuestions_type_info = new String[]{'enablePrivateQuestions','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] expertsGroup_type_info = new String[]{'expertsGroup','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] portal_type_info = new String[]{'portal','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] reputationLevels_type_info = new String[]{'reputationLevels','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showInPortal_type_info = new String[]{'showInPortal','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] site_type_info = new String[]{'site','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'active','communityFeedPage','description','emailFooterDocument','emailHeaderDocument','emailNotificationUrl','enableChatterAnswers','enablePrivateQuestions','expertsGroup','portal','reputationLevels','showInPortal','site'};
    }
    public class BusinessProcess extends Metadata {
        public String type = 'BusinessProcess';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String description;
        public Boolean isActive;
        public MetadataService.PicklistValue[] values;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] isActive_type_info = new String[]{'isActive','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] values_type_info = new String[]{'values','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'description','isActive','values'};
    }
    public class EmailToCaseRoutingAddress {
        public String addressType;
        public String authorizedSenders;
        public String caseOrigin;
        public String caseOwner;
        public String caseOwnerType;
        public String casePriority;
        public Boolean createTask;
        public String emailAddress;
        public String routingName;
        public Boolean saveEmailHeaders;
        public String taskStatus;
        private String[] addressType_type_info = new String[]{'addressType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] authorizedSenders_type_info = new String[]{'authorizedSenders','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] caseOrigin_type_info = new String[]{'caseOrigin','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] caseOwner_type_info = new String[]{'caseOwner','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] caseOwnerType_type_info = new String[]{'caseOwnerType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] casePriority_type_info = new String[]{'casePriority','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] createTask_type_info = new String[]{'createTask','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] emailAddress_type_info = new String[]{'emailAddress','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] routingName_type_info = new String[]{'routingName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] saveEmailHeaders_type_info = new String[]{'saveEmailHeaders','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] taskStatus_type_info = new String[]{'taskStatus','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'addressType','authorizedSenders','caseOrigin','caseOwner','caseOwnerType','casePriority','createTask','emailAddress','routingName','saveEmailHeaders','taskStatus'};
    }
    public class DataCategory {
        public MetadataService.DataCategory[] dataCategory;
        public String label;
        public String name;
        private String[] dataCategory_type_info = new String[]{'dataCategory','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'dataCategory','label','name'};
    }
    public class PermissionSetTabSetting {
        public String tab;
        public String visibility;
        private String[] tab_type_info = new String[]{'tab','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] visibility_type_info = new String[]{'visibility','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'tab','visibility'};
    }
    public class ReportHistoricalSelector {
        public String[] snapshot;
        private String[] snapshot_type_info = new String[]{'snapshot','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'snapshot'};
    }
    public class PermissionSetUserPermission {
        public Boolean enabled;
        public String name;
        private String[] enabled_type_info = new String[]{'enabled','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'enabled','name'};
    }
    public class SharingRules extends Metadata {
        public String type = 'SharingRules';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public MetadataService.SharingCriteriaRule[] sharingCriteriaRules;
        public MetadataService.SharingOwnerRule[] sharingOwnerRules;
        public MetadataService.SharingTerritoryRule[] sharingTerritoryRules;
        private String[] sharingCriteriaRules_type_info = new String[]{'sharingCriteriaRules','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] sharingOwnerRules_type_info = new String[]{'sharingOwnerRules','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] sharingTerritoryRules_type_info = new String[]{'sharingTerritoryRules','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'sharingCriteriaRules','sharingOwnerRules','sharingTerritoryRules'};
    }
    public class SharingRecalculation {
        public String className;
        private String[] className_type_info = new String[]{'className','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'className'};
    }
    public class CustomLabels extends Metadata {
        public String type = 'CustomLabels';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public MetadataService.CustomLabel[] labels;
        private String[] labels_type_info = new String[]{'labels','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'labels'};
    }
    public class RelatedContentItem {
        public MetadataService.LayoutItem layoutItem;
        private String[] layoutItem_type_info = new String[]{'layoutItem','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'layoutItem'};
    }
    public class LiveAgentConfig {
        public Boolean enableLiveChat;
        public Boolean openNewAccountSubtab;
        public Boolean openNewCaseSubtab;
        public Boolean openNewContactSubtab;
        public Boolean openNewLeadSubtab;
        public Boolean openNewVFPageSubtab;
        public MetadataService.PagesToOpen pagesToOpen;
        public Boolean showKnowledgeArticles;
        private String[] enableLiveChat_type_info = new String[]{'enableLiveChat','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] openNewAccountSubtab_type_info = new String[]{'openNewAccountSubtab','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] openNewCaseSubtab_type_info = new String[]{'openNewCaseSubtab','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] openNewContactSubtab_type_info = new String[]{'openNewContactSubtab','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] openNewLeadSubtab_type_info = new String[]{'openNewLeadSubtab','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] openNewVFPageSubtab_type_info = new String[]{'openNewVFPageSubtab','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] pagesToOpen_type_info = new String[]{'pagesToOpen','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showKnowledgeArticles_type_info = new String[]{'showKnowledgeArticles','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'enableLiveChat','openNewAccountSubtab','openNewCaseSubtab','openNewContactSubtab','openNewLeadSubtab','openNewVFPageSubtab','pagesToOpen','showKnowledgeArticles'};
    }
    public class RunTestsResult {
        public String apexLogId;
        public MetadataService.CodeCoverageResult[] codeCoverage;
        public MetadataService.CodeCoverageWarning[] codeCoverageWarnings;
        public MetadataService.RunTestFailure[] failures;
        public Integer numFailures;
        public Integer numTestsRun;
        public MetadataService.RunTestSuccess[] successes;
        public Double totalTime;
        private String[] apexLogId_type_info = new String[]{'apexLogId','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] codeCoverage_type_info = new String[]{'codeCoverage','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] codeCoverageWarnings_type_info = new String[]{'codeCoverageWarnings','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] failures_type_info = new String[]{'failures','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] numFailures_type_info = new String[]{'numFailures','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] numTestsRun_type_info = new String[]{'numTestsRun','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] successes_type_info = new String[]{'successes','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] totalTime_type_info = new String[]{'totalTime','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'apexLogId','codeCoverage','codeCoverageWarnings','failures','numFailures','numTestsRun','successes','totalTime'};
    }
    public class LicenseDefinition extends Metadata {
        public String type = 'LicenseDefinition';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String aggregationGroup;
        public String description;
        public Boolean isPublished;
        public String label;
        public MetadataService.LicensedCustomPermissions[] licensedCustomPermissions;
        public String licensingAuthority;
        public String licensingAuthorityProvider;
        public Integer minPlatformVersion;
        public String origin;
        public Integer revision;
        public Integer trialLicenseDuration;
        public Integer trialLicenseQuantity;
        private String[] aggregationGroup_type_info = new String[]{'aggregationGroup','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] isPublished_type_info = new String[]{'isPublished','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] licensedCustomPermissions_type_info = new String[]{'licensedCustomPermissions','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] licensingAuthority_type_info = new String[]{'licensingAuthority','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] licensingAuthorityProvider_type_info = new String[]{'licensingAuthorityProvider','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] minPlatformVersion_type_info = new String[]{'minPlatformVersion','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] origin_type_info = new String[]{'origin','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] revision_type_info = new String[]{'revision','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] trialLicenseDuration_type_info = new String[]{'trialLicenseDuration','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] trialLicenseQuantity_type_info = new String[]{'trialLicenseQuantity','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'aggregationGroup','description','isPublished','label','licensedCustomPermissions','licensingAuthority','licensingAuthorityProvider','minPlatformVersion','origin','revision','trialLicenseDuration','trialLicenseQuantity'};
    }
    public class FlowOutputFieldAssignment extends FlowBaseElement {
        public String type = 'FlowOutputFieldAssignment';
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        public String assignToReference;
        public String field;
        private String[] assignToReference_type_info = new String[]{'assignToReference','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] field_type_info = new String[]{'field','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'processMetadataValues', 'assignToReference','field'};
    }
    public class FlowApexPluginCallOutputParameter extends FlowBaseElement {
        public String type = 'FlowApexPluginCallOutputParameter';
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        public String assignToReference;
        public String name;
        private String[] assignToReference_type_info = new String[]{'assignToReference','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'processMetadataValues', 'assignToReference','name'};
    }
    public class DashboardGridLayout {
        public MetadataService.DashboardGridComponent[] dashboardGridComponents;
        public Integer numberOfColumns;
        public Integer rowHeight;
        private String[] dashboardGridComponents_type_info = new String[]{'dashboardGridComponents','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] numberOfColumns_type_info = new String[]{'numberOfColumns','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] rowHeight_type_info = new String[]{'rowHeight','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'dashboardGridComponents','numberOfColumns','rowHeight'};
    }
    public class AdjustmentsSettings {
        public Boolean enableAdjustments;
        public Boolean enableOwnerAdjustments;
        private String[] enableAdjustments_type_info = new String[]{'enableAdjustments','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] enableOwnerAdjustments_type_info = new String[]{'enableOwnerAdjustments','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'enableAdjustments','enableOwnerAdjustments'};
    }
    public class SummaryLayoutItem {
        public String customLink;
        public String field;
        public Integer posX;
        public Integer posY;
        public Integer posZ;
        private String[] customLink_type_info = new String[]{'customLink','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] field_type_info = new String[]{'field','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] posX_type_info = new String[]{'posX','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] posY_type_info = new String[]{'posY','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] posZ_type_info = new String[]{'posZ','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'customLink','field','posX','posY','posZ'};
    }
    public class QuickActionLayoutItem {
        public Boolean emptySpace;
        public String field;
        public String uiBehavior;
        private String[] emptySpace_type_info = new String[]{'emptySpace','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] field_type_info = new String[]{'field','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] uiBehavior_type_info = new String[]{'uiBehavior','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'emptySpace','field','uiBehavior'};
    }
    public class DeployDetails {
        public MetadataService.DeployMessage[] componentFailures;
        public MetadataService.DeployMessage[] componentSuccesses;
        public MetadataService.RetrieveResult retrieveResult;
        public MetadataService.RunTestsResult runTestResult;
        private String[] componentFailures_type_info = new String[]{'componentFailures','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] componentSuccesses_type_info = new String[]{'componentSuccesses','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] retrieveResult_type_info = new String[]{'retrieveResult','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] runTestResult_type_info = new String[]{'runTestResult','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'componentFailures','componentSuccesses','retrieveResult','runTestResult'};
    }
    public class FlexiPage extends Metadata {
        public String type = 'FlexiPage';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String description;
        public MetadataService.FlexiPageRegion[] flexiPageRegions;
        public String masterLabel;
        public String pageTemplate;
        public String parentFlexiPage;
        public MetadataService.PlatformActionList platformActionlist;
        public MetadataService.QuickActionList quickActionList;
        public String sobjectType;
        public String type_x;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] flexiPageRegions_type_info = new String[]{'flexiPageRegions','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] masterLabel_type_info = new String[]{'masterLabel','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] pageTemplate_type_info = new String[]{'pageTemplate','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] parentFlexiPage_type_info = new String[]{'parentFlexiPage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] platformActionlist_type_info = new String[]{'platformActionlist','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] quickActionList_type_info = new String[]{'quickActionList','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] sobjectType_type_info = new String[]{'sobjectType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] type_x_type_info = new String[]{'type','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'description','flexiPageRegions','masterLabel','pageTemplate','parentFlexiPage','platformActionlist','quickActionList','sobjectType','type_x'};
    }
    public class EntitlementProcessMilestoneTimeTrigger {
        public MetadataService.WorkflowActionReference[] actions;
        public Integer timeLength;
        public String workflowTimeTriggerUnit;
        private String[] actions_type_info = new String[]{'actions','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] timeLength_type_info = new String[]{'timeLength','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] workflowTimeTriggerUnit_type_info = new String[]{'workflowTimeTriggerUnit','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'actions','timeLength','workflowTimeTriggerUnit'};
    }
    public class CallCenter extends Metadata {
        public String type = 'CallCenter';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String adapterUrl;
        public String customSettings;
        public String displayName;
        public String displayNameLabel;
        public String internalNameLabel;
        public MetadataService.CallCenterSection[] sections;
        public String version;
        private String[] adapterUrl_type_info = new String[]{'adapterUrl','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] customSettings_type_info = new String[]{'customSettings','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] displayName_type_info = new String[]{'displayName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] displayNameLabel_type_info = new String[]{'displayNameLabel','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] internalNameLabel_type_info = new String[]{'internalNameLabel','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] sections_type_info = new String[]{'sections','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] version_type_info = new String[]{'version','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'adapterUrl','customSettings','displayName','displayNameLabel','internalNameLabel','sections','version'};
    }
    public class PlatformActionList {
        public String actionListContext;
        public MetadataService.PlatformActionListItem[] platformActionListItems;
        public String relatedSourceEntity;
        private String[] actionListContext_type_info = new String[]{'actionListContext','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] platformActionListItems_type_info = new String[]{'platformActionListItems','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] relatedSourceEntity_type_info = new String[]{'relatedSourceEntity','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'actionListContext','platformActionListItems','relatedSourceEntity'};
    }
    public class MarketingActionSettings extends Metadata {
        public String type = 'MarketingActionSettings';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Boolean enableMarketingAction;
        private String[] enableMarketingAction_type_info = new String[]{'enableMarketingAction','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'enableMarketingAction'};
    }
    public class AccountSharingRuleSettings {
        public String caseAccessLevel;
        public String contactAccessLevel;
        public String opportunityAccessLevel;
        private String[] caseAccessLevel_type_info = new String[]{'caseAccessLevel','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] contactAccessLevel_type_info = new String[]{'contactAccessLevel','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] opportunityAccessLevel_type_info = new String[]{'opportunityAccessLevel','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'caseAccessLevel','contactAccessLevel','opportunityAccessLevel'};
    }
    public class AgentConfigButtons {
        public String[] button;
        private String[] button_type_info = new String[]{'button','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'button'};
    }
    public class CustomShortcut {
        public String description;
        public String eventName;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] eventName_type_info = new String[]{'eventName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'description','eventName'};
    }
    public class ArticleTypeChannelDisplay {
        public MetadataService.ArticleTypeTemplate[] articleTypeTemplates;
        private String[] articleTypeTemplates_type_info = new String[]{'articleTypeTemplates','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'articleTypeTemplates'};
    }
    public class FlowWaitEventInputParameter extends FlowBaseElement {
        public String type = 'FlowWaitEventInputParameter';
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        public String name;
        public MetadataService.FlowElementReferenceOrValue value;
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] value_type_info = new String[]{'value','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'processMetadataValues', 'name','value'};
    }
    public class WorkflowOutboundMessage extends WorkflowAction {
        public String type = 'WorkflowOutboundMessage';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Double apiVersion;
        public String description;
        public String endpointUrl;
        public String[] fields;
        public Boolean includeSessionId;
        public String integrationUser;
        public String name;
        public Boolean protected_x;
        public Boolean useDeadLetterQueue;
        private String[] apiVersion_type_info = new String[]{'apiVersion','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] endpointUrl_type_info = new String[]{'endpointUrl','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] fields_type_info = new String[]{'fields','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] includeSessionId_type_info = new String[]{'includeSessionId','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] integrationUser_type_info = new String[]{'integrationUser','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] protected_x_type_info = new String[]{'protected','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] useDeadLetterQueue_type_info = new String[]{'useDeadLetterQueue','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'apiVersion','description','endpointUrl','fields','includeSessionId','integrationUser','name','protected_x','useDeadLetterQueue'};
    }
    public class CorsWhitelistOrigin extends Metadata {
        public String type = 'CorsWhitelistOrigin';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String urlPattern;
        private String[] urlPattern_type_info = new String[]{'urlPattern','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'urlPattern'};
    }
    public class SessionHeader_element {
        public String sessionId;
        private String[] sessionId_type_info = new String[]{'sessionId','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'sessionId'};
    }
    public class AnalyticSnapshot extends Metadata {
        public String type = 'AnalyticSnapshot';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String description;
        public String groupColumn;
        public MetadataService.AnalyticSnapshotMapping[] mappings;
        public String name;
        public String runningUser;
        public String sourceReport;
        public String targetObject;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] groupColumn_type_info = new String[]{'groupColumn','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] mappings_type_info = new String[]{'mappings','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] runningUser_type_info = new String[]{'runningUser','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] sourceReport_type_info = new String[]{'sourceReport','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] targetObject_type_info = new String[]{'targetObject','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'description','groupColumn','mappings','name','runningUser','sourceReport','targetObject'};
    }
    public virtual class FlowElement extends FlowBaseElement {
        public String description;
        public String name;
    }
    public class ReputationPointsRules {
        public MetadataService.ReputationPointsRule[] pointsRule;
        private String[] pointsRule_type_info = new String[]{'pointsRule','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'pointsRule'};
    }
    public class ProfileCustomPermissions {
        public Boolean enabled;
        public String name;
        private String[] enabled_type_info = new String[]{'enabled','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'enabled','name'};
    }
    public class deployRecentValidationResponse_element {
        public String result;
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class IpRange {
        public String description;
        public String end_x;
        public String start;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] end_x_type_info = new String[]{'end','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] start_type_info = new String[]{'start','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'description','end_x','start'};
    }
    public class deployRecentValidation_element {
        public String validationId;
        private String[] validationId_type_info = new String[]{'validationId','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'validationId'};
    }
    public class ManagedTopics extends Metadata {
        public String type = 'ManagedTopics';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public MetadataService.ManagedTopic[] managedTopic;
        private String[] managedTopic_type_info = new String[]{'managedTopic','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'managedTopic'};
    }
    public class FeedFilterCriterion {
        public String feedItemType;
        public String feedItemVisibility;
        public String relatedSObjectType;
        private String[] feedItemType_type_info = new String[]{'feedItemType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] feedItemVisibility_type_info = new String[]{'feedItemVisibility','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] relatedSObjectType_type_info = new String[]{'relatedSObjectType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'feedItemType','feedItemVisibility','relatedSObjectType'};
    }
    public class ReportBlockInfo {
        public MetadataService.ReportAggregateReference[] aggregateReferences;
        public String blockId;
        public String joinTable;
        private String[] aggregateReferences_type_info = new String[]{'aggregateReferences','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] blockId_type_info = new String[]{'blockId','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] joinTable_type_info = new String[]{'joinTable','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'aggregateReferences','blockId','joinTable'};
    }
    public virtual class Folder extends Metadata {
        public String accessType;
        public MetadataService.FolderShare[] folderShares;
        public String name;
        public String publicFolderAccess;
        public MetadataService.SharedTo sharedTo;
    }
    public class Branding {
        public String loginFooterText;
        public String loginLogo;
        public String pageFooter;
        public String pageHeader;
        public String primaryColor;
        public String primaryComplementColor;
        public String quaternaryColor;
        public String quaternaryComplementColor;
        public String secondaryColor;
        public String tertiaryColor;
        public String tertiaryComplementColor;
        public String zeronaryColor;
        public String zeronaryComplementColor;
        private String[] loginFooterText_type_info = new String[]{'loginFooterText','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] loginLogo_type_info = new String[]{'loginLogo','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] pageFooter_type_info = new String[]{'pageFooter','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] pageHeader_type_info = new String[]{'pageHeader','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] primaryColor_type_info = new String[]{'primaryColor','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] primaryComplementColor_type_info = new String[]{'primaryComplementColor','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] quaternaryColor_type_info = new String[]{'quaternaryColor','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] quaternaryComplementColor_type_info = new String[]{'quaternaryComplementColor','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] secondaryColor_type_info = new String[]{'secondaryColor','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] tertiaryColor_type_info = new String[]{'tertiaryColor','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] tertiaryComplementColor_type_info = new String[]{'tertiaryComplementColor','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] zeronaryColor_type_info = new String[]{'zeronaryColor','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] zeronaryComplementColor_type_info = new String[]{'zeronaryComplementColor','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'loginFooterText','loginLogo','pageFooter','pageHeader','primaryColor','primaryComplementColor','quaternaryColor','quaternaryComplementColor','secondaryColor','tertiaryColor','tertiaryComplementColor','zeronaryColor','zeronaryComplementColor'};
    }
    public class Profile extends Metadata {
        public String type = 'Profile';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public MetadataService.ProfileApplicationVisibility[] applicationVisibilities;
        public MetadataService.ProfileApexClassAccess[] classAccesses;
        public Boolean custom;
        public MetadataService.ProfileCustomPermissions[] customPermissions;
        public String description;
        public MetadataService.ProfileExternalDataSourceAccess[] externalDataSourceAccesses;
        public MetadataService.ProfileFieldLevelSecurity[] fieldPermissions;
        public MetadataService.ProfileLayoutAssignment[] layoutAssignments;
        public MetadataService.ProfileLoginHours loginHours;
        public MetadataService.ProfileLoginIpRange[] loginIpRanges;
        public MetadataService.ProfileObjectPermissions[] objectPermissions;
        public MetadataService.ProfileApexPageAccess[] pageAccesses;
        public MetadataService.ProfileRecordTypeVisibility[] recordTypeVisibilities;
        public MetadataService.ProfileTabVisibility[] tabVisibilities;
        public String userLicense;
        public MetadataService.ProfileUserPermission[] userPermissions;
        private String[] applicationVisibilities_type_info = new String[]{'applicationVisibilities','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] classAccesses_type_info = new String[]{'classAccesses','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] custom_type_info = new String[]{'custom','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] customPermissions_type_info = new String[]{'customPermissions','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] externalDataSourceAccesses_type_info = new String[]{'externalDataSourceAccesses','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] fieldPermissions_type_info = new String[]{'fieldPermissions','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] layoutAssignments_type_info = new String[]{'layoutAssignments','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] loginHours_type_info = new String[]{'loginHours','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] loginIpRanges_type_info = new String[]{'loginIpRanges','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] objectPermissions_type_info = new String[]{'objectPermissions','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] pageAccesses_type_info = new String[]{'pageAccesses','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] recordTypeVisibilities_type_info = new String[]{'recordTypeVisibilities','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] tabVisibilities_type_info = new String[]{'tabVisibilities','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] userLicense_type_info = new String[]{'userLicense','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] userPermissions_type_info = new String[]{'userPermissions','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'applicationVisibilities','classAccesses','custom','customPermissions','description','externalDataSourceAccesses','fieldPermissions','layoutAssignments','loginHours','loginIpRanges','objectPermissions','pageAccesses','recordTypeVisibilities','tabVisibilities','userLicense','userPermissions'};
    }
    public class KnowledgeLanguage {
        public Boolean active;
        public String defaultAssignee;
        public String defaultAssigneeType;
        public String defaultReviewer;
        public String defaultReviewerType;
        public String name;
        private String[] active_type_info = new String[]{'active','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] defaultAssignee_type_info = new String[]{'defaultAssignee','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] defaultAssigneeType_type_info = new String[]{'defaultAssigneeType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] defaultReviewer_type_info = new String[]{'defaultReviewer','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] defaultReviewerType_type_info = new String[]{'defaultReviewerType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'active','defaultAssignee','defaultAssigneeType','defaultReviewer','defaultReviewerType','name'};
    }
    public class DeployOptions {
        public Boolean allowMissingFiles;
        public Boolean autoUpdatePackage;
        public Boolean checkOnly;
        public Boolean ignoreWarnings;
        public Boolean performRetrieve;
        public Boolean purgeOnDelete;
        public Boolean rollbackOnError;
        public String[] runTests;
        public Boolean singlePackage;
        public String testLevel;
        private String[] allowMissingFiles_type_info = new String[]{'allowMissingFiles','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] autoUpdatePackage_type_info = new String[]{'autoUpdatePackage','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] checkOnly_type_info = new String[]{'checkOnly','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] ignoreWarnings_type_info = new String[]{'ignoreWarnings','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] performRetrieve_type_info = new String[]{'performRetrieve','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] purgeOnDelete_type_info = new String[]{'purgeOnDelete','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] rollbackOnError_type_info = new String[]{'rollbackOnError','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] runTests_type_info = new String[]{'runTests','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] singlePackage_type_info = new String[]{'singlePackage','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] testLevel_type_info = new String[]{'testLevel','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'allowMissingFiles','autoUpdatePackage','checkOnly','ignoreWarnings','performRetrieve','purgeOnDelete','rollbackOnError','runTests','singlePackage','testLevel'};
    }
    public class FieldSet extends Metadata {
        public String type = 'FieldSet';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public MetadataService.FieldSetItem[] availableFields;
        public String description;
        public MetadataService.FieldSetItem[] displayedFields;
        public String label;
        private String[] availableFields_type_info = new String[]{'availableFields','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] displayedFields_type_info = new String[]{'displayedFields','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'availableFields','description','displayedFields','label'};
    }
    public class ProfileLoginHours {
        public String fridayEnd;
        public String fridayStart;
        public String mondayEnd;
        public String mondayStart;
        public String saturdayEnd;
        public String saturdayStart;
        public String sundayEnd;
        public String sundayStart;
        public String thursdayEnd;
        public String thursdayStart;
        public String tuesdayEnd;
        public String tuesdayStart;
        public String wednesdayEnd;
        public String wednesdayStart;
        private String[] fridayEnd_type_info = new String[]{'fridayEnd','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] fridayStart_type_info = new String[]{'fridayStart','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] mondayEnd_type_info = new String[]{'mondayEnd','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] mondayStart_type_info = new String[]{'mondayStart','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] saturdayEnd_type_info = new String[]{'saturdayEnd','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] saturdayStart_type_info = new String[]{'saturdayStart','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] sundayEnd_type_info = new String[]{'sundayEnd','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] sundayStart_type_info = new String[]{'sundayStart','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] thursdayEnd_type_info = new String[]{'thursdayEnd','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] thursdayStart_type_info = new String[]{'thursdayStart','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] tuesdayEnd_type_info = new String[]{'tuesdayEnd','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] tuesdayStart_type_info = new String[]{'tuesdayStart','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] wednesdayEnd_type_info = new String[]{'wednesdayEnd','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] wednesdayStart_type_info = new String[]{'wednesdayStart','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'fridayEnd','fridayStart','mondayEnd','mondayStart','saturdayEnd','saturdayStart','sundayEnd','sundayStart','thursdayEnd','thursdayStart','tuesdayEnd','tuesdayStart','wednesdayEnd','wednesdayStart'};
    }
    public class FlowChoiceUserInput extends FlowBaseElement {
        public String type = 'FlowChoiceUserInput';
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        public Boolean isRequired;
        public String promptText;
        public MetadataService.FlowInputValidationRule validationRule;
        private String[] isRequired_type_info = new String[]{'isRequired','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] promptText_type_info = new String[]{'promptText','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] validationRule_type_info = new String[]{'validationRule','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'processMetadataValues', 'isRequired','promptText','validationRule'};
    }
    public class HomePageComponent extends Metadata {
        public String type = 'HomePageComponent';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String body;
        public Integer height;
        public String[] links;
        public String page_x;
        public String pageComponentType;
        public Boolean showLabel;
        public Boolean showScrollbars;
        public String width;
        private String[] body_type_info = new String[]{'body','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] height_type_info = new String[]{'height','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] links_type_info = new String[]{'links','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] page_x_type_info = new String[]{'page','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] pageComponentType_type_info = new String[]{'pageComponentType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] showLabel_type_info = new String[]{'showLabel','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showScrollbars_type_info = new String[]{'showScrollbars','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] width_type_info = new String[]{'width','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'body','height','links','page_x','pageComponentType','showLabel','showScrollbars','width'};
    }
    public class PermissionSetFieldPermissions {
        public Boolean editable;
        public String field;
        public Boolean readable;
        private String[] editable_type_info = new String[]{'editable','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] field_type_info = new String[]{'field','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] readable_type_info = new String[]{'readable','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'editable','field','readable'};
    }
    public class RetrieveRequest {
        public Double apiVersion;
        public String[] packageNames;
        public Boolean singlePackage;
        public String[] specificFiles;
        public MetadataService.Package_x unpackaged;
        private String[] apiVersion_type_info = new String[]{'apiVersion','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] packageNames_type_info = new String[]{'packageNames','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] singlePackage_type_info = new String[]{'singlePackage','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] specificFiles_type_info = new String[]{'specificFiles','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] unpackaged_type_info = new String[]{'unpackaged','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'apiVersion','packageNames','singlePackage','specificFiles','unpackaged'};
    }
    public class ObjectRelationship {
        public MetadataService.ObjectRelationship join_x;
        public Boolean outerJoin;
        public String relationship;
        private String[] join_x_type_info = new String[]{'join','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] outerJoin_type_info = new String[]{'outerJoin','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] relationship_type_info = new String[]{'relationship','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'join_x','outerJoin','relationship'};
    }
    public class ReportLayoutSection {
        public MetadataService.ReportTypeColumn[] columns;
        public String masterLabel;
        private String[] columns_type_info = new String[]{'columns','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] masterLabel_type_info = new String[]{'masterLabel','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'columns','masterLabel'};
    }
    public class CompactLayout extends Metadata {
        public String type = 'CompactLayout';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String[] fields;
        public String label;
        private String[] fields_type_info = new String[]{'fields','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'fields','label'};
    }
    public class VisualizationType {
        public String description;
        public String developerName;
        public String icon;
        public String masterLabel;
        public String scriptBootstrapMethod;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] developerName_type_info = new String[]{'developerName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] icon_type_info = new String[]{'icon','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] masterLabel_type_info = new String[]{'masterLabel','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] scriptBootstrapMethod_type_info = new String[]{'scriptBootstrapMethod','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'description','developerName','icon','masterLabel','scriptBootstrapMethod'};
    }
    public virtual class SharingBaseRule extends Metadata {
        public String accessLevel;
        public MetadataService.AccountSharingRuleSettings accountSettings;
        public String description;
        public String label;
        public MetadataService.SharedTo sharedTo;
    }
    public class AuthProvider extends Metadata {
        public String type = 'AuthProvider';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String authorizeUrl;
        public String consumerKey;
        public String consumerSecret;
        public String defaultScopes;
        public String errorUrl;
        public String executionUser;
        public String friendlyName;
        public String iconUrl;
        public String idTokenIssuer;
        public Boolean includeOrgIdInIdentifier;
        public String logoutUrl;
        public String portal;
        public String providerType;
        public String registrationHandler;
        public Boolean sendAccessTokenInHeader;
        public Boolean sendClientCredentialsInHeader;
        public String tokenUrl;
        public String userInfoUrl;
        private String[] authorizeUrl_type_info = new String[]{'authorizeUrl','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] consumerKey_type_info = new String[]{'consumerKey','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] consumerSecret_type_info = new String[]{'consumerSecret','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] defaultScopes_type_info = new String[]{'defaultScopes','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] errorUrl_type_info = new String[]{'errorUrl','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] executionUser_type_info = new String[]{'executionUser','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] friendlyName_type_info = new String[]{'friendlyName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] iconUrl_type_info = new String[]{'iconUrl','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] idTokenIssuer_type_info = new String[]{'idTokenIssuer','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] includeOrgIdInIdentifier_type_info = new String[]{'includeOrgIdInIdentifier','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] logoutUrl_type_info = new String[]{'logoutUrl','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] portal_type_info = new String[]{'portal','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] providerType_type_info = new String[]{'providerType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] registrationHandler_type_info = new String[]{'registrationHandler','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] sendAccessTokenInHeader_type_info = new String[]{'sendAccessTokenInHeader','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] sendClientCredentialsInHeader_type_info = new String[]{'sendClientCredentialsInHeader','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] tokenUrl_type_info = new String[]{'tokenUrl','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] userInfoUrl_type_info = new String[]{'userInfoUrl','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'authorizeUrl','consumerKey','consumerSecret','defaultScopes','errorUrl','executionUser','friendlyName','iconUrl','idTokenIssuer','includeOrgIdInIdentifier','logoutUrl','portal','providerType','registrationHandler','sendAccessTokenInHeader','sendClientCredentialsInHeader','tokenUrl','userInfoUrl'};
    }
    public class FlowDynamicChoiceSet extends FlowElement {
        public String type = 'FlowDynamicChoiceSet';
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        public String description;
        public String name;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        public String dataType;
        public String displayField;
        public MetadataService.FlowRecordFilter[] filters;
        public Integer limit_x;
        public String object_x;
        public MetadataService.FlowOutputFieldAssignment[] outputAssignments;
        public String picklistField;
        public String picklistObject;
        public String sortField;
        public String sortOrder;
        public String valueField;
        private String[] dataType_type_info = new String[]{'dataType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] displayField_type_info = new String[]{'displayField','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] filters_type_info = new String[]{'filters','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] limit_x_type_info = new String[]{'limit','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] object_x_type_info = new String[]{'object','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] outputAssignments_type_info = new String[]{'outputAssignments','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] picklistField_type_info = new String[]{'picklistField','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] picklistObject_type_info = new String[]{'picklistObject','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] sortField_type_info = new String[]{'sortField','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] sortOrder_type_info = new String[]{'sortOrder','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] valueField_type_info = new String[]{'valueField','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'processMetadataValues','description','name', 'dataType','displayField','filters','limit_x','object_x','outputAssignments','picklistField','picklistObject','sortField','sortOrder','valueField'};
    }
    public class RelatedContent {
        public MetadataService.RelatedContentItem[] relatedContentItems;
        private String[] relatedContentItems_type_info = new String[]{'relatedContentItems','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'relatedContentItems'};
    }
    public class WebLink extends Metadata {
        public String type = 'WebLink';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String availability;
        public String description;
        public String displayType;
        public String encodingKey;
        public Boolean hasMenubar;
        public Boolean hasScrollbars;
        public Boolean hasToolbar;
        public Integer height;
        public Boolean isResizable;
        public String linkType;
        public String masterLabel;
        public String openType;
        public String page_x;
        public String position;
        public Boolean protected_x;
        public Boolean requireRowSelection;
        public String scontrol;
        public Boolean showsLocation;
        public Boolean showsStatus;
        public String url;
        public Integer width;
        private String[] availability_type_info = new String[]{'availability','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] displayType_type_info = new String[]{'displayType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] encodingKey_type_info = new String[]{'encodingKey','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] hasMenubar_type_info = new String[]{'hasMenubar','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] hasScrollbars_type_info = new String[]{'hasScrollbars','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] hasToolbar_type_info = new String[]{'hasToolbar','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] height_type_info = new String[]{'height','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] isResizable_type_info = new String[]{'isResizable','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] linkType_type_info = new String[]{'linkType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] masterLabel_type_info = new String[]{'masterLabel','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] openType_type_info = new String[]{'openType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] page_x_type_info = new String[]{'page','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] position_type_info = new String[]{'position','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] protected_x_type_info = new String[]{'protected','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] requireRowSelection_type_info = new String[]{'requireRowSelection','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] scontrol_type_info = new String[]{'scontrol','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showsLocation_type_info = new String[]{'showsLocation','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showsStatus_type_info = new String[]{'showsStatus','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] url_type_info = new String[]{'url','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] width_type_info = new String[]{'width','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'availability','description','displayType','encodingKey','hasMenubar','hasScrollbars','hasToolbar','height','isResizable','linkType','masterLabel','openType','page_x','position','protected_x','requireRowSelection','scontrol','showsLocation','showsStatus','url','width'};
    }
    public class Flow extends Metadata {
        public String type = 'Flow';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public MetadataService.FlowActionCall[] actionCalls;
        public MetadataService.FlowApexPluginCall[] apexPluginCalls;
        public MetadataService.FlowAssignment[] assignments;
        public MetadataService.FlowChoice[] choices;
        public MetadataService.FlowConstant[] constants;
        public MetadataService.FlowDecision[] decisions;
        public String description;
        public MetadataService.FlowDynamicChoiceSet[] dynamicChoiceSets;
        public MetadataService.FlowFormula[] formulas;
        public String interviewLabel;
        public String label;
        public MetadataService.FlowLoop[] loops;
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        public String processType;
        public MetadataService.FlowRecordCreate[] recordCreates;
        public MetadataService.FlowRecordDelete[] recordDeletes;
        public MetadataService.FlowRecordLookup[] recordLookups;
        public MetadataService.FlowRecordUpdate[] recordUpdates;
        public MetadataService.FlowScreen[] screens;
        public String startElementReference;
        public MetadataService.FlowStep[] steps;
        public MetadataService.FlowSubflow[] subflows;
        public MetadataService.FlowTextTemplate[] textTemplates;
        public MetadataService.FlowVariable[] variables;
        public MetadataService.FlowWait[] waits;
        private String[] actionCalls_type_info = new String[]{'actionCalls','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apexPluginCalls_type_info = new String[]{'apexPluginCalls','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] assignments_type_info = new String[]{'assignments','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] choices_type_info = new String[]{'choices','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] constants_type_info = new String[]{'constants','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] decisions_type_info = new String[]{'decisions','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] dynamicChoiceSets_type_info = new String[]{'dynamicChoiceSets','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] formulas_type_info = new String[]{'formulas','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] interviewLabel_type_info = new String[]{'interviewLabel','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] loops_type_info = new String[]{'loops','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] processType_type_info = new String[]{'processType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] recordCreates_type_info = new String[]{'recordCreates','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] recordDeletes_type_info = new String[]{'recordDeletes','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] recordLookups_type_info = new String[]{'recordLookups','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] recordUpdates_type_info = new String[]{'recordUpdates','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] screens_type_info = new String[]{'screens','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] startElementReference_type_info = new String[]{'startElementReference','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] steps_type_info = new String[]{'steps','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] subflows_type_info = new String[]{'subflows','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] textTemplates_type_info = new String[]{'textTemplates','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] variables_type_info = new String[]{'variables','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] waits_type_info = new String[]{'waits','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'actionCalls','apexPluginCalls','assignments','choices','constants','decisions','description','dynamicChoiceSets','formulas','interviewLabel','label','loops','processMetadataValues','processType','recordCreates','recordDeletes','recordLookups','recordUpdates','screens','startElementReference','steps','subflows','textTemplates','variables','waits'};
    }
    public class CustomMetadataValue {
        public String field;
        public String value;
        private String[] field_type_info = new String[]{'field','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] value_type_info = new String[]{'value','http://soap.sforce.com/2006/04/metadata',null,'1','1','true'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'field','value'};
    }
    public class ArticleTypeTemplate {
        public String channel;
        public String page_x;
        public String template;
        private String[] channel_type_info = new String[]{'channel','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] page_x_type_info = new String[]{'page','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] template_type_info = new String[]{'template','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'channel','page_x','template'};
    }
    public class LetterheadHeaderFooter {
        public String backgroundColor;
        public Integer height;
        public String horizontalAlignment;
        public String logo;
        public String verticalAlignment;
        private String[] backgroundColor_type_info = new String[]{'backgroundColor','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] height_type_info = new String[]{'height','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] horizontalAlignment_type_info = new String[]{'horizontalAlignment','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] logo_type_info = new String[]{'logo','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] verticalAlignment_type_info = new String[]{'verticalAlignment','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'backgroundColor','height','horizontalAlignment','logo','verticalAlignment'};
    }
    public class PicklistValueTranslation {
        public String masterLabel;
        public String translation;
        private String[] masterLabel_type_info = new String[]{'masterLabel','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] translation_type_info = new String[]{'translation','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'masterLabel','translation'};
    }
    public class CountriesAndStates {
        public MetadataService.Country[] countries;
        private String[] countries_type_info = new String[]{'countries','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'countries'};
    }
    public class PathAssistant {
        public Boolean active;
        public String entityName;
        public String fieldName;
        public String masterLabel;
        public MetadataService.PathAssistantStep[] pathAssistantSteps;
        public String recordTypeName;
        private String[] active_type_info = new String[]{'active','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] entityName_type_info = new String[]{'entityName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] fieldName_type_info = new String[]{'fieldName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] masterLabel_type_info = new String[]{'masterLabel','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] pathAssistantSteps_type_info = new String[]{'pathAssistantSteps','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] recordTypeName_type_info = new String[]{'recordTypeName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'active','entityName','fieldName','masterLabel','pathAssistantSteps','recordTypeName'};
    }
    public class AsyncResult {
        public Boolean done;
        public String id;
        public String message;
        public String state;
        public String statusCode;
        private String[] done_type_info = new String[]{'done','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] id_type_info = new String[]{'id','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] message_type_info = new String[]{'message','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] state_type_info = new String[]{'state','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] statusCode_type_info = new String[]{'statusCode','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'done','id','message','state','statusCode'};
    }
    public class XOrgHub extends Metadata {
        public String type = 'XOrgHub';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String label;
        public Boolean lockSharedObjects;
        public String[] permissionSets;
        public MetadataService.XOrgHubSharedObject[] sharedObjects;
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] lockSharedObjects_type_info = new String[]{'lockSharedObjects','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] permissionSets_type_info = new String[]{'permissionSets','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] sharedObjects_type_info = new String[]{'sharedObjects','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'label','lockSharedObjects','permissionSets','sharedObjects'};
    }
    public class CustomLabel extends Metadata {
        public String type = 'CustomLabel';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String categories;
        public String language;
        public Boolean protected_x;
        public String shortDescription;
        public String value;
        private String[] categories_type_info = new String[]{'categories','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] language_type_info = new String[]{'language','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] protected_x_type_info = new String[]{'protected','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] shortDescription_type_info = new String[]{'shortDescription','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] value_type_info = new String[]{'value','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'categories','language','protected_x','shortDescription','value'};
    }
    public class NameSettings extends Metadata {
        public String type = 'NameSettings';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Boolean enableMiddleName;
        public Boolean enableNameSuffix;
        private String[] enableMiddleName_type_info = new String[]{'enableMiddleName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableNameSuffix_type_info = new String[]{'enableNameSuffix','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'enableMiddleName','enableNameSuffix'};
    }
    public class checkRetrieveStatusResponse_element {
        public MetadataService.RetrieveResult result;
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class Territory2Settings extends Metadata {
        public String type = 'Territory2Settings';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String defaultAccountAccessLevel;
        public String defaultCaseAccessLevel;
        public String defaultContactAccessLevel;
        public String defaultOpportunityAccessLevel;
        public MetadataService.Territory2SettingsOpportunityFilter opportunityFilterSettings;
        private String[] defaultAccountAccessLevel_type_info = new String[]{'defaultAccountAccessLevel','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] defaultCaseAccessLevel_type_info = new String[]{'defaultCaseAccessLevel','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] defaultContactAccessLevel_type_info = new String[]{'defaultContactAccessLevel','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] defaultOpportunityAccessLevel_type_info = new String[]{'defaultOpportunityAccessLevel','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] opportunityFilterSettings_type_info = new String[]{'opportunityFilterSettings','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'defaultAccountAccessLevel','defaultCaseAccessLevel','defaultContactAccessLevel','defaultOpportunityAccessLevel','opportunityFilterSettings'};
    }
    public class PlatformCachePartition {
        public String description;
        public Boolean isDefaultPartition;
        public String masterLabel;
        public MetadataService.PlatformCachePartitionType[] platformCachePartitionTypes;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] isDefaultPartition_type_info = new String[]{'isDefaultPartition','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] masterLabel_type_info = new String[]{'masterLabel','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] platformCachePartitionTypes_type_info = new String[]{'platformCachePartitionTypes','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'description','isDefaultPartition','masterLabel','platformCachePartitionTypes'};
    }
    public class ConnectedAppIpRange {
        public String description;
        public String end_x;
        public String start;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] end_x_type_info = new String[]{'end','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] start_type_info = new String[]{'start','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'description','end_x','start'};
    }
    public class ExternalDataSource extends Metadata {
        public String type = 'ExternalDataSource';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String apiKey;
        public String authProvider;
        public String certificate;
        public String customConfiguration;
        public String endpoint;
        public Boolean isWritable;
        public String label;
        public String oauthRefreshToken;
        public String oauthScope;
        public String oauthToken;
        public String password;
        public String principalType;
        public String protocol;
        public String repository;
        public String type_x;
        public String username;
        public String version;
        private String[] apiKey_type_info = new String[]{'apiKey','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] authProvider_type_info = new String[]{'authProvider','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] certificate_type_info = new String[]{'certificate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] customConfiguration_type_info = new String[]{'customConfiguration','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] endpoint_type_info = new String[]{'endpoint','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] isWritable_type_info = new String[]{'isWritable','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] oauthRefreshToken_type_info = new String[]{'oauthRefreshToken','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] oauthScope_type_info = new String[]{'oauthScope','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] oauthToken_type_info = new String[]{'oauthToken','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] password_type_info = new String[]{'password','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] principalType_type_info = new String[]{'principalType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] protocol_type_info = new String[]{'protocol','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] repository_type_info = new String[]{'repository','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] type_x_type_info = new String[]{'type','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] username_type_info = new String[]{'username','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] version_type_info = new String[]{'version','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'apiKey','authProvider','certificate','customConfiguration','endpoint','isWritable','label','oauthRefreshToken','oauthScope','oauthToken','password','principalType','protocol','repository','type_x','username','version'};
    }
    public class retrieveResponse_element {
        public MetadataService.AsyncResult result;
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ComponentInstance {
        public MetadataService.ComponentInstanceProperty[] componentInstanceProperties;
        public String componentName;
        private String[] componentInstanceProperties_type_info = new String[]{'componentInstanceProperties','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] componentName_type_info = new String[]{'componentName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'componentInstanceProperties','componentName'};
    }
    public class LayoutSectionTranslation {
        public String label;
        public String section;
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] section_type_info = new String[]{'section','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'label','section'};
    }
    public class FlowActionCallOutputParameter extends FlowBaseElement {
        public String type = 'FlowActionCallOutputParameter';
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        public String assignToReference;
        public String name;
        private String[] assignToReference_type_info = new String[]{'assignToReference','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'processMetadataValues', 'assignToReference','name'};
    }
    public class MarketingResourceType extends Metadata {
        public String type = 'MarketingResourceType';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String description;
        public String masterLabel;
        public String object_x;
        public String provider;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] masterLabel_type_info = new String[]{'masterLabel','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] object_x_type_info = new String[]{'object','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] provider_type_info = new String[]{'provider','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'description','masterLabel','object_x','provider'};
    }
    public class ApprovalSubmitter {
        public String submitter;
        public String type_x;
        private String[] submitter_type_info = new String[]{'submitter','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] type_x_type_info = new String[]{'type','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'submitter','type_x'};
    }
    public class FlowRecordCreate extends FlowNode {
        public String type = 'FlowRecordCreate';
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        public String description;
        public String name;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        public String label;
        public Integer locationX;
        public Integer locationY;
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] locationX_type_info = new String[]{'locationX','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] locationY_type_info = new String[]{'locationY','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        public String assignRecordIdToReference;
        public MetadataService.FlowConnector connector;
        public MetadataService.FlowConnector faultConnector;
        public MetadataService.FlowInputFieldAssignment[] inputAssignments;
        public String inputReference;
        public String object_x;
        private String[] assignRecordIdToReference_type_info = new String[]{'assignRecordIdToReference','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] connector_type_info = new String[]{'connector','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] faultConnector_type_info = new String[]{'faultConnector','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] inputAssignments_type_info = new String[]{'inputAssignments','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] inputReference_type_info = new String[]{'inputReference','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] object_x_type_info = new String[]{'object','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'processMetadataValues','description','name','label','locationX','locationY', 'assignRecordIdToReference','connector','faultConnector','inputAssignments','inputReference','object_x'};
    }
    public class upsertMetadataResponse_element {
        public MetadataService.UpsertResult[] result;
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ChannelLayout {
        public String[] enabledChannels;
        public String label;
        public MetadataService.ChannelLayoutItem[] layoutItems;
        private String[] enabledChannels_type_info = new String[]{'enabledChannels','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] layoutItems_type_info = new String[]{'layoutItems','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'enabledChannels','label','layoutItems'};
    }
    public class LiveChatDeploymentDomainWhitelist {
        public String[] domain;
        private String[] domain_type_info = new String[]{'domain','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'domain'};
    }
    public class PermissionSetRecordTypeVisibility {
        public String recordType;
        public Boolean visible;
        private String[] recordType_type_info = new String[]{'recordType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] visible_type_info = new String[]{'visible','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'recordType','visible'};
    }
    public class cancelDeploy_element {
        public String String_x;
        private String[] String_x_type_info = new String[]{'String','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'String_x'};
    }
    public class ReportFolder extends Folder {
        public String type = 'ReportFolder';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String accessType;
        public MetadataService.FolderShare[] folderShares;
        public String name;
        public String publicFolderAccess;
        public MetadataService.SharedTo sharedTo;
        private String[] accessType_type_info = new String[]{'accessType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] folderShares_type_info = new String[]{'folderShares','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] publicFolderAccess_type_info = new String[]{'publicFolderAccess','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] sharedTo_type_info = new String[]{'sharedTo','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName','accessType','folderShares','name','publicFolderAccess','sharedTo'};
    }
    public class DashboardComponentSection {
        public String columnSize;
        public MetadataService.DashboardComponent[] components;
        private String[] columnSize_type_info = new String[]{'columnSize','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] components_type_info = new String[]{'components','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'columnSize','components'};
    }
    public class EscalationRule extends Metadata {
        public String type = 'EscalationRule';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Boolean active;
        public MetadataService.RuleEntry[] ruleEntry;
        private String[] active_type_info = new String[]{'active','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] ruleEntry_type_info = new String[]{'ruleEntry','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'active','ruleEntry'};
    }
    public class RunTestFailure {
        public String id;
        public String message;
        public String methodName;
        public String name;
        public String namespace;
        public String packageName;
        public Boolean seeAllData;
        public String stackTrace;
        public Double time_x;
        public String type_x;
        private String[] id_type_info = new String[]{'id','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] message_type_info = new String[]{'message','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] methodName_type_info = new String[]{'methodName','http://soap.sforce.com/2006/04/metadata',null,'1','1','true'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] namespace_type_info = new String[]{'namespace','http://soap.sforce.com/2006/04/metadata',null,'1','1','true'};
        private String[] packageName_type_info = new String[]{'packageName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] seeAllData_type_info = new String[]{'seeAllData','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] stackTrace_type_info = new String[]{'stackTrace','http://soap.sforce.com/2006/04/metadata',null,'1','1','true'};
        private String[] time_x_type_info = new String[]{'time','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] type_x_type_info = new String[]{'type','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'id','message','methodName','name','namespace','packageName','seeAllData','stackTrace','time_x','type_x'};
    }
    public class SubtabComponents {
        public MetadataService.Container[] containers;
        private String[] containers_type_info = new String[]{'containers','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'containers'};
    }
    public class ConnectedAppMobileDetailConfig {
        public String applicationBinaryFile;
        public String applicationBinaryFileName;
        public String applicationBundleIdentifier;
        public Integer applicationFileLength;
        public String applicationIconFile;
        public String applicationIconFileName;
        public String applicationInstallUrl;
        public String devicePlatform;
        public String deviceType;
        public String minimumOsVersion;
        public Boolean privateApp;
        public String version;
        private String[] applicationBinaryFile_type_info = new String[]{'applicationBinaryFile','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] applicationBinaryFileName_type_info = new String[]{'applicationBinaryFileName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] applicationBundleIdentifier_type_info = new String[]{'applicationBundleIdentifier','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] applicationFileLength_type_info = new String[]{'applicationFileLength','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] applicationIconFile_type_info = new String[]{'applicationIconFile','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] applicationIconFileName_type_info = new String[]{'applicationIconFileName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] applicationInstallUrl_type_info = new String[]{'applicationInstallUrl','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] devicePlatform_type_info = new String[]{'devicePlatform','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] deviceType_type_info = new String[]{'deviceType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] minimumOsVersion_type_info = new String[]{'minimumOsVersion','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] privateApp_type_info = new String[]{'privateApp','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] version_type_info = new String[]{'version','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'applicationBinaryFile','applicationBinaryFileName','applicationBundleIdentifier','applicationFileLength','applicationIconFile','applicationIconFileName','applicationInstallUrl','devicePlatform','deviceType','minimumOsVersion','privateApp','version'};
    }
    public class PermissionSet extends Metadata {
        public String type = 'PermissionSet';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public MetadataService.PermissionSetApplicationVisibility[] applicationVisibilities;
        public MetadataService.PermissionSetApexClassAccess[] classAccesses;
        public MetadataService.PermissionSetCustomPermissions[] customPermissions;
        public String description;
        public MetadataService.PermissionSetExternalDataSourceAccess[] externalDataSourceAccesses;
        public MetadataService.PermissionSetFieldPermissions[] fieldPermissions;
        public String label;
        public MetadataService.PermissionSetObjectPermissions[] objectPermissions;
        public MetadataService.PermissionSetApexPageAccess[] pageAccesses;
        public MetadataService.PermissionSetRecordTypeVisibility[] recordTypeVisibilities;
        public MetadataService.PermissionSetTabSetting[] tabSettings;
        public String userLicense;
        public MetadataService.PermissionSetUserPermission[] userPermissions;
        private String[] applicationVisibilities_type_info = new String[]{'applicationVisibilities','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] classAccesses_type_info = new String[]{'classAccesses','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] customPermissions_type_info = new String[]{'customPermissions','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] externalDataSourceAccesses_type_info = new String[]{'externalDataSourceAccesses','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] fieldPermissions_type_info = new String[]{'fieldPermissions','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] objectPermissions_type_info = new String[]{'objectPermissions','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] pageAccesses_type_info = new String[]{'pageAccesses','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] recordTypeVisibilities_type_info = new String[]{'recordTypeVisibilities','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] tabSettings_type_info = new String[]{'tabSettings','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] userLicense_type_info = new String[]{'userLicense','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] userPermissions_type_info = new String[]{'userPermissions','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'applicationVisibilities','classAccesses','customPermissions','description','externalDataSourceAccesses','fieldPermissions','label','objectPermissions','pageAccesses','recordTypeVisibilities','tabSettings','userLicense','userPermissions'};
    }
    public class WorkflowRule extends Metadata {
        public String type = 'WorkflowRule';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public MetadataService.WorkflowActionReference[] actions;
        public Boolean active;
        public String booleanFilter;
        public MetadataService.FilterItem[] criteriaItems;
        public String description;
        public String formula;
        public String triggerType;
        public MetadataService.WorkflowTimeTrigger[] workflowTimeTriggers;
        private String[] actions_type_info = new String[]{'actions','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] active_type_info = new String[]{'active','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] booleanFilter_type_info = new String[]{'booleanFilter','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] criteriaItems_type_info = new String[]{'criteriaItems','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] formula_type_info = new String[]{'formula','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] triggerType_type_info = new String[]{'triggerType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] workflowTimeTriggers_type_info = new String[]{'workflowTimeTriggers','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'actions','active','booleanFilter','criteriaItems','description','formula','triggerType','workflowTimeTriggers'};
    }
    public class FlowRule extends FlowElement {
        public String type = 'FlowRule';
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        public String description;
        public String name;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        public String conditionLogic;
        public MetadataService.FlowCondition[] conditions;
        public MetadataService.FlowConnector connector;
        public String label;
        private String[] conditionLogic_type_info = new String[]{'conditionLogic','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] conditions_type_info = new String[]{'conditions','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] connector_type_info = new String[]{'connector','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'processMetadataValues','description','name', 'conditionLogic','conditions','connector','label'};
    }
    public class PermissionSetApexClassAccess {
        public String apexClass;
        public Boolean enabled;
        private String[] apexClass_type_info = new String[]{'apexClass','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] enabled_type_info = new String[]{'enabled','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'apexClass','enabled'};
    }
    public class CustomTab extends Metadata {
        public String type = 'CustomTab';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String auraComponent;
        public Boolean customObject;
        public String description;
        public String flexiPage;
        public Integer frameHeight;
        public Boolean hasSidebar;
        public String icon;
        public String label;
        public Boolean mobileReady;
        public String motif;
        public String page_x;
        public String scontrol;
        public String splashPageLink;
        public String url;
        public String urlEncodingKey;
        private String[] auraComponent_type_info = new String[]{'auraComponent','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] customObject_type_info = new String[]{'customObject','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] flexiPage_type_info = new String[]{'flexiPage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] frameHeight_type_info = new String[]{'frameHeight','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] hasSidebar_type_info = new String[]{'hasSidebar','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] icon_type_info = new String[]{'icon','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] mobileReady_type_info = new String[]{'mobileReady','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] motif_type_info = new String[]{'motif','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] page_x_type_info = new String[]{'page','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] scontrol_type_info = new String[]{'scontrol','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] splashPageLink_type_info = new String[]{'splashPageLink','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] url_type_info = new String[]{'url','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] urlEncodingKey_type_info = new String[]{'urlEncodingKey','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'auraComponent','customObject','description','flexiPage','frameHeight','hasSidebar','icon','label','mobileReady','motif','page_x','scontrol','splashPageLink','url','urlEncodingKey'};
    }
    public class LiveChatAgentConfig extends Metadata {
        public String type = 'LiveChatAgentConfig';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public MetadataService.AgentConfigAssignments assignments;
        public String autoGreeting;
        public Integer capacity;
        public Integer criticalWaitTime;
        public String customAgentName;
        public Boolean enableAgentFileTransfer;
        public Boolean enableAgentSneakPeek;
        public Boolean enableAssistanceFlag;
        public Boolean enableAutoAwayOnDecline;
        public Boolean enableAutoAwayOnPushTimeout;
        public Boolean enableChatConferencing;
        public Boolean enableChatMonitoring;
        public Boolean enableChatTransfer;
        public Boolean enableLogoutSound;
        public Boolean enableNotifications;
        public Boolean enableRequestSound;
        public Boolean enableSneakPeek;
        public Boolean enableVisitorBlocking;
        public Boolean enableWhisperMessage;
        public String label;
        public String supervisorDefaultAgentStatusFilter;
        public String supervisorDefaultButtonFilter;
        public String supervisorDefaultSkillFilter;
        public MetadataService.SupervisorAgentConfigSkills supervisorSkills;
        public MetadataService.AgentConfigButtons transferableButtons;
        public MetadataService.AgentConfigSkills transferableSkills;
        private String[] assignments_type_info = new String[]{'assignments','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] autoGreeting_type_info = new String[]{'autoGreeting','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] capacity_type_info = new String[]{'capacity','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] criticalWaitTime_type_info = new String[]{'criticalWaitTime','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] customAgentName_type_info = new String[]{'customAgentName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableAgentFileTransfer_type_info = new String[]{'enableAgentFileTransfer','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableAgentSneakPeek_type_info = new String[]{'enableAgentSneakPeek','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableAssistanceFlag_type_info = new String[]{'enableAssistanceFlag','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableAutoAwayOnDecline_type_info = new String[]{'enableAutoAwayOnDecline','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableAutoAwayOnPushTimeout_type_info = new String[]{'enableAutoAwayOnPushTimeout','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableChatConferencing_type_info = new String[]{'enableChatConferencing','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableChatMonitoring_type_info = new String[]{'enableChatMonitoring','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableChatTransfer_type_info = new String[]{'enableChatTransfer','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableLogoutSound_type_info = new String[]{'enableLogoutSound','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableNotifications_type_info = new String[]{'enableNotifications','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableRequestSound_type_info = new String[]{'enableRequestSound','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableSneakPeek_type_info = new String[]{'enableSneakPeek','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableVisitorBlocking_type_info = new String[]{'enableVisitorBlocking','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableWhisperMessage_type_info = new String[]{'enableWhisperMessage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] supervisorDefaultAgentStatusFilter_type_info = new String[]{'supervisorDefaultAgentStatusFilter','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] supervisorDefaultButtonFilter_type_info = new String[]{'supervisorDefaultButtonFilter','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] supervisorDefaultSkillFilter_type_info = new String[]{'supervisorDefaultSkillFilter','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] supervisorSkills_type_info = new String[]{'supervisorSkills','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] transferableButtons_type_info = new String[]{'transferableButtons','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] transferableSkills_type_info = new String[]{'transferableSkills','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'assignments','autoGreeting','capacity','criticalWaitTime','customAgentName','enableAgentFileTransfer','enableAgentSneakPeek','enableAssistanceFlag','enableAutoAwayOnDecline','enableAutoAwayOnPushTimeout','enableChatConferencing','enableChatMonitoring','enableChatTransfer','enableLogoutSound','enableNotifications','enableRequestSound','enableSneakPeek','enableVisitorBlocking','enableWhisperMessage','label','supervisorDefaultAgentStatusFilter','supervisorDefaultButtonFilter','supervisorDefaultSkillFilter','supervisorSkills','transferableButtons','transferableSkills'};
    }
    public class EmailToCaseSettings {
        public Boolean enableEmailToCase;
        public Boolean enableHtmlEmail;
        public Boolean enableOnDemandEmailToCase;
        public Boolean enableThreadIDInBody;
        public Boolean enableThreadIDInSubject;
        public Boolean notifyOwnerOnNewCaseEmail;
        public String overEmailLimitAction;
        public Boolean preQuoteSignature;
        public MetadataService.EmailToCaseRoutingAddress[] routingAddresses;
        public String unauthorizedSenderAction;
        private String[] enableEmailToCase_type_info = new String[]{'enableEmailToCase','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableHtmlEmail_type_info = new String[]{'enableHtmlEmail','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableOnDemandEmailToCase_type_info = new String[]{'enableOnDemandEmailToCase','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableThreadIDInBody_type_info = new String[]{'enableThreadIDInBody','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableThreadIDInSubject_type_info = new String[]{'enableThreadIDInSubject','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] notifyOwnerOnNewCaseEmail_type_info = new String[]{'notifyOwnerOnNewCaseEmail','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] overEmailLimitAction_type_info = new String[]{'overEmailLimitAction','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] preQuoteSignature_type_info = new String[]{'preQuoteSignature','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] routingAddresses_type_info = new String[]{'routingAddresses','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] unauthorizedSenderAction_type_info = new String[]{'unauthorizedSenderAction','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'enableEmailToCase','enableHtmlEmail','enableOnDemandEmailToCase','enableThreadIDInBody','enableThreadIDInSubject','notifyOwnerOnNewCaseEmail','overEmailLimitAction','preQuoteSignature','routingAddresses','unauthorizedSenderAction'};
    }
    public class FlowSubflowOutputAssignment extends FlowBaseElement {
        public String type = 'FlowSubflowOutputAssignment';
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        public String assignToReference;
        public String name;
        private String[] assignToReference_type_info = new String[]{'assignToReference','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'processMetadataValues', 'assignToReference','name'};
    }
    public class SecuritySettings extends Metadata {
        public String type = 'SecuritySettings';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public MetadataService.NetworkAccess networkAccess;
        public MetadataService.PasswordPolicies passwordPolicies;
        public MetadataService.SessionSettings sessionSettings;
        private String[] networkAccess_type_info = new String[]{'networkAccess','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] passwordPolicies_type_info = new String[]{'passwordPolicies','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] sessionSettings_type_info = new String[]{'sessionSettings','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'networkAccess','passwordPolicies','sessionSettings'};
    }
    public class ReportChart {
        public String backgroundColor1;
        public String backgroundColor2;
        public String backgroundFadeDir;
        public MetadataService.ChartSummary[] chartSummaries;
        public String chartType;
        public Boolean enableHoverLabels;
        public Boolean expandOthers;
        public String groupingColumn;
        public String legendPosition;
        public String location;
        public String secondaryGroupingColumn;
        public Boolean showAxisLabels;
        public Boolean showPercentage;
        public Boolean showTotal;
        public Boolean showValues;
        public String size;
        public Double summaryAxisManualRangeEnd;
        public Double summaryAxisManualRangeStart;
        public String summaryAxisRange;
        public String textColor;
        public Integer textSize;
        public String title;
        public String titleColor;
        public Integer titleSize;
        private String[] backgroundColor1_type_info = new String[]{'backgroundColor1','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] backgroundColor2_type_info = new String[]{'backgroundColor2','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] backgroundFadeDir_type_info = new String[]{'backgroundFadeDir','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] chartSummaries_type_info = new String[]{'chartSummaries','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] chartType_type_info = new String[]{'chartType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] enableHoverLabels_type_info = new String[]{'enableHoverLabels','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] expandOthers_type_info = new String[]{'expandOthers','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] groupingColumn_type_info = new String[]{'groupingColumn','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] legendPosition_type_info = new String[]{'legendPosition','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] location_type_info = new String[]{'location','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] secondaryGroupingColumn_type_info = new String[]{'secondaryGroupingColumn','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showAxisLabels_type_info = new String[]{'showAxisLabels','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showPercentage_type_info = new String[]{'showPercentage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showTotal_type_info = new String[]{'showTotal','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showValues_type_info = new String[]{'showValues','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] size_type_info = new String[]{'size','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] summaryAxisManualRangeEnd_type_info = new String[]{'summaryAxisManualRangeEnd','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] summaryAxisManualRangeStart_type_info = new String[]{'summaryAxisManualRangeStart','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] summaryAxisRange_type_info = new String[]{'summaryAxisRange','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] textColor_type_info = new String[]{'textColor','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] textSize_type_info = new String[]{'textSize','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] title_type_info = new String[]{'title','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] titleColor_type_info = new String[]{'titleColor','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] titleSize_type_info = new String[]{'titleSize','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'backgroundColor1','backgroundColor2','backgroundFadeDir','chartSummaries','chartType','enableHoverLabels','expandOthers','groupingColumn','legendPosition','location','secondaryGroupingColumn','showAxisLabels','showPercentage','showTotal','showValues','size','summaryAxisManualRangeEnd','summaryAxisManualRangeStart','summaryAxisRange','textColor','textSize','title','titleColor','titleSize'};
    }
    public class AppMenuItem {
        public String name;
        public String type_x;
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] type_x_type_info = new String[]{'type','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'name','type_x'};
    }
    public class RecordType extends Metadata {
        public String type = 'RecordType';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Boolean active;
        public String businessProcess;
        public String compactLayoutAssignment;
        public String description;
        public String label;
        public MetadataService.RecordTypePicklistValue[] picklistValues;
        private String[] active_type_info = new String[]{'active','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] businessProcess_type_info = new String[]{'businessProcess','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] compactLayoutAssignment_type_info = new String[]{'compactLayoutAssignment','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] picklistValues_type_info = new String[]{'picklistValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'active','businessProcess','compactLayoutAssignment','description','label','picklistValues'};
    }
    public class FieldOverride {
        public String field;
        public String formula;
        public String literalValue;
        private String[] field_type_info = new String[]{'field','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] formula_type_info = new String[]{'formula','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] literalValue_type_info = new String[]{'literalValue','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'field','formula','literalValue'};
    }
    public class ProfileTabVisibility {
        public String tab;
        public String visibility;
        private String[] tab_type_info = new String[]{'tab','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] visibility_type_info = new String[]{'visibility','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'tab','visibility'};
    }
    public class ReportCrossFilter {
        public MetadataService.ReportFilterItem[] criteriaItems;
        public String operation;
        public String primaryTableColumn;
        public String relatedTable;
        public String relatedTableJoinColumn;
        private String[] criteriaItems_type_info = new String[]{'criteriaItems','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] operation_type_info = new String[]{'operation','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] primaryTableColumn_type_info = new String[]{'primaryTableColumn','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] relatedTable_type_info = new String[]{'relatedTable','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] relatedTableJoinColumn_type_info = new String[]{'relatedTableJoinColumn','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'criteriaItems','operation','primaryTableColumn','relatedTable','relatedTableJoinColumn'};
    }
    public class LookupFilter {
        public Boolean active;
        public String booleanFilter;
        public String description;
        public String errorMessage;
        public MetadataService.FilterItem[] filterItems;
        public String infoMessage;
        public Boolean isOptional;
        private String[] active_type_info = new String[]{'active','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] booleanFilter_type_info = new String[]{'booleanFilter','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] errorMessage_type_info = new String[]{'errorMessage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] filterItems_type_info = new String[]{'filterItems','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] infoMessage_type_info = new String[]{'infoMessage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] isOptional_type_info = new String[]{'isOptional','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'active','booleanFilter','description','errorMessage','filterItems','infoMessage','isOptional'};
    }
    public class UiPlugin {
        public String description;
        public String extensionPointIdentifier;
        public Boolean isEnabled;
        public String language;
        public String masterLabel;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] extensionPointIdentifier_type_info = new String[]{'extensionPointIdentifier','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] isEnabled_type_info = new String[]{'isEnabled','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] language_type_info = new String[]{'language','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] masterLabel_type_info = new String[]{'masterLabel','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'description','extensionPointIdentifier','isEnabled','language','masterLabel'};
    }
    public class FlowLoop extends FlowNode {
        public String type = 'FlowLoop';
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        public String description;
        public String name;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        public String label;
        public Integer locationX;
        public Integer locationY;
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] locationX_type_info = new String[]{'locationX','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] locationY_type_info = new String[]{'locationY','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        public String assignNextValueToReference;
        public String collectionReference;
        public String iterationOrder;
        public MetadataService.FlowConnector nextValueConnector;
        public MetadataService.FlowConnector noMoreValuesConnector;
        private String[] assignNextValueToReference_type_info = new String[]{'assignNextValueToReference','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] collectionReference_type_info = new String[]{'collectionReference','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] iterationOrder_type_info = new String[]{'iterationOrder','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] nextValueConnector_type_info = new String[]{'nextValueConnector','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] noMoreValuesConnector_type_info = new String[]{'noMoreValuesConnector','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'processMetadataValues','description','name','label','locationX','locationY', 'assignNextValueToReference','collectionReference','iterationOrder','nextValueConnector','noMoreValuesConnector'};
    }
    public class FlowDefinition {
        public Integer activeVersionNumber;
        public String description;
        public String masterLabel;
        private String[] activeVersionNumber_type_info = new String[]{'activeVersionNumber','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] masterLabel_type_info = new String[]{'masterLabel','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'activeVersionNumber','description','masterLabel'};
    }
    public class ReputationLevelDefinitions {
        public MetadataService.ReputationLevel[] level;
        private String[] level_type_info = new String[]{'level','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'level'};
    }
    public class CustomPageWebLink extends Metadata {
        public String type = 'CustomPageWebLink';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String availability;
        public String description;
        public String displayType;
        public String encodingKey;
        public Boolean hasMenubar;
        public Boolean hasScrollbars;
        public Boolean hasToolbar;
        public Integer height;
        public Boolean isResizable;
        public String linkType;
        public String masterLabel;
        public String openType;
        public String page_x;
        public String position;
        public Boolean protected_x;
        public Boolean requireRowSelection;
        public String scontrol;
        public Boolean showsLocation;
        public Boolean showsStatus;
        public String url;
        public Integer width;
        private String[] availability_type_info = new String[]{'availability','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] displayType_type_info = new String[]{'displayType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] encodingKey_type_info = new String[]{'encodingKey','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] hasMenubar_type_info = new String[]{'hasMenubar','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] hasScrollbars_type_info = new String[]{'hasScrollbars','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] hasToolbar_type_info = new String[]{'hasToolbar','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] height_type_info = new String[]{'height','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] isResizable_type_info = new String[]{'isResizable','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] linkType_type_info = new String[]{'linkType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] masterLabel_type_info = new String[]{'masterLabel','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] openType_type_info = new String[]{'openType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] page_x_type_info = new String[]{'page','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] position_type_info = new String[]{'position','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] protected_x_type_info = new String[]{'protected','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] requireRowSelection_type_info = new String[]{'requireRowSelection','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] scontrol_type_info = new String[]{'scontrol','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showsLocation_type_info = new String[]{'showsLocation','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showsStatus_type_info = new String[]{'showsStatus','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] url_type_info = new String[]{'url','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] width_type_info = new String[]{'width','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'availability','description','displayType','encodingKey','hasMenubar','hasScrollbars','hasToolbar','height','isResizable','linkType','masterLabel','openType','page_x','position','protected_x','requireRowSelection','scontrol','showsLocation','showsStatus','url','width'};
    }
    public class ApprovalAction {
        public MetadataService.WorkflowActionReference[] action;
        private String[] action_type_info = new String[]{'action','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'action'};
    }
    public class SharingSet extends Metadata {
        public String type = 'SharingSet';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public MetadataService.AccessMapping[] accessMappings;
        public String description;
        public String name;
        public String[] profiles;
        private String[] accessMappings_type_info = new String[]{'accessMappings','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] profiles_type_info = new String[]{'profiles','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'accessMappings','description','name','profiles'};
    }
    public class WaveTemplateBundle {
        public String assetIcon;
        public String description;
        public String label;
        public String templateType;
        private String[] assetIcon_type_info = new String[]{'assetIcon','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] templateType_type_info = new String[]{'templateType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'assetIcon','description','label','templateType'};
    }
    public class LayoutColumn {
        public MetadataService.LayoutItem[] layoutItems;
        public String reserved;
        private String[] layoutItems_type_info = new String[]{'layoutItems','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] reserved_type_info = new String[]{'reserved','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'layoutItems','reserved'};
    }
    public class Error {
        public String[] fields;
        public String message;
        public String statusCode;
        private String[] fields_type_info = new String[]{'fields','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] message_type_info = new String[]{'message','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] statusCode_type_info = new String[]{'statusCode','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'fields','message','statusCode'};
    }
    public class Territory2RuleItem {
        public String field;
        public String operation;
        public String value;
        private String[] field_type_info = new String[]{'field','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] operation_type_info = new String[]{'operation','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] value_type_info = new String[]{'value','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'field','operation','value'};
    }
    public class FlowStep extends FlowNode {
        public String type = 'FlowStep';
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        public String description;
        public String name;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        public String label;
        public Integer locationX;
        public Integer locationY;
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] locationX_type_info = new String[]{'locationX','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] locationY_type_info = new String[]{'locationY','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        public MetadataService.FlowConnector[] connectors;
        private String[] connectors_type_info = new String[]{'connectors','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'processMetadataValues','description','name','label','locationX','locationY', 'connectors'};
    }
    public class updateMetadata_element {
        public MetadataService.Metadata[] metadata;
        private String[] metadata_type_info = new String[]{'metadata','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'metadata'};
    }
    public class AccountSettings extends Metadata {
        public String type = 'AccountSettings';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Boolean enableAccountOwnerReport;
        public Boolean enableAccountTeams;
        public Boolean enableSharedContacts;
        public Boolean showViewHierarchyLink;
        private String[] enableAccountOwnerReport_type_info = new String[]{'enableAccountOwnerReport','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableAccountTeams_type_info = new String[]{'enableAccountTeams','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableSharedContacts_type_info = new String[]{'enableSharedContacts','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showViewHierarchyLink_type_info = new String[]{'showViewHierarchyLink','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'enableAccountOwnerReport','enableAccountTeams','enableSharedContacts','showViewHierarchyLink'};
    }
    public class CancelDeployResult {
        public Boolean done;
        public String id;
        private String[] done_type_info = new String[]{'done','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] id_type_info = new String[]{'id','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'done','id'};
    }
    public class AgentConfigUserAssignments {
        public String[] user_x;
        private String[] user_x_type_info = new String[]{'user','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'user_x'};
    }
    public class TransactionSecurityAction {
        public Boolean block;
        public Boolean endSession;
        public MetadataService.TransactionSecurityNotification[] notifications;
        public Boolean twoFactorAuthentication;
        private String[] block_type_info = new String[]{'block','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] endSession_type_info = new String[]{'endSession','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] notifications_type_info = new String[]{'notifications','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] twoFactorAuthentication_type_info = new String[]{'twoFactorAuthentication','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'block','endSession','notifications','twoFactorAuthentication'};
    }
    public class DashboardFilterColumn {
        public String column;
        private String[] column_type_info = new String[]{'column','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'column'};
    }
    public class FlowVariable extends FlowElement {
        public String type = 'FlowVariable';
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        public String description;
        public String name;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        public String dataType;
        public Boolean isCollection;
        public Boolean isInput;
        public Boolean isOutput;
        public String objectType;
        public Integer scale;
        public MetadataService.FlowElementReferenceOrValue value;
        private String[] dataType_type_info = new String[]{'dataType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] isCollection_type_info = new String[]{'isCollection','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] isInput_type_info = new String[]{'isInput','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] isOutput_type_info = new String[]{'isOutput','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] objectType_type_info = new String[]{'objectType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] scale_type_info = new String[]{'scale','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] value_type_info = new String[]{'value','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'processMetadataValues','description','name', 'dataType','isCollection','isInput','isOutput','objectType','scale','value'};
    }
    public class SharingTerritoryRule extends SharingBaseRule {
        public String type = 'SharingTerritoryRule';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String accessLevel;
        public MetadataService.AccountSharingRuleSettings accountSettings;
        public String description;
        public String label;
        public MetadataService.SharedTo sharedTo;
        private String[] accessLevel_type_info = new String[]{'accessLevel','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] accountSettings_type_info = new String[]{'accountSettings','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] sharedTo_type_info = new String[]{'sharedTo','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName','accessLevel','accountSettings','description','label','sharedTo'};
    }
    public class WorkflowFlowActionParameter {
        public String name;
        public String value;
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] value_type_info = new String[]{'value','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'name','value'};
    }
    public class ScontrolTranslation {
        public String label;
        public String name;
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'label','name'};
    }
    public class PlatformActionListItem {
        public String actionName;
        public String actionType;
        public Integer sortOrder;
        public String subtype;
        private String[] actionName_type_info = new String[]{'actionName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] actionType_type_info = new String[]{'actionType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] sortOrder_type_info = new String[]{'sortOrder','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] subtype_type_info = new String[]{'subtype','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'actionName','actionType','sortOrder','subtype'};
    }
    public class CallOptions_element {
        public String client;
        private String[] client_type_info = new String[]{'client','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'client'};
    }
    public class ApprovalEntryCriteria {
        public String booleanFilter;
        public MetadataService.FilterItem[] criteriaItems;
        public String formula;
        private String[] booleanFilter_type_info = new String[]{'booleanFilter','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] criteriaItems_type_info = new String[]{'criteriaItems','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] formula_type_info = new String[]{'formula','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'booleanFilter','criteriaItems','formula'};
    }
    public class CallCenterItem {
        public String label;
        public String name;
        public String value;
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] value_type_info = new String[]{'value','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'label','name','value'};
    }
    public class Document extends MetadataWithContent {
        public String type = 'Document';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String content;
        private String[] content_type_info = new String[]{'content','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String description;
        public Boolean internalUseOnly;
        public String keywords;
        public String name;
        public Boolean public_x;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] internalUseOnly_type_info = new String[]{'internalUseOnly','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] keywords_type_info = new String[]{'keywords','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] public_x_type_info = new String[]{'public','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName','content', 'description','internalUseOnly','keywords','name','public_x'};
    }
    public class upsertMetadata_element {
        public MetadataService.Metadata[] metadata;
        private String[] metadata_type_info = new String[]{'metadata','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'metadata'};
    }
    public class ProfileExternalDataSourceAccess {
        public Boolean enabled;
        public String externalDataSource;
        private String[] enabled_type_info = new String[]{'enabled','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] externalDataSource_type_info = new String[]{'externalDataSource','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'enabled','externalDataSource'};
    }
    public class ValueTypeField {
        public MetadataService.ValueTypeField[] fields;
        public String[] foreignKeyDomain;
        public Boolean isForeignKey;
        public Boolean isNameField;
        public Integer minOccurs;
        public String name;
        public MetadataService.PicklistEntry[] picklistValues;
        public String soapType;
        public Boolean valueRequired;
        private String[] fields_type_info = new String[]{'fields','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] foreignKeyDomain_type_info = new String[]{'foreignKeyDomain','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] isForeignKey_type_info = new String[]{'isForeignKey','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] isNameField_type_info = new String[]{'isNameField','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] minOccurs_type_info = new String[]{'minOccurs','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] picklistValues_type_info = new String[]{'picklistValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] soapType_type_info = new String[]{'soapType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] valueRequired_type_info = new String[]{'valueRequired','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'fields','foreignKeyDomain','isForeignKey','isNameField','minOccurs','name','picklistValues','soapType','valueRequired'};
    }
    public class FlowAssignmentItem extends FlowBaseElement {
        public String type = 'FlowAssignmentItem';
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        public String assignToReference;
        public String operator;
        public MetadataService.FlowElementReferenceOrValue value;
        private String[] assignToReference_type_info = new String[]{'assignToReference','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] operator_type_info = new String[]{'operator','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] value_type_info = new String[]{'value','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'processMetadataValues', 'assignToReference','operator','value'};
    }
    public class EmailFolder extends Folder {
        public String type = 'EmailFolder';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String accessType;
        public MetadataService.FolderShare[] folderShares;
        public String name;
        public String publicFolderAccess;
        public MetadataService.SharedTo sharedTo;
        private String[] accessType_type_info = new String[]{'accessType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] folderShares_type_info = new String[]{'folderShares','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] publicFolderAccess_type_info = new String[]{'publicFolderAccess','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] sharedTo_type_info = new String[]{'sharedTo','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName','accessType','folderShares','name','publicFolderAccess','sharedTo'};
    }
    public class renameMetadata_element {
        public String type_x;
        public String oldFullName;
        public String newFullName;
        private String[] type_x_type_info = new String[]{'type','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] oldFullName_type_info = new String[]{'oldFullName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] newFullName_type_info = new String[]{'newFullName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'type_x','oldFullName','newFullName'};
    }
    public class PicklistValue extends Metadata {
        public String type = 'PicklistValue';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Boolean allowEmail;
        public Boolean closed;
        public String color;
        public String[] controllingFieldValues;
        public Boolean converted;
        public Boolean cssExposed;
        public Boolean default_x;
        public String description;
        public String forecastCategory;
        public Boolean highPriority;
        public Integer probability;
        public String reverseRole;
        public Boolean reviewed;
        public Boolean won;
        private String[] allowEmail_type_info = new String[]{'allowEmail','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] closed_type_info = new String[]{'closed','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] color_type_info = new String[]{'color','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] controllingFieldValues_type_info = new String[]{'controllingFieldValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] converted_type_info = new String[]{'converted','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] cssExposed_type_info = new String[]{'cssExposed','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] default_x_type_info = new String[]{'default','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] forecastCategory_type_info = new String[]{'forecastCategory','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] highPriority_type_info = new String[]{'highPriority','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] probability_type_info = new String[]{'probability','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] reverseRole_type_info = new String[]{'reverseRole','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] reviewed_type_info = new String[]{'reviewed','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] won_type_info = new String[]{'won','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'allowEmail','closed','color','controllingFieldValues','converted','cssExposed','default_x','description','forecastCategory','highPriority','probability','reverseRole','reviewed','won'};
    }
    public class SkillProfileAssignments {
        public String[] profile;
        private String[] profile_type_info = new String[]{'profile','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'profile'};
    }
    public class EscalationAction {
        public String assignedTo;
        public String assignedToTemplate;
        public String assignedToType;
        public Integer minutesToEscalation;
        public Boolean notifyCaseOwner;
        public String[] notifyEmail;
        public String notifyTo;
        public String notifyToTemplate;
        private String[] assignedTo_type_info = new String[]{'assignedTo','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] assignedToTemplate_type_info = new String[]{'assignedToTemplate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] assignedToType_type_info = new String[]{'assignedToType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] minutesToEscalation_type_info = new String[]{'minutesToEscalation','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] notifyCaseOwner_type_info = new String[]{'notifyCaseOwner','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] notifyEmail_type_info = new String[]{'notifyEmail','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] notifyTo_type_info = new String[]{'notifyTo','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] notifyToTemplate_type_info = new String[]{'notifyToTemplate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'assignedTo','assignedToTemplate','assignedToType','minutesToEscalation','notifyCaseOwner','notifyEmail','notifyTo','notifyToTemplate'};
    }
    public class Workflow extends Metadata {
        public String type = 'Workflow';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public MetadataService.WorkflowAlert[] alerts;
        public MetadataService.WorkflowFieldUpdate[] fieldUpdates;
        public MetadataService.WorkflowFlowAction[] flowActions;
        public MetadataService.WorkflowKnowledgePublish[] knowledgePublishes;
        public MetadataService.WorkflowOutboundMessage[] outboundMessages;
        public MetadataService.WorkflowRule[] rules;
        public MetadataService.WorkflowSend[] send;
        public MetadataService.WorkflowTask[] tasks;
        private String[] alerts_type_info = new String[]{'alerts','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] fieldUpdates_type_info = new String[]{'fieldUpdates','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] flowActions_type_info = new String[]{'flowActions','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] knowledgePublishes_type_info = new String[]{'knowledgePublishes','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] outboundMessages_type_info = new String[]{'outboundMessages','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] rules_type_info = new String[]{'rules','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] send_type_info = new String[]{'send','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] tasks_type_info = new String[]{'tasks','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'alerts','fieldUpdates','flowActions','knowledgePublishes','outboundMessages','rules','send','tasks'};
    }
    public class WorkflowKnowledgePublish extends WorkflowAction {
        public String type = 'WorkflowKnowledgePublish';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String action;
        public String description;
        public String label;
        public String language;
        public Boolean protected_x;
        private String[] action_type_info = new String[]{'action','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] language_type_info = new String[]{'language','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] protected_x_type_info = new String[]{'protected','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'action','description','label','language','protected_x'};
    }
    public class CustomFieldTranslation {
        public MetadataService.ObjectNameCaseValue[] caseValues;
        public String gender;
        public String help;
        public String label;
        public MetadataService.LookupFilterTranslation lookupFilter;
        public String name;
        public MetadataService.PicklistValueTranslation[] picklistValues;
        public String relationshipLabel;
        public String startsWith;
        private String[] caseValues_type_info = new String[]{'caseValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] gender_type_info = new String[]{'gender','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] help_type_info = new String[]{'help','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] lookupFilter_type_info = new String[]{'lookupFilter','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] picklistValues_type_info = new String[]{'picklistValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] relationshipLabel_type_info = new String[]{'relationshipLabel','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] startsWith_type_info = new String[]{'startsWith','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'caseValues','gender','help','label','lookupFilter','name','picklistValues','relationshipLabel','startsWith'};
    }
    public class VisualizationPlugin extends Metadata {
        public String type = 'VisualizationPlugin';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String description;
        public String developerName;
        public String icon;
        public String masterLabel;
        public MetadataService.VisualizationResource[] visualizationResources;
        public MetadataService.VisualizationType[] visualizationTypes;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] developerName_type_info = new String[]{'developerName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] icon_type_info = new String[]{'icon','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] masterLabel_type_info = new String[]{'masterLabel','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] visualizationResources_type_info = new String[]{'visualizationResources','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] visualizationTypes_type_info = new String[]{'visualizationTypes','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'description','developerName','icon','masterLabel','visualizationResources','visualizationTypes'};
    }
    public class DataPipeline {
        public Double apiVersion;
        public String label;
        public String scriptType;
        private String[] apiVersion_type_info = new String[]{'apiVersion','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] scriptType_type_info = new String[]{'scriptType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'apiVersion','label','scriptType'};
    }
    public class QueueSobject {
        public String sobjectType;
        private String[] sobjectType_type_info = new String[]{'sobjectType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'sobjectType'};
    }
    public class ApexClass extends MetadataWithContent {
        public String type = 'ApexClass';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String content;
        private String[] content_type_info = new String[]{'content','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Double apiVersion;
        public MetadataService.PackageVersion[] packageVersions;
        public String status;
        private String[] apiVersion_type_info = new String[]{'apiVersion','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] packageVersions_type_info = new String[]{'packageVersions','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] status_type_info = new String[]{'status','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName','content', 'apiVersion','packageVersions','status'};
    }
    public class EntitlementTemplate extends Metadata {
        public String type = 'EntitlementTemplate';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String businessHours;
        public Integer casesPerEntitlement;
        public String entitlementProcess;
        public Boolean isPerIncident;
        public Integer term;
        public String type_x;
        private String[] businessHours_type_info = new String[]{'businessHours','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] casesPerEntitlement_type_info = new String[]{'casesPerEntitlement','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] entitlementProcess_type_info = new String[]{'entitlementProcess','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] isPerIncident_type_info = new String[]{'isPerIncident','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] term_type_info = new String[]{'term','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] type_x_type_info = new String[]{'type','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'businessHours','casesPerEntitlement','entitlementProcess','isPerIncident','term','type_x'};
    }
    public class Group_x extends Metadata {
        public String type = 'Group_x';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Boolean doesIncludeBosses;
        public String name;
        private String[] doesIncludeBosses_type_info = new String[]{'doesIncludeBosses','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'doesIncludeBosses','name'};
    }
    public class KnowledgeLanguageSettings {
        public MetadataService.KnowledgeLanguage[] language;
        private String[] language_type_info = new String[]{'language','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'language'};
    }
    public virtual class Metadata {
        public String fullName;
    }
    public class DebuggingHeader_element {
        public MetadataService.LogInfo[] categories;
        public String debugLevel;
        private String[] categories_type_info = new String[]{'categories','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] debugLevel_type_info = new String[]{'debugLevel','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'categories','debugLevel'};
    }
    public class ApprovalPageField {
        public String[] field;
        private String[] field_type_info = new String[]{'field','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'field'};
    }
    public class PermissionSetApexPageAccess {
        public String apexPage;
        public Boolean enabled;
        private String[] apexPage_type_info = new String[]{'apexPage','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] enabled_type_info = new String[]{'enabled','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'apexPage','enabled'};
    }
    public class FlowChoice extends FlowElement {
        public String type = 'FlowChoice';
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        public String description;
        public String name;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        public String choiceText;
        public String dataType;
        public MetadataService.FlowChoiceUserInput userInput;
        public MetadataService.FlowElementReferenceOrValue value;
        private String[] choiceText_type_info = new String[]{'choiceText','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] dataType_type_info = new String[]{'dataType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] userInput_type_info = new String[]{'userInput','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] value_type_info = new String[]{'value','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'processMetadataValues','description','name', 'choiceText','dataType','userInput','value'};
    }
    public class ConnectedApp extends Metadata {
        public String type = 'ConnectedApp';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public MetadataService.ConnectedAppAttribute[] attributes;
        public MetadataService.ConnectedAppCanvasConfig canvasConfig;
        public String contactEmail;
        public String contactPhone;
        public String description;
        public String iconUrl;
        public String infoUrl;
        public MetadataService.ConnectedAppIpRange[] ipRanges;
        public String label;
        public String logoUrl;
        public MetadataService.ConnectedAppMobileDetailConfig mobileAppConfig;
        public String mobileStartUrl;
        public MetadataService.ConnectedAppOauthConfig oauthConfig;
        public String plugin;
        public MetadataService.ConnectedAppSamlConfig samlConfig;
        public String startUrl;
        private String[] attributes_type_info = new String[]{'attributes','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] canvasConfig_type_info = new String[]{'canvasConfig','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] contactEmail_type_info = new String[]{'contactEmail','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] contactPhone_type_info = new String[]{'contactPhone','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] iconUrl_type_info = new String[]{'iconUrl','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] infoUrl_type_info = new String[]{'infoUrl','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] ipRanges_type_info = new String[]{'ipRanges','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] logoUrl_type_info = new String[]{'logoUrl','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] mobileAppConfig_type_info = new String[]{'mobileAppConfig','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] mobileStartUrl_type_info = new String[]{'mobileStartUrl','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] oauthConfig_type_info = new String[]{'oauthConfig','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] plugin_type_info = new String[]{'plugin','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] samlConfig_type_info = new String[]{'samlConfig','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] startUrl_type_info = new String[]{'startUrl','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'attributes','canvasConfig','contactEmail','contactPhone','description','iconUrl','infoUrl','ipRanges','label','logoUrl','mobileAppConfig','mobileStartUrl','oauthConfig','plugin','samlConfig','startUrl'};
    }
    public class describeMetadata_element {
        public Double asOfVersion;
        private String[] asOfVersion_type_info = new String[]{'asOfVersion','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'asOfVersion'};
    }
    public class LayoutItem {
        public MetadataService.AnalyticsCloudComponentLayoutItem analyticsCloudComponent;
        public String behavior;
        public String canvas;
        public String component;
        public String customLink;
        public Boolean emptySpace;
        public String field;
        public Integer height;
        public String page_x;
        public MetadataService.ReportChartComponentLayoutItem reportChartComponent;
        public String scontrol;
        public Boolean showLabel;
        public Boolean showScrollbars;
        public String width;
        private String[] analyticsCloudComponent_type_info = new String[]{'analyticsCloudComponent','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] behavior_type_info = new String[]{'behavior','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] canvas_type_info = new String[]{'canvas','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] component_type_info = new String[]{'component','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] customLink_type_info = new String[]{'customLink','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] emptySpace_type_info = new String[]{'emptySpace','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] field_type_info = new String[]{'field','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] height_type_info = new String[]{'height','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] page_x_type_info = new String[]{'page','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] reportChartComponent_type_info = new String[]{'reportChartComponent','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] scontrol_type_info = new String[]{'scontrol','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showLabel_type_info = new String[]{'showLabel','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showScrollbars_type_info = new String[]{'showScrollbars','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] width_type_info = new String[]{'width','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'analyticsCloudComponent','behavior','canvas','component','customLink','emptySpace','field','height','page_x','reportChartComponent','scontrol','showLabel','showScrollbars','width'};
    }
    public class Portal extends Metadata {
        public String type = 'Portal';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Boolean active;
        public String admin;
        public String defaultLanguage;
        public String description;
        public String emailSenderAddress;
        public String emailSenderName;
        public Boolean enableSelfCloseCase;
        public String footerDocument;
        public String forgotPassTemplate;
        public String headerDocument;
        public Boolean isSelfRegistrationActivated;
        public String loginHeaderDocument;
        public String logoDocument;
        public String logoutUrl;
        public String newCommentTemplate;
        public String newPassTemplate;
        public String newUserTemplate;
        public String ownerNotifyTemplate;
        public String selfRegNewUserUrl;
        public String selfRegUserDefaultProfile;
        public String selfRegUserDefaultRole;
        public String selfRegUserTemplate;
        public Boolean showActionConfirmation;
        public String stylesheetDocument;
        public String type_x;
        private String[] active_type_info = new String[]{'active','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] admin_type_info = new String[]{'admin','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] defaultLanguage_type_info = new String[]{'defaultLanguage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] emailSenderAddress_type_info = new String[]{'emailSenderAddress','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] emailSenderName_type_info = new String[]{'emailSenderName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] enableSelfCloseCase_type_info = new String[]{'enableSelfCloseCase','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] footerDocument_type_info = new String[]{'footerDocument','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] forgotPassTemplate_type_info = new String[]{'forgotPassTemplate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] headerDocument_type_info = new String[]{'headerDocument','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] isSelfRegistrationActivated_type_info = new String[]{'isSelfRegistrationActivated','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] loginHeaderDocument_type_info = new String[]{'loginHeaderDocument','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] logoDocument_type_info = new String[]{'logoDocument','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] logoutUrl_type_info = new String[]{'logoutUrl','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] newCommentTemplate_type_info = new String[]{'newCommentTemplate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] newPassTemplate_type_info = new String[]{'newPassTemplate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] newUserTemplate_type_info = new String[]{'newUserTemplate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] ownerNotifyTemplate_type_info = new String[]{'ownerNotifyTemplate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] selfRegNewUserUrl_type_info = new String[]{'selfRegNewUserUrl','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] selfRegUserDefaultProfile_type_info = new String[]{'selfRegUserDefaultProfile','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] selfRegUserDefaultRole_type_info = new String[]{'selfRegUserDefaultRole','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] selfRegUserTemplate_type_info = new String[]{'selfRegUserTemplate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showActionConfirmation_type_info = new String[]{'showActionConfirmation','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] stylesheetDocument_type_info = new String[]{'stylesheetDocument','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] type_x_type_info = new String[]{'type','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'active','admin','defaultLanguage','description','emailSenderAddress','emailSenderName','enableSelfCloseCase','footerDocument','forgotPassTemplate','headerDocument','isSelfRegistrationActivated','loginHeaderDocument','logoDocument','logoutUrl','newCommentTemplate','newPassTemplate','newUserTemplate','ownerNotifyTemplate','selfRegNewUserUrl','selfRegUserDefaultProfile','selfRegUserDefaultRole','selfRegUserTemplate','showActionConfirmation','stylesheetDocument','type_x'};
    }
    public class RunTestSuccess {
        public String id;
        public String methodName;
        public String name;
        public String namespace;
        public Boolean seeAllData;
        public Double time_x;
        private String[] id_type_info = new String[]{'id','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] methodName_type_info = new String[]{'methodName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] namespace_type_info = new String[]{'namespace','http://soap.sforce.com/2006/04/metadata',null,'1','1','true'};
        private String[] seeAllData_type_info = new String[]{'seeAllData','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] time_x_type_info = new String[]{'time','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'id','methodName','name','namespace','seeAllData','time_x'};
    }
    public class PermissionSetExternalDataSourceAccess {
        public Boolean enabled;
        public String externalDataSource;
        private String[] enabled_type_info = new String[]{'enabled','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] externalDataSource_type_info = new String[]{'externalDataSource','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'enabled','externalDataSource'};
    }
    public class CustomDataType extends Metadata {
        public String type = 'CustomDataType';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public MetadataService.CustomDataTypeComponent[] customDataTypeComponents;
        public String description;
        public String displayFormula;
        public Boolean editComponentsOnSeparateLines;
        public String label;
        public Boolean rightAligned;
        public Boolean supportComponentsInReports;
        private String[] customDataTypeComponents_type_info = new String[]{'customDataTypeComponents','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] displayFormula_type_info = new String[]{'displayFormula','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] editComponentsOnSeparateLines_type_info = new String[]{'editComponentsOnSeparateLines','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] rightAligned_type_info = new String[]{'rightAligned','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] supportComponentsInReports_type_info = new String[]{'supportComponentsInReports','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'customDataTypeComponents','description','displayFormula','editComponentsOnSeparateLines','label','rightAligned','supportComponentsInReports'};
    }
    public class FlowConnector extends FlowBaseElement {
        public String type = 'FlowConnector';
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        public String targetReference;
        private String[] targetReference_type_info = new String[]{'targetReference','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'processMetadataValues', 'targetReference'};
    }
    public class ListMetadataQuery {
        public String folder;
        public String type_x;
        private String[] folder_type_info = new String[]{'folder','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] type_x_type_info = new String[]{'type','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'folder','type_x'};
    }
    public class LogInfo {
        public String category;
        public String level;
        private String[] category_type_info = new String[]{'category','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] level_type_info = new String[]{'level','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'category','level'};
    }
    public class SharedTo {
        public String allCustomerPortalUsers;
        public String allInternalUsers;
        public String allPartnerUsers;
        public String[] group_x;
        public String[] groups;
        public String[] managerSubordinates;
        public String[] managers;
        public String[] portalRole;
        public String[] portalRoleAndSubordinates;
        public String[] queue;
        public String[] role;
        public String[] roleAndSubordinates;
        public String[] roleAndSubordinatesInternal;
        public String[] roles;
        public String[] rolesAndSubordinates;
        public String[] territories;
        public String[] territoriesAndSubordinates;
        public String[] territory;
        public String[] territoryAndSubordinates;
        private String[] allCustomerPortalUsers_type_info = new String[]{'allCustomerPortalUsers','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] allInternalUsers_type_info = new String[]{'allInternalUsers','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] allPartnerUsers_type_info = new String[]{'allPartnerUsers','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] group_x_type_info = new String[]{'group','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] groups_type_info = new String[]{'groups','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] managerSubordinates_type_info = new String[]{'managerSubordinates','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] managers_type_info = new String[]{'managers','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] portalRole_type_info = new String[]{'portalRole','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] portalRoleAndSubordinates_type_info = new String[]{'portalRoleAndSubordinates','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] queue_type_info = new String[]{'queue','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] role_type_info = new String[]{'role','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] roleAndSubordinates_type_info = new String[]{'roleAndSubordinates','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] roleAndSubordinatesInternal_type_info = new String[]{'roleAndSubordinatesInternal','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] roles_type_info = new String[]{'roles','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] rolesAndSubordinates_type_info = new String[]{'rolesAndSubordinates','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] territories_type_info = new String[]{'territories','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] territoriesAndSubordinates_type_info = new String[]{'territoriesAndSubordinates','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] territory_type_info = new String[]{'territory','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] territoryAndSubordinates_type_info = new String[]{'territoryAndSubordinates','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'allCustomerPortalUsers','allInternalUsers','allPartnerUsers','group_x','groups','managerSubordinates','managers','portalRole','portalRoleAndSubordinates','queue','role','roleAndSubordinates','roleAndSubordinatesInternal','roles','rolesAndSubordinates','territories','territoriesAndSubordinates','territory','territoryAndSubordinates'};
    }
    public class PlatformCachePartitionType {
        public Integer allocatedCapacity;
        public Long allocatedPurchasedCapacity;
        public String cacheType;
        private String[] allocatedCapacity_type_info = new String[]{'allocatedCapacity','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] allocatedPurchasedCapacity_type_info = new String[]{'allocatedPurchasedCapacity','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] cacheType_type_info = new String[]{'cacheType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'allocatedCapacity','allocatedPurchasedCapacity','cacheType'};
    }
    public class ReputationPointsRule {
        public String eventType;
        public Integer points;
        private String[] eventType_type_info = new String[]{'eventType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] points_type_info = new String[]{'points','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'eventType','points'};
    }
    public class FlowRecordLookup extends FlowNode {
        public String type = 'FlowRecordLookup';
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        public String description;
        public String name;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        public String label;
        public Integer locationX;
        public Integer locationY;
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] locationX_type_info = new String[]{'locationX','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] locationY_type_info = new String[]{'locationY','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        public Boolean assignNullValuesIfNoRecordsFound;
        public MetadataService.FlowConnector connector;
        public MetadataService.FlowConnector faultConnector;
        public MetadataService.FlowRecordFilter[] filters;
        public String object_x;
        public MetadataService.FlowOutputFieldAssignment[] outputAssignments;
        public String outputReference;
        public String[] queriedFields;
        public String sortField;
        public String sortOrder;
        private String[] assignNullValuesIfNoRecordsFound_type_info = new String[]{'assignNullValuesIfNoRecordsFound','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] connector_type_info = new String[]{'connector','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] faultConnector_type_info = new String[]{'faultConnector','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] filters_type_info = new String[]{'filters','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] object_x_type_info = new String[]{'object','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] outputAssignments_type_info = new String[]{'outputAssignments','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] outputReference_type_info = new String[]{'outputReference','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] queriedFields_type_info = new String[]{'queriedFields','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] sortField_type_info = new String[]{'sortField','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] sortOrder_type_info = new String[]{'sortOrder','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'processMetadataValues','description','name','label','locationX','locationY', 'assignNullValuesIfNoRecordsFound','connector','faultConnector','filters','object_x','outputAssignments','outputReference','queriedFields','sortField','sortOrder'};
    }
    public class QuickActionLayoutColumn {
        public MetadataService.QuickActionLayoutItem[] quickActionLayoutItems;
        private String[] quickActionLayoutItems_type_info = new String[]{'quickActionLayoutItems','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'quickActionLayoutItems'};
    }
    public class ReputationBranding {
        public String smallImage;
        private String[] smallImage_type_info = new String[]{'smallImage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'smallImage'};
    }
    public class ReputationLevel {
        public MetadataService.ReputationBranding branding;
        public String label;
        public Double lowerThreshold;
        private String[] branding_type_info = new String[]{'branding','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] lowerThreshold_type_info = new String[]{'lowerThreshold','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'branding','label','lowerThreshold'};
    }
    public class ProfileLayoutAssignment {
        public String layout;
        public String recordType;
        private String[] layout_type_info = new String[]{'layout','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] recordType_type_info = new String[]{'recordType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'layout','recordType'};
    }
    public class QuickActionTranslation {
        public String label;
        public String name;
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'label','name'};
    }
    public class ReportTypeTranslation {
        public String description;
        public String label;
        public String name;
        public MetadataService.ReportTypeSectionTranslation[] sections;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] sections_type_info = new String[]{'sections','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'description','label','name','sections'};
    }
    public class ActionLinkGroupTemplate extends Metadata {
        public String type = 'ActionLinkGroupTemplate';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public MetadataService.ActionLinkTemplate[] actionLinkTemplates;
        public String category;
        public String executionsAllowed;
        public Integer hoursUntilExpiration;
        public Boolean isPublished;
        public String name;
        private String[] actionLinkTemplates_type_info = new String[]{'actionLinkTemplates','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] category_type_info = new String[]{'category','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] executionsAllowed_type_info = new String[]{'executionsAllowed','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] hoursUntilExpiration_type_info = new String[]{'hoursUntilExpiration','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] isPublished_type_info = new String[]{'isPublished','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'actionLinkTemplates','category','executionsAllowed','hoursUntilExpiration','isPublished','name'};
    }
    public class ReportDataCategoryFilter {
        public String dataCategory;
        public String dataCategoryGroup;
        public String operator;
        private String[] dataCategory_type_info = new String[]{'dataCategory','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] dataCategoryGroup_type_info = new String[]{'dataCategoryGroup','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] operator_type_info = new String[]{'operator','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'dataCategory','dataCategoryGroup','operator'};
    }
    public class ReportBucketFieldSourceValue {
        public String from_x;
        public String sourceValue;
        public String to;
        private String[] from_x_type_info = new String[]{'from','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] sourceValue_type_info = new String[]{'sourceValue','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] to_type_info = new String[]{'to','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'from_x','sourceValue','to'};
    }
    public class ValidationRuleTranslation {
        public String errorMessage;
        public String name;
        private String[] errorMessage_type_info = new String[]{'errorMessage','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'errorMessage','name'};
    }
    public class DocumentFolder extends Folder {
        public String type = 'DocumentFolder';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String accessType;
        public MetadataService.FolderShare[] folderShares;
        public String name;
        public String publicFolderAccess;
        public MetadataService.SharedTo sharedTo;
        private String[] accessType_type_info = new String[]{'accessType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] folderShares_type_info = new String[]{'folderShares','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] publicFolderAccess_type_info = new String[]{'publicFolderAccess','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] sharedTo_type_info = new String[]{'sharedTo','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName','accessType','folderShares','name','publicFolderAccess','sharedTo'};
    }
    public class createMetadataResponse_element {
        public MetadataService.SaveResult[] result;
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class Dashboard extends Metadata {
        public String type = 'Dashboard';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String backgroundEndColor;
        public String backgroundFadeDirection;
        public String backgroundStartColor;
        public MetadataService.DashboardFilter[] dashboardFilters;
        public MetadataService.DashboardGridLayout dashboardGridLayout;
        public String dashboardResultRefreshedDate;
        public String dashboardResultRunningUser;
        public String dashboardType;
        public String description;
        public String folderName;
        public Boolean isGridLayout;
        public MetadataService.DashboardComponentSection leftSection;
        public MetadataService.DashboardComponentSection middleSection;
        public MetadataService.DashboardComponentSection rightSection;
        public String runningUser;
        public String textColor;
        public String title;
        public String titleColor;
        public Integer titleSize;
        private String[] backgroundEndColor_type_info = new String[]{'backgroundEndColor','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] backgroundFadeDirection_type_info = new String[]{'backgroundFadeDirection','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] backgroundStartColor_type_info = new String[]{'backgroundStartColor','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] dashboardFilters_type_info = new String[]{'dashboardFilters','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] dashboardGridLayout_type_info = new String[]{'dashboardGridLayout','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] dashboardResultRefreshedDate_type_info = new String[]{'dashboardResultRefreshedDate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] dashboardResultRunningUser_type_info = new String[]{'dashboardResultRunningUser','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] dashboardType_type_info = new String[]{'dashboardType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] folderName_type_info = new String[]{'folderName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] isGridLayout_type_info = new String[]{'isGridLayout','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] leftSection_type_info = new String[]{'leftSection','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] middleSection_type_info = new String[]{'middleSection','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] rightSection_type_info = new String[]{'rightSection','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] runningUser_type_info = new String[]{'runningUser','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] textColor_type_info = new String[]{'textColor','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] title_type_info = new String[]{'title','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] titleColor_type_info = new String[]{'titleColor','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] titleSize_type_info = new String[]{'titleSize','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'backgroundEndColor','backgroundFadeDirection','backgroundStartColor','dashboardFilters','dashboardGridLayout','dashboardResultRefreshedDate','dashboardResultRunningUser','dashboardType','description','folderName','isGridLayout','leftSection','middleSection','rightSection','runningUser','textColor','title','titleColor','titleSize'};
    }
    public class PersonListSettings {
        public Boolean enablePersonList;
        private String[] enablePersonList_type_info = new String[]{'enablePersonList','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'enablePersonList'};
    }
    public class KeyboardShortcuts {
        public MetadataService.CustomShortcut[] customShortcut;
        public MetadataService.DefaultShortcut[] defaultShortcut;
        private String[] customShortcut_type_info = new String[]{'customShortcut','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] defaultShortcut_type_info = new String[]{'defaultShortcut','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'customShortcut','defaultShortcut'};
    }
    public class ManagedTopic {
        public String managedTopicType;
        public String name;
        public String parentName;
        public Integer position;
        public String topicDescription;
        private String[] managedTopicType_type_info = new String[]{'managedTopicType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] parentName_type_info = new String[]{'parentName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] position_type_info = new String[]{'position','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] topicDescription_type_info = new String[]{'topicDescription','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'managedTopicType','name','parentName','position','topicDescription'};
    }
    public class SkillAssignments {
        public MetadataService.SkillProfileAssignments profiles;
        public MetadataService.SkillUserAssignments users;
        private String[] profiles_type_info = new String[]{'profiles','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] users_type_info = new String[]{'users','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'profiles','users'};
    }
    public class WorkflowEmailRecipient {
        public String field;
        public String recipient;
        public String type_x;
        private String[] field_type_info = new String[]{'field','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] recipient_type_info = new String[]{'recipient','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] type_x_type_info = new String[]{'type','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'field','recipient','type_x'};
    }
    public class CodeCoverageResult {
        public MetadataService.CodeLocation[] dmlInfo;
        public String id;
        public MetadataService.CodeLocation[] locationsNotCovered;
        public MetadataService.CodeLocation[] methodInfo;
        public String name;
        public String namespace;
        public Integer numLocations;
        public Integer numLocationsNotCovered;
        public MetadataService.CodeLocation[] soqlInfo;
        public MetadataService.CodeLocation[] soslInfo;
        public String type_x;
        private String[] dmlInfo_type_info = new String[]{'dmlInfo','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] id_type_info = new String[]{'id','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] locationsNotCovered_type_info = new String[]{'locationsNotCovered','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] methodInfo_type_info = new String[]{'methodInfo','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] namespace_type_info = new String[]{'namespace','http://soap.sforce.com/2006/04/metadata',null,'1','1','true'};
        private String[] numLocations_type_info = new String[]{'numLocations','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] numLocationsNotCovered_type_info = new String[]{'numLocationsNotCovered','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] soqlInfo_type_info = new String[]{'soqlInfo','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] soslInfo_type_info = new String[]{'soslInfo','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] type_x_type_info = new String[]{'type','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'dmlInfo','id','locationsNotCovered','methodInfo','name','namespace','numLocations','numLocationsNotCovered','soqlInfo','soslInfo','type_x'};
    }
    public class RecordTypePicklistValue {
        public String picklist;
        public MetadataService.PicklistValue[] values;
        private String[] picklist_type_info = new String[]{'picklist','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] values_type_info = new String[]{'values','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'picklist','values'};
    }
    public class FlowApexPluginCall extends FlowNode {
        public String type = 'FlowApexPluginCall';
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        public String description;
        public String name;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        public String label;
        public Integer locationX;
        public Integer locationY;
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] locationX_type_info = new String[]{'locationX','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] locationY_type_info = new String[]{'locationY','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        public String apexClass;
        public MetadataService.FlowConnector connector;
        public MetadataService.FlowConnector faultConnector;
        public MetadataService.FlowApexPluginCallInputParameter[] inputParameters;
        public MetadataService.FlowApexPluginCallOutputParameter[] outputParameters;
        private String[] apexClass_type_info = new String[]{'apexClass','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] connector_type_info = new String[]{'connector','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] faultConnector_type_info = new String[]{'faultConnector','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] inputParameters_type_info = new String[]{'inputParameters','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] outputParameters_type_info = new String[]{'outputParameters','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'processMetadataValues','description','name','label','locationX','locationY', 'apexClass','connector','faultConnector','inputParameters','outputParameters'};
    }
    public class Container {
        public Integer height;
        public Boolean isContainerAutoSizeEnabled;
        public String region;
        public MetadataService.SidebarComponent[] sidebarComponents;
        public String style;
        public String unit;
        public Integer width;
        private String[] height_type_info = new String[]{'height','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] isContainerAutoSizeEnabled_type_info = new String[]{'isContainerAutoSizeEnabled','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] region_type_info = new String[]{'region','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] sidebarComponents_type_info = new String[]{'sidebarComponents','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] style_type_info = new String[]{'style','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] unit_type_info = new String[]{'unit','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] width_type_info = new String[]{'width','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'height','isContainerAutoSizeEnabled','region','sidebarComponents','style','unit','width'};
    }
    public class FeedLayout {
        public Boolean autocollapsePublisher;
        public Boolean compactFeed;
        public String feedFilterPosition;
        public MetadataService.FeedLayoutFilter[] feedFilters;
        public Boolean fullWidthFeed;
        public Boolean hideSidebar;
        public Boolean highlightExternalFeedItems;
        public MetadataService.FeedLayoutComponent[] leftComponents;
        public MetadataService.FeedLayoutComponent[] rightComponents;
        public Boolean useInlineFiltersInConsole;
        private String[] autocollapsePublisher_type_info = new String[]{'autocollapsePublisher','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] compactFeed_type_info = new String[]{'compactFeed','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] feedFilterPosition_type_info = new String[]{'feedFilterPosition','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] feedFilters_type_info = new String[]{'feedFilters','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] fullWidthFeed_type_info = new String[]{'fullWidthFeed','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] hideSidebar_type_info = new String[]{'hideSidebar','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] highlightExternalFeedItems_type_info = new String[]{'highlightExternalFeedItems','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] leftComponents_type_info = new String[]{'leftComponents','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] rightComponents_type_info = new String[]{'rightComponents','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] useInlineFiltersInConsole_type_info = new String[]{'useInlineFiltersInConsole','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'autocollapsePublisher','compactFeed','feedFilterPosition','feedFilters','fullWidthFeed','hideSidebar','highlightExternalFeedItems','leftComponents','rightComponents','useInlineFiltersInConsole'};
    }
    public class NetworkAccess {
        public MetadataService.IpRange[] ipRanges;
        private String[] ipRanges_type_info = new String[]{'ipRanges','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'ipRanges'};
    }
    public class IdeasSettings extends Metadata {
        public String type = 'IdeasSettings';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Boolean enableChatterProfile;
        public Boolean enableIdeaThemes;
        public Boolean enableIdeas;
        public Boolean enableIdeasReputation;
        public Double halfLife;
        public String ideasProfilePage;
        private String[] enableChatterProfile_type_info = new String[]{'enableChatterProfile','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableIdeaThemes_type_info = new String[]{'enableIdeaThemes','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableIdeas_type_info = new String[]{'enableIdeas','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableIdeasReputation_type_info = new String[]{'enableIdeasReputation','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] halfLife_type_info = new String[]{'halfLife','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] ideasProfilePage_type_info = new String[]{'ideasProfilePage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'enableChatterProfile','enableIdeaThemes','enableIdeas','enableIdeasReputation','halfLife','ideasProfilePage'};
    }
    public class CustomDataTypeTranslation {
        public MetadataService.CustomDataTypeComponentTranslation[] components;
        public String customDataTypeName;
        public String description;
        public String label;
        private String[] components_type_info = new String[]{'components','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] customDataTypeName_type_info = new String[]{'customDataTypeName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'components','customDataTypeName','description','label'};
    }
    public class readMetadata_element {
        public String type_x;
        public String[] fullNames;
        private String[] type_x_type_info = new String[]{'type','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] fullNames_type_info = new String[]{'fullNames','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'type_x','fullNames'};
    }
    public class PostTemplate extends Metadata {
        public String type = 'PostTemplate';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Boolean default_x;
        public String description;
        public String[] fields;
        public String label;
        private String[] default_x_type_info = new String[]{'default','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] fields_type_info = new String[]{'fields','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'default_x','description','fields','label'};
    }
    public class QuickActionList {
        public MetadataService.QuickActionListItem[] quickActionListItems;
        private String[] quickActionListItems_type_info = new String[]{'quickActionListItems','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'quickActionListItems'};
    }
    public class FlexiPageRegion {
        public String appendable;
        public MetadataService.ComponentInstance[] componentInstances;
        public String mode;
        public String name;
        public String prependable;
        public String replaceable;
        public String type_x;
        private String[] appendable_type_info = new String[]{'appendable','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] componentInstances_type_info = new String[]{'componentInstances','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] mode_type_info = new String[]{'mode','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] prependable_type_info = new String[]{'prependable','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] replaceable_type_info = new String[]{'replaceable','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] type_x_type_info = new String[]{'type','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'appendable','componentInstances','mode','name','prependable','replaceable','type_x'};
    }
    public class PrimaryTabComponents {
        public MetadataService.Container[] containers;
        private String[] containers_type_info = new String[]{'containers','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'containers'};
    }
    public class Territory {
        public String accountAccessLevel;
        public String parentTerritory;
        private String[] accountAccessLevel_type_info = new String[]{'accountAccessLevel','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] parentTerritory_type_info = new String[]{'parentTerritory','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'accountAccessLevel','parentTerritory'};
    }
    public class updateMetadataResponse_element {
        public MetadataService.SaveResult[] result;
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class FolderShare {
        public String accessLevel;
        public String sharedTo;
        public String sharedToType;
        private String[] accessLevel_type_info = new String[]{'accessLevel','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] sharedTo_type_info = new String[]{'sharedTo','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] sharedToType_type_info = new String[]{'sharedToType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'accessLevel','sharedTo','sharedToType'};
    }
    public class QuickActionListItem {
        public String quickActionName;
        private String[] quickActionName_type_info = new String[]{'quickActionName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'quickActionName'};
    }
    public class SiteDotCom extends MetadataWithContent {
        public String type = 'SiteDotCom';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String content;
        private String[] content_type_info = new String[]{'content','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String label;
        public String siteType;
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] siteType_type_info = new String[]{'siteType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName','content', 'label','siteType'};
    }
    public class MobileSettings extends Metadata {
        public String type = 'MobileSettings';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public MetadataService.ChatterMobileSettings chatterMobile;
        public MetadataService.DashboardMobileSettings dashboardMobile;
        public MetadataService.SFDCMobileSettings salesforceMobile;
        public MetadataService.TouchMobileSettings touchMobile;
        private String[] chatterMobile_type_info = new String[]{'chatterMobile','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] dashboardMobile_type_info = new String[]{'dashboardMobile','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] salesforceMobile_type_info = new String[]{'salesforceMobile','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] touchMobile_type_info = new String[]{'touchMobile','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'chatterMobile','dashboardMobile','salesforceMobile','touchMobile'};
    }
    public class DescribeValueTypeResult {
        public MetadataService.ValueTypeField[] valueTypeFields;
        private String[] valueTypeFields_type_info = new String[]{'valueTypeFields','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'valueTypeFields'};
    }
    public class EntitlementSettings extends Metadata {
        public String type = 'EntitlementSettings';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Boolean assetLookupLimitedToActiveEntitlementsOnAccount;
        public Boolean assetLookupLimitedToActiveEntitlementsOnContact;
        public Boolean assetLookupLimitedToSameAccount;
        public Boolean assetLookupLimitedToSameContact;
        public Boolean enableEntitlementVersioning;
        public Boolean enableEntitlements;
        public Boolean entitlementLookupLimitedToActiveStatus;
        public Boolean entitlementLookupLimitedToSameAccount;
        public Boolean entitlementLookupLimitedToSameAsset;
        public Boolean entitlementLookupLimitedToSameContact;
        private String[] assetLookupLimitedToActiveEntitlementsOnAccount_type_info = new String[]{'assetLookupLimitedToActiveEntitlementsOnAccount','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] assetLookupLimitedToActiveEntitlementsOnContact_type_info = new String[]{'assetLookupLimitedToActiveEntitlementsOnContact','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] assetLookupLimitedToSameAccount_type_info = new String[]{'assetLookupLimitedToSameAccount','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] assetLookupLimitedToSameContact_type_info = new String[]{'assetLookupLimitedToSameContact','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableEntitlementVersioning_type_info = new String[]{'enableEntitlementVersioning','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] enableEntitlements_type_info = new String[]{'enableEntitlements','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] entitlementLookupLimitedToActiveStatus_type_info = new String[]{'entitlementLookupLimitedToActiveStatus','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] entitlementLookupLimitedToSameAccount_type_info = new String[]{'entitlementLookupLimitedToSameAccount','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] entitlementLookupLimitedToSameAsset_type_info = new String[]{'entitlementLookupLimitedToSameAsset','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] entitlementLookupLimitedToSameContact_type_info = new String[]{'entitlementLookupLimitedToSameContact','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'assetLookupLimitedToActiveEntitlementsOnAccount','assetLookupLimitedToActiveEntitlementsOnContact','assetLookupLimitedToSameAccount','assetLookupLimitedToSameContact','enableEntitlementVersioning','enableEntitlements','entitlementLookupLimitedToActiveStatus','entitlementLookupLimitedToSameAccount','entitlementLookupLimitedToSameAsset','entitlementLookupLimitedToSameContact'};
    }
    public class Territory2RuleAssociation {
        public Boolean inherited;
        public String ruleName;
        private String[] inherited_type_info = new String[]{'inherited','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] ruleName_type_info = new String[]{'ruleName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'inherited','ruleName'};
    }
    public class PermissionSetCustomPermissions {
        public Boolean enabled;
        public String name;
        private String[] enabled_type_info = new String[]{'enabled','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'enabled','name'};
    }
    public class CustomApplicationComponent extends Metadata {
        public String type = 'CustomApplicationComponent';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String buttonIconUrl;
        public String buttonStyle;
        public String buttonText;
        public Integer buttonWidth;
        public Integer height;
        public Boolean isHeightFixed;
        public Boolean isHidden;
        public Boolean isWidthFixed;
        public String visualforcePage;
        public Integer width;
        private String[] buttonIconUrl_type_info = new String[]{'buttonIconUrl','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] buttonStyle_type_info = new String[]{'buttonStyle','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] buttonText_type_info = new String[]{'buttonText','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] buttonWidth_type_info = new String[]{'buttonWidth','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] height_type_info = new String[]{'height','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] isHeightFixed_type_info = new String[]{'isHeightFixed','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] isHidden_type_info = new String[]{'isHidden','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] isWidthFixed_type_info = new String[]{'isWidthFixed','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] visualforcePage_type_info = new String[]{'visualforcePage','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] width_type_info = new String[]{'width','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'buttonIconUrl','buttonStyle','buttonText','buttonWidth','height','isHeightFixed','isHidden','isWidthFixed','visualforcePage','width'};
    }
    public class ComponentInstanceProperty {
        public String name;
        public String value;
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] value_type_info = new String[]{'value','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'name','value'};
    }
    public class ChatterMobileSettings {
        public Boolean enablePushNotifications;
        private String[] enablePushNotifications_type_info = new String[]{'enablePushNotifications','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'enablePushNotifications'};
    }
    public class WorkflowAlert extends WorkflowAction {
        public String type = 'WorkflowAlert';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String[] ccEmails;
        public String description;
        public Boolean protected_x;
        public MetadataService.WorkflowEmailRecipient[] recipients;
        public String senderAddress;
        public String senderType;
        public String template;
        private String[] ccEmails_type_info = new String[]{'ccEmails','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] protected_x_type_info = new String[]{'protected','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] recipients_type_info = new String[]{'recipients','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] senderAddress_type_info = new String[]{'senderAddress','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] senderType_type_info = new String[]{'senderType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] template_type_info = new String[]{'template','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'ccEmails','description','protected_x','recipients','senderAddress','senderType','template'};
    }
    public class EmailTemplate extends MetadataWithContent {
        public String type = 'EmailTemplate';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String content;
        private String[] content_type_info = new String[]{'content','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Double apiVersion;
        public String[] attachedDocuments;
        public MetadataService.Attachment[] attachments;
        public Boolean available;
        public String description;
        public String encodingKey;
        public String letterhead;
        public String name;
        public MetadataService.PackageVersion[] packageVersions;
        public String style;
        public String subject;
        public String textOnly;
        public String type_x;
        private String[] apiVersion_type_info = new String[]{'apiVersion','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] attachedDocuments_type_info = new String[]{'attachedDocuments','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] attachments_type_info = new String[]{'attachments','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] available_type_info = new String[]{'available','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] encodingKey_type_info = new String[]{'encodingKey','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] letterhead_type_info = new String[]{'letterhead','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] packageVersions_type_info = new String[]{'packageVersions','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] style_type_info = new String[]{'style','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] subject_type_info = new String[]{'subject','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] textOnly_type_info = new String[]{'textOnly','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] type_x_type_info = new String[]{'type','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName','content', 'apiVersion','attachedDocuments','attachments','available','description','encodingKey','letterhead','name','packageVersions','style','subject','textOnly','type_x'};
    }
    public class FlowTextTemplate extends FlowElement {
        public String type = 'FlowTextTemplate';
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        public String description;
        public String name;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        public String text;
        private String[] text_type_info = new String[]{'text','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'processMetadataValues','description','name', 'text'};
    }
    public class PushNotification {
        public String[] fieldNames;
        public String objectName;
        private String[] fieldNames_type_info = new String[]{'fieldNames','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] objectName_type_info = new String[]{'objectName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'fieldNames','objectName'};
    }
    public class TransactionSecurityPolicy {
        public MetadataService.TransactionSecurityAction action;
        public Boolean active;
        public String apexClass;
        public String eventType;
        public String executionUser;
        public String resourceName;
        private String[] action_type_info = new String[]{'action','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] active_type_info = new String[]{'active','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apexClass_type_info = new String[]{'apexClass','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] eventType_type_info = new String[]{'eventType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] executionUser_type_info = new String[]{'executionUser','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] resourceName_type_info = new String[]{'resourceName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'action','active','apexClass','eventType','executionUser','resourceName'};
    }
    public class FlowScreen extends FlowNode {
        public String type = 'FlowScreen';
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        public String description;
        public String name;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        public String label;
        public Integer locationX;
        public Integer locationY;
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] locationX_type_info = new String[]{'locationX','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] locationY_type_info = new String[]{'locationY','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        public Boolean allowBack;
        public Boolean allowFinish;
        public Boolean allowPause;
        public MetadataService.FlowConnector connector;
        public MetadataService.FlowScreenField[] fields;
        public String helpText;
        public String pausedText;
        private String[] allowBack_type_info = new String[]{'allowBack','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] allowFinish_type_info = new String[]{'allowFinish','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] allowPause_type_info = new String[]{'allowPause','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] connector_type_info = new String[]{'connector','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] fields_type_info = new String[]{'fields','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] helpText_type_info = new String[]{'helpText','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] pausedText_type_info = new String[]{'pausedText','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'processMetadataValues','description','name','label','locationX','locationY', 'allowBack','allowFinish','allowPause','connector','fields','helpText','pausedText'};
    }
    public class OpportunityListFieldsSelectedSettings {
        public String[] field;
        private String[] field_type_info = new String[]{'field','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'field'};
    }
    public class AccessMapping {
        public String accessLevel;
        public String object_x;
        public String objectField;
        public String userField;
        private String[] accessLevel_type_info = new String[]{'accessLevel','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] object_x_type_info = new String[]{'object','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] objectField_type_info = new String[]{'objectField','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] userField_type_info = new String[]{'userField','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'accessLevel','object_x','objectField','userField'};
    }
    public class AnalyticSnapshotMapping {
        public String aggregateType;
        public String sourceField;
        public String sourceType;
        public String targetField;
        private String[] aggregateType_type_info = new String[]{'aggregateType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] sourceField_type_info = new String[]{'sourceField','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] sourceType_type_info = new String[]{'sourceType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] targetField_type_info = new String[]{'targetField','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'aggregateType','sourceField','sourceType','targetField'};
    }
    public class DefaultShortcut {
        public String action;
        public Boolean active;
        public String keyCommand;
        private String[] action_type_info = new String[]{'action','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] active_type_info = new String[]{'active','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] keyCommand_type_info = new String[]{'keyCommand','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'action','active','keyCommand'};
    }
    public class WorkspaceMapping {
        public String fieldName;
        public String tab;
        private String[] fieldName_type_info = new String[]{'fieldName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] tab_type_info = new String[]{'tab','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'fieldName','tab'};
    }
    public class WorkflowSend extends WorkflowAction {
        public String type = 'WorkflowSend';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String action;
        public String description;
        public String label;
        public String language;
        public Boolean protected_x;
        private String[] action_type_info = new String[]{'action','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] language_type_info = new String[]{'language','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] protected_x_type_info = new String[]{'protected','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'action','description','label','language','protected_x'};
    }
    public class FlowRecordFilter extends FlowBaseElement {
        public String type = 'FlowRecordFilter';
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        public String field;
        public String operator;
        public MetadataService.FlowElementReferenceOrValue value;
        private String[] field_type_info = new String[]{'field','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] operator_type_info = new String[]{'operator','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] value_type_info = new String[]{'value','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'processMetadataValues', 'field','operator','value'};
    }
    public class deleteMetadata_element {
        public String type_x;
        public String[] fullNames;
        private String[] type_x_type_info = new String[]{'type','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] fullNames_type_info = new String[]{'fullNames','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'type_x','fullNames'};
    }
    public class ForecastRangeSettings {
        public Integer beginning;
        public Integer displaying;
        public String periodType;
        private String[] beginning_type_info = new String[]{'beginning','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] displaying_type_info = new String[]{'displaying','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] periodType_type_info = new String[]{'periodType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'beginning','displaying','periodType'};
    }
    public class FlowActionCall extends FlowNode {
        public String type = 'FlowActionCall';
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        public String description;
        public String name;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        public String label;
        public Integer locationX;
        public Integer locationY;
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] locationX_type_info = new String[]{'locationX','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] locationY_type_info = new String[]{'locationY','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        public String actionName;
        public String actionType;
        public MetadataService.FlowConnector connector;
        public MetadataService.FlowConnector faultConnector;
        public MetadataService.FlowActionCallInputParameter[] inputParameters;
        public MetadataService.FlowActionCallOutputParameter[] outputParameters;
        private String[] actionName_type_info = new String[]{'actionName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] actionType_type_info = new String[]{'actionType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] connector_type_info = new String[]{'connector','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] faultConnector_type_info = new String[]{'faultConnector','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] inputParameters_type_info = new String[]{'inputParameters','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] outputParameters_type_info = new String[]{'outputParameters','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'processMetadataValues','description','name','label','locationX','locationY', 'actionName','actionType','connector','faultConnector','inputParameters','outputParameters'};
    }
    public class ListViewFilter {
        public String field;
        public String operation;
        public String value;
        private String[] field_type_info = new String[]{'field','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] operation_type_info = new String[]{'operation','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] value_type_info = new String[]{'value','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'field','operation','value'};
    }
    public class DashboardTableColumn {
        public String aggregateType;
        public Boolean calculatePercent;
        public String column;
        public Integer decimalPlaces;
        public Boolean showTotal;
        public String sortBy;
        private String[] aggregateType_type_info = new String[]{'aggregateType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] calculatePercent_type_info = new String[]{'calculatePercent','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] column_type_info = new String[]{'column','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] decimalPlaces_type_info = new String[]{'decimalPlaces','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showTotal_type_info = new String[]{'showTotal','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] sortBy_type_info = new String[]{'sortBy','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'aggregateType','calculatePercent','column','decimalPlaces','showTotal','sortBy'};
    }
    public class Territory2 extends Metadata {
        public String type = 'Territory2';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String accountAccessLevel;
        public String caseAccessLevel;
        public String contactAccessLevel;
        public MetadataService.FieldValue[] customFields;
        public String description;
        public String name;
        public String opportunityAccessLevel;
        public String parentTerritory;
        public MetadataService.Territory2RuleAssociation[] ruleAssociations;
        public String territory2Type;
        private String[] accountAccessLevel_type_info = new String[]{'accountAccessLevel','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] caseAccessLevel_type_info = new String[]{'caseAccessLevel','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] contactAccessLevel_type_info = new String[]{'contactAccessLevel','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] customFields_type_info = new String[]{'customFields','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] opportunityAccessLevel_type_info = new String[]{'opportunityAccessLevel','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] parentTerritory_type_info = new String[]{'parentTerritory','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] ruleAssociations_type_info = new String[]{'ruleAssociations','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] territory2Type_type_info = new String[]{'territory2Type','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'accountAccessLevel','caseAccessLevel','contactAccessLevel','customFields','description','name','opportunityAccessLevel','parentTerritory','ruleAssociations','territory2Type'};
    }
    public class ListPlacement {
        public Integer height;
        public String location;
        public String units;
        public Integer width;
        private String[] height_type_info = new String[]{'height','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] location_type_info = new String[]{'location','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] units_type_info = new String[]{'units','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] width_type_info = new String[]{'width','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'height','location','units','width'};
    }
    public class PicklistEntry {
        public Boolean active;
        public Boolean defaultValue;
        public String label;
        public String validFor;
        public String value;
        private String[] active_type_info = new String[]{'active','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] defaultValue_type_info = new String[]{'defaultValue','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] validFor_type_info = new String[]{'validFor','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] value_type_info = new String[]{'value','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'active','defaultValue','label','validFor','value'};
    }
    public class ReportBucketField {
        public String bucketType;
        public String developerName;
        public String masterLabel;
        public String nullTreatment;
        public String otherBucketLabel;
        public String sourceColumnName;
        public Boolean useOther;
        public MetadataService.ReportBucketFieldValue[] values;
        private String[] bucketType_type_info = new String[]{'bucketType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] developerName_type_info = new String[]{'developerName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] masterLabel_type_info = new String[]{'masterLabel','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] nullTreatment_type_info = new String[]{'nullTreatment','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] otherBucketLabel_type_info = new String[]{'otherBucketLabel','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] sourceColumnName_type_info = new String[]{'sourceColumnName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] useOther_type_info = new String[]{'useOther','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] values_type_info = new String[]{'values','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'bucketType','developerName','masterLabel','nullTreatment','otherBucketLabel','sourceColumnName','useOther','values'};
    }
    public class KnowledgeCommunitiesSettings {
        public String[] community;
        private String[] community_type_info = new String[]{'community','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'community'};
    }
    public class OpportunitySettings extends Metadata {
        public String type = 'OpportunitySettings';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Boolean autoActivateNewReminders;
        public Boolean enableFindSimilarOpportunities;
        public Boolean enableOpportunityTeam;
        public Boolean enableUpdateReminders;
        public MetadataService.FindSimilarOppFilter findSimilarOppFilter;
        public Boolean promptToAddProducts;
        private String[] autoActivateNewReminders_type_info = new String[]{'autoActivateNewReminders','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableFindSimilarOpportunities_type_info = new String[]{'enableFindSimilarOpportunities','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableOpportunityTeam_type_info = new String[]{'enableOpportunityTeam','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableUpdateReminders_type_info = new String[]{'enableUpdateReminders','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] findSimilarOppFilter_type_info = new String[]{'findSimilarOppFilter','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] promptToAddProducts_type_info = new String[]{'promptToAddProducts','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'autoActivateNewReminders','enableFindSimilarOpportunities','enableOpportunityTeam','enableUpdateReminders','findSimilarOppFilter','promptToAddProducts'};
    }
    public class CodeCoverageWarning {
        public String id;
        public String message;
        public String name;
        public String namespace;
        private String[] id_type_info = new String[]{'id','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] message_type_info = new String[]{'message','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','true'};
        private String[] namespace_type_info = new String[]{'namespace','http://soap.sforce.com/2006/04/metadata',null,'1','1','true'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'id','message','name','namespace'};
    }
    public class CustomLabelTranslation {
        public String label;
        public String name;
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'label','name'};
    }
    public class KnowledgeAnswerSettings {
        public String assignTo;
        public String defaultArticleType;
        public Boolean enableArticleCreation;
        private String[] assignTo_type_info = new String[]{'assignTo','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] defaultArticleType_type_info = new String[]{'defaultArticleType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableArticleCreation_type_info = new String[]{'enableArticleCreation','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'assignTo','defaultArticleType','enableArticleCreation'};
    }
    public class Letterhead extends Metadata {
        public String type = 'Letterhead';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Boolean available;
        public String backgroundColor;
        public String bodyColor;
        public MetadataService.LetterheadLine bottomLine;
        public String description;
        public MetadataService.LetterheadHeaderFooter footer;
        public MetadataService.LetterheadHeaderFooter header;
        public MetadataService.LetterheadLine middleLine;
        public String name;
        public MetadataService.LetterheadLine topLine;
        private String[] available_type_info = new String[]{'available','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] backgroundColor_type_info = new String[]{'backgroundColor','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] bodyColor_type_info = new String[]{'bodyColor','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] bottomLine_type_info = new String[]{'bottomLine','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] footer_type_info = new String[]{'footer','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] header_type_info = new String[]{'header','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] middleLine_type_info = new String[]{'middleLine','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] topLine_type_info = new String[]{'topLine','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'available','backgroundColor','bodyColor','bottomLine','description','footer','header','middleLine','name','topLine'};
    }
    public class AddressSettings extends Metadata {
        public String type = 'AddressSettings';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public MetadataService.CountriesAndStates countriesAndStates;
        private String[] countriesAndStates_type_info = new String[]{'countriesAndStates','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'countriesAndStates'};
    }
    public class FlowApexPluginCallInputParameter extends FlowBaseElement {
        public String type = 'FlowApexPluginCallInputParameter';
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        public String name;
        public MetadataService.FlowElementReferenceOrValue value;
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] value_type_info = new String[]{'value','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'processMetadataValues', 'name','value'};
    }
    public class PathAssistantSettings {
        public Boolean pathAssistantEnabled;
        private String[] pathAssistantEnabled_type_info = new String[]{'pathAssistantEnabled','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'pathAssistantEnabled'};
    }
    public class QuoteSettings extends Metadata {
        public String type = 'QuoteSettings';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Boolean enableQuote;
        private String[] enableQuote_type_info = new String[]{'enableQuote','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'enableQuote'};
    }
    public class BusinessHoursEntry extends Metadata {
        public String type = 'BusinessHoursEntry';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Boolean active;
        public Boolean default_x;
        public DateTime fridayEndTime;
        public DateTime fridayStartTime;
        public DateTime mondayEndTime;
        public DateTime mondayStartTime;
        public String name;
        public DateTime saturdayEndTime;
        public DateTime saturdayStartTime;
        public DateTime sundayEndTime;
        public DateTime sundayStartTime;
        public DateTime thursdayEndTime;
        public DateTime thursdayStartTime;
        public String timeZoneId;
        public DateTime tuesdayEndTime;
        public DateTime tuesdayStartTime;
        public DateTime wednesdayEndTime;
        public DateTime wednesdayStartTime;
        private String[] active_type_info = new String[]{'active','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] default_x_type_info = new String[]{'default','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] fridayEndTime_type_info = new String[]{'fridayEndTime','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] fridayStartTime_type_info = new String[]{'fridayStartTime','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] mondayEndTime_type_info = new String[]{'mondayEndTime','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] mondayStartTime_type_info = new String[]{'mondayStartTime','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] saturdayEndTime_type_info = new String[]{'saturdayEndTime','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] saturdayStartTime_type_info = new String[]{'saturdayStartTime','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] sundayEndTime_type_info = new String[]{'sundayEndTime','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] sundayStartTime_type_info = new String[]{'sundayStartTime','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] thursdayEndTime_type_info = new String[]{'thursdayEndTime','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] thursdayStartTime_type_info = new String[]{'thursdayStartTime','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] timeZoneId_type_info = new String[]{'timeZoneId','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] tuesdayEndTime_type_info = new String[]{'tuesdayEndTime','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] tuesdayStartTime_type_info = new String[]{'tuesdayStartTime','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] wednesdayEndTime_type_info = new String[]{'wednesdayEndTime','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] wednesdayStartTime_type_info = new String[]{'wednesdayStartTime','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'active','default_x','fridayEndTime','fridayStartTime','mondayEndTime','mondayStartTime','name','saturdayEndTime','saturdayStartTime','sundayEndTime','sundayStartTime','thursdayEndTime','thursdayStartTime','timeZoneId','tuesdayEndTime','tuesdayStartTime','wednesdayEndTime','wednesdayStartTime'};
    }
    public class NetworkMemberGroup {
        public String[] permissionSet;
        public String[] profile;
        private String[] permissionSet_type_info = new String[]{'permissionSet','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] profile_type_info = new String[]{'profile','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'permissionSet','profile'};
    }
    public class ApexPage extends MetadataWithContent {
        public String type = 'ApexPage';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String content;
        private String[] content_type_info = new String[]{'content','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Double apiVersion;
        public Boolean availableInTouch;
        public Boolean confirmationTokenRequired;
        public String description;
        public String label;
        public MetadataService.PackageVersion[] packageVersions;
        private String[] apiVersion_type_info = new String[]{'apiVersion','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] availableInTouch_type_info = new String[]{'availableInTouch','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] confirmationTokenRequired_type_info = new String[]{'confirmationTokenRequired','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] packageVersions_type_info = new String[]{'packageVersions','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName','content', 'apiVersion','availableInTouch','confirmationTokenRequired','description','label','packageVersions'};
    }
    public class CustomSite extends Metadata {
        public String type = 'CustomSite';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Boolean active;
        public Boolean allowHomePage;
        public Boolean allowStandardAnswersPages;
        public Boolean allowStandardIdeasPages;
        public Boolean allowStandardLookups;
        public Boolean allowStandardSearch;
        public String analyticsTrackingCode;
        public String authorizationRequiredPage;
        public String bandwidthExceededPage;
        public String changePasswordPage;
        public String chatterAnswersForgotPasswordConfirmPage;
        public String chatterAnswersForgotPasswordPage;
        public String chatterAnswersHelpPage;
        public String chatterAnswersLoginPage;
        public String chatterAnswersRegistrationPage;
        public String clickjackProtectionLevel;
        public MetadataService.SiteWebAddress[] customWebAddresses;
        public String description;
        public String favoriteIcon;
        public String fileNotFoundPage;
        public String forgotPasswordPage;
        public String genericErrorPage;
        public String guestProfile;
        public String inMaintenancePage;
        public String inactiveIndexPage;
        public String indexPage;
        public String masterLabel;
        public String myProfilePage;
        public String portal;
        public Boolean requireHttps;
        public Boolean requireInsecurePortalAccess;
        public String robotsTxtPage;
        public String rootComponent;
        public String selfRegPage;
        public String serverIsDown;
        public String siteAdmin;
        public MetadataService.SiteRedirectMapping[] siteRedirectMappings;
        public String siteTemplate;
        public String siteType;
        public String subdomain;
        public String urlPathPrefix;
        private String[] active_type_info = new String[]{'active','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] allowHomePage_type_info = new String[]{'allowHomePage','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] allowStandardAnswersPages_type_info = new String[]{'allowStandardAnswersPages','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] allowStandardIdeasPages_type_info = new String[]{'allowStandardIdeasPages','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] allowStandardLookups_type_info = new String[]{'allowStandardLookups','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] allowStandardSearch_type_info = new String[]{'allowStandardSearch','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] analyticsTrackingCode_type_info = new String[]{'analyticsTrackingCode','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] authorizationRequiredPage_type_info = new String[]{'authorizationRequiredPage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] bandwidthExceededPage_type_info = new String[]{'bandwidthExceededPage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] changePasswordPage_type_info = new String[]{'changePasswordPage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] chatterAnswersForgotPasswordConfirmPage_type_info = new String[]{'chatterAnswersForgotPasswordConfirmPage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] chatterAnswersForgotPasswordPage_type_info = new String[]{'chatterAnswersForgotPasswordPage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] chatterAnswersHelpPage_type_info = new String[]{'chatterAnswersHelpPage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] chatterAnswersLoginPage_type_info = new String[]{'chatterAnswersLoginPage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] chatterAnswersRegistrationPage_type_info = new String[]{'chatterAnswersRegistrationPage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] clickjackProtectionLevel_type_info = new String[]{'clickjackProtectionLevel','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] customWebAddresses_type_info = new String[]{'customWebAddresses','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] favoriteIcon_type_info = new String[]{'favoriteIcon','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] fileNotFoundPage_type_info = new String[]{'fileNotFoundPage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] forgotPasswordPage_type_info = new String[]{'forgotPasswordPage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] genericErrorPage_type_info = new String[]{'genericErrorPage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] guestProfile_type_info = new String[]{'guestProfile','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] inMaintenancePage_type_info = new String[]{'inMaintenancePage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] inactiveIndexPage_type_info = new String[]{'inactiveIndexPage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] indexPage_type_info = new String[]{'indexPage','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] masterLabel_type_info = new String[]{'masterLabel','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] myProfilePage_type_info = new String[]{'myProfilePage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] portal_type_info = new String[]{'portal','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] requireHttps_type_info = new String[]{'requireHttps','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] requireInsecurePortalAccess_type_info = new String[]{'requireInsecurePortalAccess','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] robotsTxtPage_type_info = new String[]{'robotsTxtPage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] rootComponent_type_info = new String[]{'rootComponent','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] selfRegPage_type_info = new String[]{'selfRegPage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] serverIsDown_type_info = new String[]{'serverIsDown','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] siteAdmin_type_info = new String[]{'siteAdmin','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] siteRedirectMappings_type_info = new String[]{'siteRedirectMappings','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] siteTemplate_type_info = new String[]{'siteTemplate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] siteType_type_info = new String[]{'siteType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] subdomain_type_info = new String[]{'subdomain','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] urlPathPrefix_type_info = new String[]{'urlPathPrefix','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'active','allowHomePage','allowStandardAnswersPages','allowStandardIdeasPages','allowStandardLookups','allowStandardSearch','analyticsTrackingCode','authorizationRequiredPage','bandwidthExceededPage','changePasswordPage','chatterAnswersForgotPasswordConfirmPage','chatterAnswersForgotPasswordPage','chatterAnswersHelpPage','chatterAnswersLoginPage','chatterAnswersRegistrationPage','clickjackProtectionLevel','customWebAddresses','description','favoriteIcon','fileNotFoundPage','forgotPasswordPage','genericErrorPage','guestProfile','inMaintenancePage','inactiveIndexPage','indexPage','masterLabel','myProfilePage','portal','requireHttps','requireInsecurePortalAccess','robotsTxtPage','rootComponent','selfRegPage','serverIsDown','siteAdmin','siteRedirectMappings','siteTemplate','siteType','subdomain','urlPathPrefix'};
    }
    public class Skill extends Metadata {
        public String type = 'Skill';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public MetadataService.SkillAssignments assignments;
        public String label;
        private String[] assignments_type_info = new String[]{'assignments','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'assignments','label'};
    }
    public class renameMetadataResponse_element {
        public MetadataService.SaveResult result;
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class RelatedList {
        public Boolean hideOnDetail;
        public String name;
        private String[] hideOnDetail_type_info = new String[]{'hideOnDetail','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'hideOnDetail','name'};
    }
    public class SynonymGroup {
        public String[] languages;
        public String[] terms;
        private String[] languages_type_info = new String[]{'languages','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] terms_type_info = new String[]{'terms','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'languages','terms'};
    }
    public class FlowSubflow extends FlowNode {
        public String type = 'FlowSubflow';
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        public String description;
        public String name;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        public String label;
        public Integer locationX;
        public Integer locationY;
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] locationX_type_info = new String[]{'locationX','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] locationY_type_info = new String[]{'locationY','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        public MetadataService.FlowConnector connector;
        public String flowName;
        public MetadataService.FlowSubflowInputAssignment[] inputAssignments;
        public MetadataService.FlowSubflowOutputAssignment[] outputAssignments;
        private String[] connector_type_info = new String[]{'connector','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] flowName_type_info = new String[]{'flowName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] inputAssignments_type_info = new String[]{'inputAssignments','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] outputAssignments_type_info = new String[]{'outputAssignments','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'processMetadataValues','description','name','label','locationX','locationY', 'connector','flowName','inputAssignments','outputAssignments'};
    }
    public class MatchingRule extends Metadata {
        public String type = 'MatchingRule';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String booleanFilter;
        public String description;
        public String label;
        public MetadataService.MatchingRuleItem[] matchingRuleItems;
        public String ruleStatus;
        private String[] booleanFilter_type_info = new String[]{'booleanFilter','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] matchingRuleItems_type_info = new String[]{'matchingRuleItems','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] ruleStatus_type_info = new String[]{'ruleStatus','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'booleanFilter','description','label','matchingRuleItems','ruleStatus'};
    }
    public class PasswordPolicies {
        public String apiOnlyUserHomePageURL;
        public String complexity;
        public String expiration;
        public String historyRestriction;
        public String lockoutInterval;
        public String maxLoginAttempts;
        public String minimumPasswordLength;
        public Boolean minimumPasswordLifetime;
        public Boolean obscureSecretAnswer;
        public String passwordAssistanceMessage;
        public String passwordAssistanceURL;
        public String questionRestriction;
        private String[] apiOnlyUserHomePageURL_type_info = new String[]{'apiOnlyUserHomePageURL','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] complexity_type_info = new String[]{'complexity','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] expiration_type_info = new String[]{'expiration','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] historyRestriction_type_info = new String[]{'historyRestriction','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] lockoutInterval_type_info = new String[]{'lockoutInterval','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] maxLoginAttempts_type_info = new String[]{'maxLoginAttempts','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] minimumPasswordLength_type_info = new String[]{'minimumPasswordLength','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] minimumPasswordLifetime_type_info = new String[]{'minimumPasswordLifetime','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] obscureSecretAnswer_type_info = new String[]{'obscureSecretAnswer','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] passwordAssistanceMessage_type_info = new String[]{'passwordAssistanceMessage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] passwordAssistanceURL_type_info = new String[]{'passwordAssistanceURL','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] questionRestriction_type_info = new String[]{'questionRestriction','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'apiOnlyUserHomePageURL','complexity','expiration','historyRestriction','lockoutInterval','maxLoginAttempts','minimumPasswordLength','minimumPasswordLifetime','obscureSecretAnswer','passwordAssistanceMessage','passwordAssistanceURL','questionRestriction'};
    }
    public class AnalyticsCloudComponentLayoutItem {
        public String assetType;
        public String devName;
        public String error;
        public String filter;
        public Integer height;
        public Boolean hideOnError;
        public Boolean showTitle;
        public String width;
        private String[] assetType_type_info = new String[]{'assetType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] devName_type_info = new String[]{'devName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] error_type_info = new String[]{'error','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] filter_type_info = new String[]{'filter','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] height_type_info = new String[]{'height','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] hideOnError_type_info = new String[]{'hideOnError','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showTitle_type_info = new String[]{'showTitle','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] width_type_info = new String[]{'width','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'assetType','devName','error','filter','height','hideOnError','showTitle','width'};
    }
    public class SFDCMobileSettings {
        public Boolean enableMobileLite;
        public Boolean enableUserToDeviceLinking;
        private String[] enableMobileLite_type_info = new String[]{'enableMobileLite','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableUserToDeviceLinking_type_info = new String[]{'enableUserToDeviceLinking','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'enableMobileLite','enableUserToDeviceLinking'};
    }
    public class SharingReason extends Metadata {
        public String type = 'SharingReason';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String label;
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'label'};
    }
    public class FlowDecision extends FlowNode {
        public String type = 'FlowDecision';
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        public String description;
        public String name;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        public String label;
        public Integer locationX;
        public Integer locationY;
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] locationX_type_info = new String[]{'locationX','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] locationY_type_info = new String[]{'locationY','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        public MetadataService.FlowConnector defaultConnector;
        public String defaultConnectorLabel;
        public MetadataService.FlowRule[] rules;
        private String[] defaultConnector_type_info = new String[]{'defaultConnector','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] defaultConnectorLabel_type_info = new String[]{'defaultConnectorLabel','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] rules_type_info = new String[]{'rules','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'processMetadataValues','description','name','label','locationX','locationY', 'defaultConnector','defaultConnectorLabel','rules'};
    }
    public class CustomFeedFilter {
        public MetadataService.FeedFilterCriterion[] criteria;
        public String description;
        public Boolean isProtected;
        public String label;
        private String[] criteria_type_info = new String[]{'criteria','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] isProtected_type_info = new String[]{'isProtected','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'criteria','description','isProtected','label'};
    }
    public class ProfileRecordTypeVisibility {
        public Boolean default_x;
        public Boolean personAccountDefault;
        public String recordType;
        public Boolean visible;
        private String[] default_x_type_info = new String[]{'default','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] personAccountDefault_type_info = new String[]{'personAccountDefault','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] recordType_type_info = new String[]{'recordType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] visible_type_info = new String[]{'visible','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'default_x','personAccountDefault','recordType','visible'};
    }
    public class DashboardMobileSettings {
        public Boolean enableDashboardIPadApp;
        private String[] enableDashboardIPadApp_type_info = new String[]{'enableDashboardIPadApp','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'enableDashboardIPadApp'};
    }
    public class SiteRedirectMapping {
        public String action;
        public Boolean isActive;
        public String source;
        public String target;
        private String[] action_type_info = new String[]{'action','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] isActive_type_info = new String[]{'isActive','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] source_type_info = new String[]{'source','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] target_type_info = new String[]{'target','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'action','isActive','source','target'};
    }
    public class AgentConfigProfileAssignments {
        public String[] profile;
        private String[] profile_type_info = new String[]{'profile','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'profile'};
    }
    public interface IReadResult {
        MetadataService.Metadata[] getRecords();
    }
    public interface IReadResponseElement {
        IReadResult getResult();
    }
    public class ReadCustomSiteResult implements IReadResult {
        public MetadataService.CustomSite[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readCustomSiteResponse_element implements IReadResponseElement {
        public MetadataService.ReadCustomSiteResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadListViewResult implements IReadResult {
        public MetadataService.ListView[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readListViewResponse_element implements IReadResponseElement {
        public MetadataService.ReadListViewResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadInstalledPackageResult implements IReadResult {
        public MetadataService.InstalledPackage[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readInstalledPackageResponse_element implements IReadResponseElement {
        public MetadataService.ReadInstalledPackageResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadCustomFieldResult implements IReadResult {
        public MetadataService.CustomField[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readCustomFieldResponse_element implements IReadResponseElement {
        public MetadataService.ReadCustomFieldResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadFieldSetResult implements IReadResult {
        public MetadataService.FieldSet[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readFieldSetResponse_element implements IReadResponseElement {
        public MetadataService.ReadFieldSetResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadPicklistValueResult implements IReadResult {
        public MetadataService.PicklistValue[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readPicklistValueResponse_element implements IReadResponseElement {
        public MetadataService.ReadPicklistValueResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadRecordTypeResult implements IReadResult {
        public MetadataService.RecordType[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readRecordTypeResponse_element implements IReadResponseElement {
        public MetadataService.ReadRecordTypeResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadWebLinkResult implements IReadResult {
        public MetadataService.WebLink[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readWebLinkResponse_element implements IReadResponseElement {
        public MetadataService.ReadWebLinkResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadAddressSettingsResult implements IReadResult {
        public MetadataService.AddressSettings[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readAddressSettingsResponse_element implements IReadResponseElement {
        public MetadataService.ReadAddressSettingsResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadCaseSettingsResult implements IReadResult {
        public MetadataService.CaseSettings[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readCaseSettingsResponse_element implements IReadResponseElement {
        public MetadataService.ReadCaseSettingsResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadCustomObjectResult implements IReadResult {
        public MetadataService.CustomObject[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readCustomObjectResponse_element implements IReadResponseElement {
        public MetadataService.ReadCustomObjectResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadLayoutResult implements IReadResult {
        public MetadataService.Layout[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readLayoutResponse_element implements IReadResponseElement {
        public MetadataService.ReadLayoutResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadEmailTemplateResult implements IReadResult {
        public MetadataService.EmailTemplate[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readEmailTemplateResponse_element implements IReadResponseElement {
        public MetadataService.ReadEmailTemplateResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadScontrolResult implements IReadResult {
        public MetadataService.Scontrol[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readScontrolResponse_element implements IReadResponseElement {
        public MetadataService.ReadScontrolResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadApexPageResult implements IReadResult {
        public MetadataService.ApexPage[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readApexPageResponse_element implements IReadResponseElement {
        public MetadataService.ReadApexPageResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadApexComponentResult implements IReadResult {
        public MetadataService.ApexComponent[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readApexComponentResponse_element implements IReadResponseElement {
        public MetadataService.ReadApexComponentResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadApexClassResult implements IReadResult {
        public MetadataService.ApexClass[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readApexClassResponse_element implements IReadResponseElement {
        public MetadataService.ReadApexClassResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadApexTriggerResult implements IReadResult {
        public MetadataService.ApexTrigger[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readApexTriggerResponse_element implements IReadResponseElement {
        public MetadataService.ReadApexTriggerResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadStaticResourceResult implements IReadResult {
        public MetadataService.StaticResource[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readStaticResourceResponse_element implements IReadResponseElement {
        public MetadataService.ReadStaticResourceResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadDocumentResult implements IReadResult {
        public MetadataService.Document[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readDocumentResponse_element implements IReadResponseElement {
        public MetadataService.ReadDocumentResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadCustomLabelsResult implements IReadResult {
        public MetadataService.CustomLabels[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readCustomLabelsResponse_element implements IReadResponseElement {
        public MetadataService.ReadCustomLabelsResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadCustomLabelResult implements IReadResult {
        public MetadataService.CustomLabel[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readCustomLabelResponse_element implements IReadResponseElement {
        public MetadataService.ReadCustomLabelResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadAccountSettingsResult implements IReadResult {
        public MetadataService.AccountSettings[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readAccountSettingsResponse_element implements IReadResponseElement {
        public MetadataService.ReadAccountSettingsResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadQueueResult implements IReadResult {
        public MetadataService.Queue[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readQueueResponse_element implements IReadResponseElement {
        public MetadataService.ReadQueueResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadCustomDataTypeResult implements IReadResult {
        public MetadataService.CustomDataType[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readCustomDataTypeResponse_element implements IReadResponseElement {
        public MetadataService.ReadCustomDataTypeResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadExternalDataSourceResult implements IReadResult {
        public MetadataService.ExternalDataSource[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readExternalDataSourceResponse_element implements IReadResponseElement {
        public MetadataService.ReadExternalDataSourceResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadGroupResult implements IReadResult {
        public MetadataService.Group_x[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readGroupResponse_element implements IReadResponseElement {
        public MetadataService.ReadGroupResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadBusinessProcessResult implements IReadResult {
        public MetadataService.BusinessProcess[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readBusinessProcessResponse_element implements IReadResponseElement {
        public MetadataService.ReadBusinessProcessResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadCompactLayoutResult implements IReadResult {
        public MetadataService.CompactLayout[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readCompactLayoutResponse_element implements IReadResponseElement {
        public MetadataService.ReadCompactLayoutResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadSharingReasonResult implements IReadResult {
        public MetadataService.SharingReason[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readSharingReasonResponse_element implements IReadResponseElement {
        public MetadataService.ReadSharingReasonResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadValidationRuleResult implements IReadResult {
        public MetadataService.ValidationRule[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readValidationRuleResponse_element implements IReadResponseElement {
        public MetadataService.ReadValidationRuleResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadReportTypeResult implements IReadResult {
        public MetadataService.ReportType[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readReportTypeResponse_element implements IReadResponseElement {
        public MetadataService.ReadReportTypeResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadReportResult implements IReadResult {
        public MetadataService.Report[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readReportResponse_element implements IReadResponseElement {
        public MetadataService.ReadReportResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadDashboardResult implements IReadResult {
        public MetadataService.Dashboard[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readDashboardResponse_element implements IReadResponseElement {
        public MetadataService.ReadDashboardResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadAnalyticSnapshotResult implements IReadResult {
        public MetadataService.AnalyticSnapshot[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readAnalyticSnapshotResponse_element implements IReadResponseElement {
        public MetadataService.ReadAnalyticSnapshotResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadCustomPageWebLinkResult implements IReadResult {
        public MetadataService.CustomPageWebLink[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readCustomPageWebLinkResponse_element implements IReadResponseElement {
        public MetadataService.ReadCustomPageWebLinkResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadQuickActionResult implements IReadResult {
        public MetadataService.QuickAction[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readQuickActionResponse_element implements IReadResponseElement {
        public MetadataService.ReadQuickActionResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadFlexiPageResult implements IReadResult {
        public MetadataService.FlexiPage[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readFlexiPageResponse_element implements IReadResponseElement {
        public MetadataService.ReadFlexiPageResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadCustomTabResult implements IReadResult {
        public MetadataService.CustomTab[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readCustomTabResponse_element implements IReadResponseElement {
        public MetadataService.ReadCustomTabResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadCustomApplicationComponentResult implements IReadResult {
        public MetadataService.CustomApplicationComponent[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readCustomApplicationComponentResponse_element implements IReadResponseElement {
        public MetadataService.ReadCustomApplicationComponentResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadCustomApplicationResult implements IReadResult {
        public MetadataService.CustomApplication[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readCustomApplicationResponse_element implements IReadResponseElement {
        public MetadataService.ReadCustomApplicationResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadPortalResult implements IReadResult {
        public MetadataService.Portal[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readPortalResponse_element implements IReadResponseElement {
        public MetadataService.ReadPortalResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadLetterheadResult implements IReadResult {
        public MetadataService.Letterhead[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readLetterheadResponse_element implements IReadResponseElement {
        public MetadataService.ReadLetterheadResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadFlowResult implements IReadResult {
        public MetadataService.Flow[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readFlowResponse_element implements IReadResponseElement {
        public MetadataService.ReadFlowResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadWorkflowResult implements IReadResult {
        public MetadataService.Workflow[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readWorkflowResponse_element implements IReadResponseElement {
        public MetadataService.ReadWorkflowResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadWorkflowRuleResult implements IReadResult {
        public MetadataService.WorkflowRule[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readWorkflowRuleResponse_element implements IReadResponseElement {
        public MetadataService.ReadWorkflowRuleResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadAssignmentRulesResult implements IReadResult {
        public MetadataService.AssignmentRules[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readAssignmentRulesResponse_element implements IReadResponseElement {
        public MetadataService.ReadAssignmentRulesResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadAssignmentRuleResult implements IReadResult {
        public MetadataService.AssignmentRule[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readAssignmentRuleResponse_element implements IReadResponseElement {
        public MetadataService.ReadAssignmentRuleResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadAutoResponseRulesResult implements IReadResult {
        public MetadataService.AutoResponseRules[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readAutoResponseRulesResponse_element implements IReadResponseElement {
        public MetadataService.ReadAutoResponseRulesResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadAutoResponseRuleResult implements IReadResult {
        public MetadataService.AutoResponseRule[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readAutoResponseRuleResponse_element implements IReadResponseElement {
        public MetadataService.ReadAutoResponseRuleResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadEscalationRulesResult implements IReadResult {
        public MetadataService.EscalationRules[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readEscalationRulesResponse_element implements IReadResponseElement {
        public MetadataService.ReadEscalationRulesResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadEscalationRuleResult implements IReadResult {
        public MetadataService.EscalationRule[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readEscalationRuleResponse_element implements IReadResponseElement {
        public MetadataService.ReadEscalationRuleResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadPostTemplateResult implements IReadResult {
        public MetadataService.PostTemplate[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readPostTemplateResponse_element implements IReadResponseElement {
        public MetadataService.ReadPostTemplateResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadApprovalProcessResult implements IReadResult {
        public MetadataService.ApprovalProcess[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readApprovalProcessResponse_element implements IReadResponseElement {
        public MetadataService.ReadApprovalProcessResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadHomePageComponentResult implements IReadResult {
        public MetadataService.HomePageComponent[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readHomePageComponentResponse_element implements IReadResponseElement {
        public MetadataService.ReadHomePageComponentResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadHomePageLayoutResult implements IReadResult {
        public MetadataService.HomePageLayout[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readHomePageLayoutResponse_element implements IReadResponseElement {
        public MetadataService.ReadHomePageLayoutResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadCustomObjectTranslationResult implements IReadResult {
        public MetadataService.CustomObjectTranslation[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readCustomObjectTranslationResponse_element implements IReadResponseElement {
        public MetadataService.ReadCustomObjectTranslationResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadTranslationsResult implements IReadResult {
        public MetadataService.Translations[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readTranslationsResponse_element implements IReadResponseElement {
        public MetadataService.ReadTranslationsResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadProfileResult implements IReadResult {
        public MetadataService.Profile[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readProfileResponse_element implements IReadResponseElement {
        public MetadataService.ReadProfileResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadPermissionSetResult implements IReadResult {
        public MetadataService.PermissionSet[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readPermissionSetResponse_element implements IReadResponseElement {
        public MetadataService.ReadPermissionSetResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadDataCategoryGroupResult implements IReadResult {
        public MetadataService.DataCategoryGroup[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readDataCategoryGroupResponse_element implements IReadResponseElement {
        public MetadataService.ReadDataCategoryGroupResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadRemoteSiteSettingResult implements IReadResult {
        public MetadataService.RemoteSiteSetting[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readRemoteSiteSettingResponse_element implements IReadResponseElement {
        public MetadataService.ReadRemoteSiteSettingResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadPackageResult implements IReadResult {
        public MetadataService.Package_x[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readPackageResponse_element implements IReadResponseElement {
        public MetadataService.ReadPackageResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadAuthProviderResult implements IReadResult {
        public MetadataService.AuthProvider[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readAuthProviderResponse_element implements IReadResponseElement {
        public MetadataService.ReadAuthProviderResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadKnowledgeSettingsResult implements IReadResult {
        public MetadataService.KnowledgeSettings[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readKnowledgeSettingsResponse_element implements IReadResponseElement {
        public MetadataService.ReadKnowledgeSettingsResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadSharingSetResult implements IReadResult {
        public MetadataService.SharingSet[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readSharingSetResponse_element implements IReadResponseElement {
        public MetadataService.ReadSharingSetResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadSecuritySettingsResult implements IReadResult {
        public MetadataService.SecuritySettings[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readSecuritySettingsResponse_element implements IReadResponseElement {
        public MetadataService.ReadSecuritySettingsResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadIdeasSettingsResult implements IReadResult {
        public MetadataService.IdeasSettings[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readIdeasSettingsResponse_element implements IReadResponseElement {
        public MetadataService.ReadIdeasSettingsResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadChatterAnswersSettingsResult implements IReadResult {
        public MetadataService.ChatterAnswersSettings[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readChatterAnswersSettingsResponse_element implements IReadResponseElement {
        public MetadataService.ReadChatterAnswersSettingsResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadCommunityResult implements IReadResult {
        public MetadataService.Community[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readCommunityResponse_element implements IReadResponseElement {
        public MetadataService.ReadCommunityResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadActivitiesSettingsResult implements IReadResult {
        public MetadataService.ActivitiesSettings[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readActivitiesSettingsResponse_element implements IReadResponseElement {
        public MetadataService.ReadActivitiesSettingsResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadContractSettingsResult implements IReadResult {
        public MetadataService.ContractSettings[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readContractSettingsResponse_element implements IReadResponseElement {
        public MetadataService.ReadContractSettingsResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadOrderSettingsResult implements IReadResult {
        public MetadataService.OrderSettings[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readOrderSettingsResponse_element implements IReadResponseElement {
        public MetadataService.ReadOrderSettingsResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadOpportunitySettingsResult implements IReadResult {
        public MetadataService.OpportunitySettings[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readOpportunitySettingsResponse_element implements IReadResponseElement {
        public MetadataService.ReadOpportunitySettingsResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadProductSettingsResult implements IReadResult {
        public MetadataService.ProductSettings[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readProductSettingsResponse_element implements IReadResponseElement {
        public MetadataService.ReadProductSettingsResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadQuoteSettingsResult implements IReadResult {
        public MetadataService.QuoteSettings[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readQuoteSettingsResponse_element implements IReadResponseElement {
        public MetadataService.ReadQuoteSettingsResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadCallCenterResult implements IReadResult {
        public MetadataService.CallCenter[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readCallCenterResponse_element implements IReadResponseElement {
        public MetadataService.ReadCallCenterResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadEntitlementProcessResult implements IReadResult {
        public MetadataService.EntitlementProcess[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readEntitlementProcessResponse_element implements IReadResponseElement {
        public MetadataService.ReadEntitlementProcessResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadMilestoneTypeResult implements IReadResult {
        public MetadataService.MilestoneType[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readMilestoneTypeResponse_element implements IReadResponseElement {
        public MetadataService.ReadMilestoneTypeResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadEntitlementTemplateResult implements IReadResult {
        public MetadataService.EntitlementTemplate[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readEntitlementTemplateResponse_element implements IReadResponseElement {
        public MetadataService.ReadEntitlementTemplateResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadEntitlementSettingsResult implements IReadResult {
        public MetadataService.EntitlementSettings[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readEntitlementSettingsResponse_element implements IReadResponseElement {
        public MetadataService.ReadEntitlementSettingsResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadBusinessHoursSettingsResult implements IReadResult {
        public MetadataService.BusinessHoursSettings[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readBusinessHoursSettingsResponse_element implements IReadResponseElement {
        public MetadataService.ReadBusinessHoursSettingsResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadBusinessHoursEntryResult implements IReadResult {
        public MetadataService.BusinessHoursEntry[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readBusinessHoursEntryResponse_element implements IReadResponseElement {
        public MetadataService.ReadBusinessHoursEntryResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadConnectedAppResult implements IReadResult {
        public MetadataService.ConnectedApp[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readConnectedAppResponse_element implements IReadResponseElement {
        public MetadataService.ReadConnectedAppResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadAppMenuResult implements IReadResult {
        public MetadataService.AppMenu[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readAppMenuResponse_element implements IReadResponseElement {
        public MetadataService.ReadAppMenuResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadMobileSettingsResult implements IReadResult {
        public MetadataService.MobileSettings[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readMobileSettingsResponse_element implements IReadResponseElement {
        public MetadataService.ReadMobileSettingsResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadNetworkResult implements IReadResult {
        public MetadataService.Network[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readNetworkResponse_element implements IReadResponseElement {
        public MetadataService.ReadNetworkResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadCompanySettingsResult implements IReadResult {
        public MetadataService.CompanySettings[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readCompanySettingsResponse_element implements IReadResponseElement {
        public MetadataService.ReadCompanySettingsResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadForecastingSettingsResult implements IReadResult {
        public MetadataService.ForecastingSettings[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readForecastingSettingsResponse_element implements IReadResponseElement {
        public MetadataService.ReadForecastingSettingsResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadSamlSsoConfigResult implements IReadResult {
        public MetadataService.SamlSsoConfig[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readSamlSsoConfigResponse_element implements IReadResponseElement {
        public MetadataService.ReadSamlSsoConfigResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadLiveAgentSettingsResult implements IReadResult {
        public MetadataService.LiveAgentSettings[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readLiveAgentSettingsResponse_element implements IReadResponseElement {
        public MetadataService.ReadLiveAgentSettingsResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadSkillResult implements IReadResult {
        public MetadataService.Skill[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readSkillResponse_element implements IReadResponseElement {
        public MetadataService.ReadSkillResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadLiveChatDeploymentResult implements IReadResult {
        public MetadataService.LiveChatDeployment[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readLiveChatDeploymentResponse_element implements IReadResponseElement {
        public MetadataService.ReadLiveChatDeploymentResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadLiveChatButtonResult implements IReadResult {
        public MetadataService.LiveChatButton[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readLiveChatButtonResponse_element implements IReadResponseElement {
        public MetadataService.ReadLiveChatButtonResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadLiveChatAgentConfigResult implements IReadResult {
        public MetadataService.LiveChatAgentConfig[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readLiveChatAgentConfigResponse_element implements IReadResponseElement {
        public MetadataService.ReadLiveChatAgentConfigResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadSynonymDictionaryResult implements IReadResult {
        public MetadataService.SynonymDictionary[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readSynonymDictionaryResponse_element implements IReadResponseElement {
        public MetadataService.ReadSynonymDictionaryResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadFolderResult implements IReadResult {
        public MetadataService.Folder[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readFolderResponse_element implements IReadResponseElement {
        public MetadataService.ReadFolderResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadReportFolderResult implements IReadResult {
        public MetadataService.ReportFolder[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readReportFolderResponse_element implements IReadResponseElement {
        public MetadataService.ReadReportFolderResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadDashboardFolderResult implements IReadResult {
        public MetadataService.DashboardFolder[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readDashboardFolderResponse_element implements IReadResponseElement {
        public MetadataService.ReadDashboardFolderResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadDocumentFolderResult implements IReadResult {
        public MetadataService.DocumentFolder[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readDocumentFolderResponse_element implements IReadResponseElement {
        public MetadataService.ReadDocumentFolderResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadEmailFolderResult implements IReadResult {
        public MetadataService.EmailFolder[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readEmailFolderResponse_element implements IReadResponseElement {
        public MetadataService.ReadEmailFolderResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadRoleOrTerritoryResult implements IReadResult {
        public MetadataService.RoleOrTerritory[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readRoleOrTerritoryResponse_element implements IReadResponseElement {
        public MetadataService.ReadRoleOrTerritoryResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadWorkflowActionResult implements IReadResult {
        public MetadataService.WorkflowAction[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readWorkflowActionResponse_element implements IReadResponseElement {
        public MetadataService.ReadWorkflowActionResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadSiteDotComResult implements IReadResult {
        public MetadataService.SiteDotCom[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readSiteDotComResponse_element implements IReadResponseElement {
        public MetadataService.ReadSiteDotComResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadWorkflowTaskResult implements IReadResult {
        public MetadataService.WorkflowTask[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readWorkflowTaskResponse_element implements IReadResponseElement {
        public MetadataService.ReadWorkflowTaskResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadWorkflowSendResult implements IReadResult {
        public MetadataService.WorkflowSend[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readWorkflowSendResponse_element implements IReadResponseElement {
        public MetadataService.ReadWorkflowSendResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadWorkflowOutboundMessageResult implements IReadResult {
        public MetadataService.WorkflowOutboundMessage[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readWorkflowOutboundMessageResponse_element implements IReadResponseElement {
        public MetadataService.ReadWorkflowOutboundMessageResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadWorkflowKnowledgePublishResult implements IReadResult {
        public MetadataService.WorkflowKnowledgePublish[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readWorkflowKnowledgePublishResponse_element implements IReadResponseElement {
        public MetadataService.ReadWorkflowKnowledgePublishResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadWorkflowFieldUpdateResult implements IReadResult {
        public MetadataService.WorkflowFieldUpdate[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readWorkflowFieldUpdateResponse_element implements IReadResponseElement {
        public MetadataService.ReadWorkflowFieldUpdateResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadWorkflowAlertResult implements IReadResult {
        public MetadataService.WorkflowAlert[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readWorkflowAlertResponse_element implements IReadResponseElement {
        public MetadataService.ReadWorkflowAlertResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadVisualizationPluginResult implements IReadResult {
        public MetadataService.VisualizationPlugin[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readVisualizationPluginResponse_element implements IReadResponseElement {
        public MetadataService.ReadVisualizationPluginResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadCustomMetadataResult implements IReadResult {
        public MetadataService.CustomMetadata[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readCustomMetadataResponse_element implements IReadResponseElement {
        public MetadataService.ReadCustomMetadataResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadNameSettingsResult implements IReadResult {
        public MetadataService.NameSettings[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readNameSettingsResponse_element implements IReadResponseElement {
        public MetadataService.ReadNameSettingsResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadMarketingActionSettingsResult implements IReadResult {
        public MetadataService.MarketingActionSettings[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readMarketingActionSettingsResponse_element implements IReadResponseElement {
        public MetadataService.ReadMarketingActionSettingsResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadCustomPermissionResult implements IReadResult {
        public MetadataService.CustomPermission[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readCustomPermissionResponse_element implements IReadResponseElement {
        public MetadataService.ReadCustomPermissionResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadAuraDefinitionBundleResult implements IReadResult {
        public MetadataService.AuraDefinitionBundle[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readAuraDefinitionBundleResponse_element implements IReadResponseElement {
        public MetadataService.ReadAuraDefinitionBundleResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadCorsWhitelistOriginResult implements IReadResult {
        public MetadataService.CorsWhitelistOrigin[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readCorsWhitelistOriginResponse_element implements IReadResponseElement {
        public MetadataService.ReadCorsWhitelistOriginResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadManagedTopicsResult implements IReadResult {
        public MetadataService.ManagedTopics[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readManagedTopicsResponse_element implements IReadResponseElement {
        public MetadataService.ReadManagedTopicsResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadTerritory2Result implements IReadResult {
        public MetadataService.Territory2[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readTerritory2Response_element implements IReadResponseElement {
        public MetadataService.ReadTerritory2Result result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadTerritory2ModelResult implements IReadResult {
        public MetadataService.Territory2Model[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readTerritory2ModelResponse_element implements IReadResponseElement {
        public MetadataService.ReadTerritory2ModelResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadTerritory2SettingsResult implements IReadResult {
        public MetadataService.Territory2Settings[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readTerritory2SettingsResponse_element implements IReadResponseElement {
        public MetadataService.ReadTerritory2SettingsResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadTerritory2TypeResult implements IReadResult {
        public MetadataService.Territory2Type[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readTerritory2TypeResponse_element implements IReadResponseElement {
        public MetadataService.ReadTerritory2TypeResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadXOrgHubResult implements IReadResult {
        public MetadataService.XOrgHub[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readXOrgHubResponse_element implements IReadResponseElement {
        public MetadataService.ReadXOrgHubResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadActionLinkGroupTemplateResult implements IReadResult {
        public MetadataService.ActionLinkGroupTemplate[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readActionLinkGroupTemplateResponse_element implements IReadResponseElement {
        public MetadataService.ReadActionLinkGroupTemplateResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadLicenseDefinitionResult implements IReadResult {
        public MetadataService.LicenseDefinition[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readLicenseDefinitionResponse_element implements IReadResponseElement {
        public MetadataService.ReadLicenseDefinitionResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadMarketingResourceTypeResult implements IReadResult {
        public MetadataService.MarketingResourceType[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readMarketingResourceTypeResponse_element implements IReadResponseElement {
        public MetadataService.ReadMarketingResourceTypeResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadMatchingRuleResult implements IReadResult {
        public MetadataService.MatchingRule[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readMatchingRuleResponse_element implements IReadResponseElement {
        public MetadataService.ReadMatchingRuleResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadMatchingRulesResult implements IReadResult {
        public MetadataService.MatchingRules[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readMatchingRulesResponse_element implements IReadResponseElement {
        public MetadataService.ReadMatchingRulesResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadNamedCredentialResult implements IReadResult {
        public MetadataService.NamedCredential[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readNamedCredentialResponse_element implements IReadResponseElement {
        public MetadataService.ReadNamedCredentialResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadPersonalJourneySettingsResult implements IReadResult {
        public MetadataService.PersonalJourneySettings[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readPersonalJourneySettingsResponse_element implements IReadResponseElement {
        public MetadataService.ReadPersonalJourneySettingsResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadSharingRulesResult implements IReadResult {
        public MetadataService.SharingRules[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readSharingRulesResponse_element implements IReadResponseElement {
        public MetadataService.ReadSharingRulesResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadSharingBaseRuleResult implements IReadResult {
        public MetadataService.SharingBaseRule[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readSharingBaseRuleResponse_element implements IReadResponseElement {
        public MetadataService.ReadSharingBaseRuleResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadSharingCriteriaRuleResult implements IReadResult {
        public MetadataService.SharingCriteriaRule[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readSharingCriteriaRuleResponse_element implements IReadResponseElement {
        public MetadataService.ReadSharingCriteriaRuleResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadSharingOwnerRuleResult implements IReadResult {
        public MetadataService.SharingOwnerRule[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readSharingOwnerRuleResponse_element implements IReadResponseElement {
        public MetadataService.ReadSharingOwnerRuleResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadSharingTerritoryRuleResult implements IReadResult {
        public MetadataService.SharingTerritoryRule[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readSharingTerritoryRuleResponse_element implements IReadResponseElement {
        public MetadataService.ReadSharingTerritoryRuleResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadMetadataWithContentResult implements IReadResult {
        public MetadataService.MetadataWithContent[] records;
        public MetadataService.Metadata[] getRecords() { return records; }
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class readMetadataWithContentResponse_element implements IReadResponseElement {
        public MetadataService.ReadMetadataWithContentResult result;
        public IReadResult getResult() { return result; }
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class ReadResult {
        public MetadataService.Metadata[] records;
        private String[] records_type_info = new String[]{'records','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'records'};
    }
    public class ReportBucketFieldValue {
        public MetadataService.ReportBucketFieldSourceValue[] sourceValues;
        public String value;
        private String[] sourceValues_type_info = new String[]{'sourceValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] value_type_info = new String[]{'value','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'sourceValues','value'};
    }
    public class ProfileApexPageAccess {
        public String apexPage;
        public Boolean enabled;
        private String[] apexPage_type_info = new String[]{'apexPage','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] enabled_type_info = new String[]{'enabled','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'apexPage','enabled'};
    }
    public class Scontrol extends MetadataWithContent {
        public String type = 'Scontrol';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String content;
        private String[] content_type_info = new String[]{'content','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String contentSource;
        public String description;
        public String encodingKey;
        public String fileContent;
        public String fileName;
        public String name;
        public Boolean supportsCaching;
        private String[] contentSource_type_info = new String[]{'contentSource','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] encodingKey_type_info = new String[]{'encodingKey','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] fileContent_type_info = new String[]{'fileContent','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] fileName_type_info = new String[]{'fileName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] supportsCaching_type_info = new String[]{'supportsCaching','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName','content', 'contentSource','description','encodingKey','fileContent','fileName','name','supportsCaching'};
    }
    public class Network extends Metadata {
        public String type = 'Network';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Boolean allowMembersToFlag;
        public MetadataService.Branding branding;
        public String caseCommentEmailTemplate;
        public String changePasswordTemplate;
        public String description;
        public String emailSenderAddress;
        public String emailSenderName;
        public Boolean enableGuestChatter;
        public Boolean enableInvitation;
        public Boolean enableKnowledgeable;
        public Boolean enableNicknameDisplay;
        public Boolean enablePrivateMessages;
        public Boolean enableReputation;
        public String feedChannel;
        public String forgotPasswordTemplate;
        public String logoutUrl;
        public MetadataService.NetworkMemberGroup networkMemberGroups;
        public String newSenderAddress;
        public String picassoSite;
        public MetadataService.ReputationLevelDefinitions reputationLevels;
        public MetadataService.ReputationPointsRules reputationPointsRules;
        public String selfRegProfile;
        public Boolean selfRegistration;
        public Boolean sendWelcomeEmail;
        public String site;
        public String status;
        public MetadataService.NetworkTabSet tabs;
        public String urlPathPrefix;
        public String welcomeTemplate;
        private String[] allowMembersToFlag_type_info = new String[]{'allowMembersToFlag','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] branding_type_info = new String[]{'branding','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] caseCommentEmailTemplate_type_info = new String[]{'caseCommentEmailTemplate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] changePasswordTemplate_type_info = new String[]{'changePasswordTemplate','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] emailSenderAddress_type_info = new String[]{'emailSenderAddress','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] emailSenderName_type_info = new String[]{'emailSenderName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] enableGuestChatter_type_info = new String[]{'enableGuestChatter','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableInvitation_type_info = new String[]{'enableInvitation','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableKnowledgeable_type_info = new String[]{'enableKnowledgeable','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableNicknameDisplay_type_info = new String[]{'enableNicknameDisplay','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enablePrivateMessages_type_info = new String[]{'enablePrivateMessages','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableReputation_type_info = new String[]{'enableReputation','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] feedChannel_type_info = new String[]{'feedChannel','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] forgotPasswordTemplate_type_info = new String[]{'forgotPasswordTemplate','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] logoutUrl_type_info = new String[]{'logoutUrl','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] networkMemberGroups_type_info = new String[]{'networkMemberGroups','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] newSenderAddress_type_info = new String[]{'newSenderAddress','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] picassoSite_type_info = new String[]{'picassoSite','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] reputationLevels_type_info = new String[]{'reputationLevels','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] reputationPointsRules_type_info = new String[]{'reputationPointsRules','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] selfRegProfile_type_info = new String[]{'selfRegProfile','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] selfRegistration_type_info = new String[]{'selfRegistration','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] sendWelcomeEmail_type_info = new String[]{'sendWelcomeEmail','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] site_type_info = new String[]{'site','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] status_type_info = new String[]{'status','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] tabs_type_info = new String[]{'tabs','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] urlPathPrefix_type_info = new String[]{'urlPathPrefix','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] welcomeTemplate_type_info = new String[]{'welcomeTemplate','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'allowMembersToFlag','branding','caseCommentEmailTemplate','changePasswordTemplate','description','emailSenderAddress','emailSenderName','enableGuestChatter','enableInvitation','enableKnowledgeable','enableNicknameDisplay','enablePrivateMessages','enableReputation','feedChannel','forgotPasswordTemplate','logoutUrl','networkMemberGroups','newSenderAddress','picassoSite','reputationLevels','reputationPointsRules','selfRegProfile','selfRegistration','sendWelcomeEmail','site','status','tabs','urlPathPrefix','welcomeTemplate'};
    }
    public class ActionLinkTemplate {
        public String actionUrl;
        public String headers;
        public Boolean isConfirmationRequired;
        public Boolean isGroupDefault;
        public String label;
        public String labelKey;
        public String linkType;
        public String method;
        public Integer position;
        public String requestBody;
        public String userAlias;
        public String userVisibility;
        private String[] actionUrl_type_info = new String[]{'actionUrl','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] headers_type_info = new String[]{'headers','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] isConfirmationRequired_type_info = new String[]{'isConfirmationRequired','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] isGroupDefault_type_info = new String[]{'isGroupDefault','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] labelKey_type_info = new String[]{'labelKey','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] linkType_type_info = new String[]{'linkType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] method_type_info = new String[]{'method','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] position_type_info = new String[]{'position','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] requestBody_type_info = new String[]{'requestBody','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] userAlias_type_info = new String[]{'userAlias','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] userVisibility_type_info = new String[]{'userVisibility','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'actionUrl','headers','isConfirmationRequired','isGroupDefault','label','labelKey','linkType','method','position','requestBody','userAlias','userVisibility'};
    }
    public class EntitlementProcessMilestoneItem {
        public String businessHours;
        public String criteriaBooleanFilter;
        public MetadataService.FilterItem[] milestoneCriteriaFilterItems;
        public String milestoneCriteriaFormula;
        public String milestoneName;
        public String minutesCustomClass;
        public Integer minutesToComplete;
        public MetadataService.WorkflowActionReference[] successActions;
        public MetadataService.EntitlementProcessMilestoneTimeTrigger[] timeTriggers;
        public Boolean useCriteriaStartTime;
        private String[] businessHours_type_info = new String[]{'businessHours','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] criteriaBooleanFilter_type_info = new String[]{'criteriaBooleanFilter','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] milestoneCriteriaFilterItems_type_info = new String[]{'milestoneCriteriaFilterItems','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] milestoneCriteriaFormula_type_info = new String[]{'milestoneCriteriaFormula','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] milestoneName_type_info = new String[]{'milestoneName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] minutesCustomClass_type_info = new String[]{'minutesCustomClass','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] minutesToComplete_type_info = new String[]{'minutesToComplete','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] successActions_type_info = new String[]{'successActions','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] timeTriggers_type_info = new String[]{'timeTriggers','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] useCriteriaStartTime_type_info = new String[]{'useCriteriaStartTime','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'businessHours','criteriaBooleanFilter','milestoneCriteriaFilterItems','milestoneCriteriaFormula','milestoneName','minutesCustomClass','minutesToComplete','successActions','timeTriggers','useCriteriaStartTime'};
    }
    public class ReportFilter {
        public String booleanFilter;
        public MetadataService.ReportFilterItem[] criteriaItems;
        public String language;
        private String[] booleanFilter_type_info = new String[]{'booleanFilter','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] criteriaItems_type_info = new String[]{'criteriaItems','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] language_type_info = new String[]{'language','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'booleanFilter','criteriaItems','language'};
    }
    public class RetrieveResult {
        public Boolean done;
        public String errorMessage;
        public String errorStatusCode;
        public MetadataService.FileProperties[] fileProperties;
        public String id;
        public MetadataService.RetrieveMessage[] messages;
        public String status;
        public Boolean success;
        public String zipFile;
        private String[] done_type_info = new String[]{'done','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] errorMessage_type_info = new String[]{'errorMessage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] errorStatusCode_type_info = new String[]{'errorStatusCode','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] fileProperties_type_info = new String[]{'fileProperties','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] id_type_info = new String[]{'id','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] messages_type_info = new String[]{'messages','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] status_type_info = new String[]{'status','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] success_type_info = new String[]{'success','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] zipFile_type_info = new String[]{'zipFile','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'done','errorMessage','errorStatusCode','fileProperties','id','messages','status','success','zipFile'};
    }
    public class Territory2Model extends Metadata {
        public String type = 'Territory2Model';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public MetadataService.FieldValue[] customFields;
        public String description;
        public String name;
        private String[] customFields_type_info = new String[]{'customFields','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'customFields','description','name'};
    }
    public class CustomObject extends Metadata {
        public String type = 'CustomObject';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public MetadataService.ActionOverride[] actionOverrides;
        public Boolean allowInChatterGroups;
        public MetadataService.ArticleTypeChannelDisplay articleTypeChannelDisplay;
        public MetadataService.BusinessProcess[] businessProcesses;
        public String compactLayoutAssignment;
        public MetadataService.CompactLayout[] compactLayouts;
        public String customHelp;
        public String customHelpPage;
        public String customSettingsType;
        public String deploymentStatus;
        public Boolean deprecated;
        public String description;
        public Boolean enableActivities;
        public Boolean enableBulkApi;
        public Boolean enableDivisions;
        public Boolean enableEnhancedLookup;
        public Boolean enableFeeds;
        public Boolean enableHistory;
        public Boolean enableReports;
        public Boolean enableSearch;
        public Boolean enableSharing;
        public Boolean enableStreamingApi;
        public String externalDataSource;
        public String externalName;
        public String externalRepository;
        public String externalSharingModel;
        public MetadataService.FieldSet[] fieldSets;
        public MetadataService.CustomField[] fields;
        public String gender;
        public MetadataService.HistoryRetentionPolicy historyRetentionPolicy;
        public Boolean household;
        public String label;
        public MetadataService.ListView[] listViews;
        public MetadataService.CustomField nameField;
        public String pluralLabel;
        public Boolean recordTypeTrackFeedHistory;
        public Boolean recordTypeTrackHistory;
        public MetadataService.RecordType[] recordTypes;
        public MetadataService.SearchLayouts searchLayouts;
        public String sharingModel;
        public MetadataService.SharingReason[] sharingReasons;
        public MetadataService.SharingRecalculation[] sharingRecalculations;
        public String startsWith;
        public MetadataService.ValidationRule[] validationRules;
        public String visibility;
        public MetadataService.WebLink[] webLinks;
        private String[] actionOverrides_type_info = new String[]{'actionOverrides','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] allowInChatterGroups_type_info = new String[]{'allowInChatterGroups','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] articleTypeChannelDisplay_type_info = new String[]{'articleTypeChannelDisplay','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] businessProcesses_type_info = new String[]{'businessProcesses','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] compactLayoutAssignment_type_info = new String[]{'compactLayoutAssignment','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] compactLayouts_type_info = new String[]{'compactLayouts','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] customHelp_type_info = new String[]{'customHelp','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] customHelpPage_type_info = new String[]{'customHelpPage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] customSettingsType_type_info = new String[]{'customSettingsType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] deploymentStatus_type_info = new String[]{'deploymentStatus','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] deprecated_type_info = new String[]{'deprecated','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableActivities_type_info = new String[]{'enableActivities','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableBulkApi_type_info = new String[]{'enableBulkApi','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableDivisions_type_info = new String[]{'enableDivisions','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableEnhancedLookup_type_info = new String[]{'enableEnhancedLookup','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableFeeds_type_info = new String[]{'enableFeeds','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableHistory_type_info = new String[]{'enableHistory','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableReports_type_info = new String[]{'enableReports','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableSearch_type_info = new String[]{'enableSearch','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableSharing_type_info = new String[]{'enableSharing','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableStreamingApi_type_info = new String[]{'enableStreamingApi','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] externalDataSource_type_info = new String[]{'externalDataSource','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] externalName_type_info = new String[]{'externalName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] externalRepository_type_info = new String[]{'externalRepository','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] externalSharingModel_type_info = new String[]{'externalSharingModel','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] fieldSets_type_info = new String[]{'fieldSets','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] fields_type_info = new String[]{'fields','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] gender_type_info = new String[]{'gender','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] historyRetentionPolicy_type_info = new String[]{'historyRetentionPolicy','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] household_type_info = new String[]{'household','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] listViews_type_info = new String[]{'listViews','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] nameField_type_info = new String[]{'nameField','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] pluralLabel_type_info = new String[]{'pluralLabel','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] recordTypeTrackFeedHistory_type_info = new String[]{'recordTypeTrackFeedHistory','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] recordTypeTrackHistory_type_info = new String[]{'recordTypeTrackHistory','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] recordTypes_type_info = new String[]{'recordTypes','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] searchLayouts_type_info = new String[]{'searchLayouts','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] sharingModel_type_info = new String[]{'sharingModel','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] sharingReasons_type_info = new String[]{'sharingReasons','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] sharingRecalculations_type_info = new String[]{'sharingRecalculations','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] startsWith_type_info = new String[]{'startsWith','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] validationRules_type_info = new String[]{'validationRules','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] visibility_type_info = new String[]{'visibility','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] webLinks_type_info = new String[]{'webLinks','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'actionOverrides','allowInChatterGroups','articleTypeChannelDisplay','businessProcesses','compactLayoutAssignment','compactLayouts','customHelp','customHelpPage','customSettingsType','deploymentStatus','deprecated','description','enableActivities','enableBulkApi','enableDivisions','enableEnhancedLookup','enableFeeds','enableHistory','enableReports','enableSearch','enableSharing','enableStreamingApi','externalDataSource','externalName','externalRepository','externalSharingModel','fieldSets','fields','gender','historyRetentionPolicy','household','label','listViews','nameField','pluralLabel','recordTypeTrackFeedHistory','recordTypeTrackHistory','recordTypes','searchLayouts','sharingModel','sharingReasons','sharingRecalculations','startsWith','validationRules','visibility','webLinks'};
    }
    public class LayoutSection {
        public Boolean customLabel;
        public Boolean detailHeading;
        public Boolean editHeading;
        public String label;
        public MetadataService.LayoutColumn[] layoutColumns;
        public String style;
        private String[] customLabel_type_info = new String[]{'customLabel','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] detailHeading_type_info = new String[]{'detailHeading','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] editHeading_type_info = new String[]{'editHeading','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] layoutColumns_type_info = new String[]{'layoutColumns','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] style_type_info = new String[]{'style','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'customLabel','detailHeading','editHeading','label','layoutColumns','style'};
    }
    public class cancelDeployResponse_element {
        public MetadataService.CancelDeployResult result;
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class FlowMetadataValue {
        public String name;
        public MetadataService.FlowElementReferenceOrValue value;
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] value_type_info = new String[]{'value','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'name','value'};
    }
    public class ProfileObjectPermissions {
        public Boolean allowCreate;
        public Boolean allowDelete;
        public Boolean allowEdit;
        public Boolean allowRead;
        public Boolean modifyAllRecords;
        public String object_x;
        public Boolean viewAllRecords;
        private String[] allowCreate_type_info = new String[]{'allowCreate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] allowDelete_type_info = new String[]{'allowDelete','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] allowEdit_type_info = new String[]{'allowEdit','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] allowRead_type_info = new String[]{'allowRead','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] modifyAllRecords_type_info = new String[]{'modifyAllRecords','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] object_x_type_info = new String[]{'object','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] viewAllRecords_type_info = new String[]{'viewAllRecords','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'allowCreate','allowDelete','allowEdit','allowRead','modifyAllRecords','object_x','viewAllRecords'};
    }
    public class ReportGrouping {
        public String aggregateType;
        public String dateGranularity;
        public String field;
        public String sortByName;
        public String sortOrder;
        public String sortType;
        private String[] aggregateType_type_info = new String[]{'aggregateType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] dateGranularity_type_info = new String[]{'dateGranularity','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] field_type_info = new String[]{'field','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] sortByName_type_info = new String[]{'sortByName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] sortOrder_type_info = new String[]{'sortOrder','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] sortType_type_info = new String[]{'sortType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'aggregateType','dateGranularity','field','sortByName','sortOrder','sortType'};
    }
    public class DeployMessage {
        public Boolean changed;
        public Integer columnNumber;
        public String componentType;
        public Boolean created;
        public DateTime createdDate;
        public Boolean deleted;
        public String fileName;
        public String fullName;
        public String id;
        public Integer lineNumber;
        public String problem;
        public String problemType;
        public Boolean success;
        private String[] changed_type_info = new String[]{'changed','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] columnNumber_type_info = new String[]{'columnNumber','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] componentType_type_info = new String[]{'componentType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] created_type_info = new String[]{'created','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] createdDate_type_info = new String[]{'createdDate','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] deleted_type_info = new String[]{'deleted','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] fileName_type_info = new String[]{'fileName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] id_type_info = new String[]{'id','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] lineNumber_type_info = new String[]{'lineNumber','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] problem_type_info = new String[]{'problem','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] problemType_type_info = new String[]{'problemType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] success_type_info = new String[]{'success','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'changed','columnNumber','componentType','created','createdDate','deleted','fileName','fullName','id','lineNumber','problem','problemType','success'};
    }
    public class PermissionSetObjectPermissions {
        public Boolean allowCreate;
        public Boolean allowDelete;
        public Boolean allowEdit;
        public Boolean allowRead;
        public Boolean modifyAllRecords;
        public String object_x;
        public Boolean viewAllRecords;
        private String[] allowCreate_type_info = new String[]{'allowCreate','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] allowDelete_type_info = new String[]{'allowDelete','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] allowEdit_type_info = new String[]{'allowEdit','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] allowRead_type_info = new String[]{'allowRead','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] modifyAllRecords_type_info = new String[]{'modifyAllRecords','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] object_x_type_info = new String[]{'object','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] viewAllRecords_type_info = new String[]{'viewAllRecords','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'allowCreate','allowDelete','allowEdit','allowRead','modifyAllRecords','object_x','viewAllRecords'};
    }
    public class ProfileApexClassAccess {
        public String apexClass;
        public Boolean enabled;
        private String[] apexClass_type_info = new String[]{'apexClass','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] enabled_type_info = new String[]{'enabled','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'apexClass','enabled'};
    }
    public class ProfileLoginIpRange {
        public String description;
        public String endAddress;
        public String startAddress;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] endAddress_type_info = new String[]{'endAddress','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] startAddress_type_info = new String[]{'startAddress','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'description','endAddress','startAddress'};
    }
    public class FlowWait extends FlowNode {
        public String type = 'FlowWait';
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        public String description;
        public String name;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        public String label;
        public Integer locationX;
        public Integer locationY;
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] locationX_type_info = new String[]{'locationX','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] locationY_type_info = new String[]{'locationY','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        public MetadataService.FlowConnector defaultConnector;
        public String defaultConnectorLabel;
        public MetadataService.FlowConnector faultConnector;
        public MetadataService.FlowWaitEvent[] waitEvents;
        private String[] defaultConnector_type_info = new String[]{'defaultConnector','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] defaultConnectorLabel_type_info = new String[]{'defaultConnectorLabel','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] faultConnector_type_info = new String[]{'faultConnector','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] waitEvents_type_info = new String[]{'waitEvents','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'processMetadataValues','description','name','label','locationX','locationY', 'defaultConnector','defaultConnectorLabel','faultConnector','waitEvents'};
    }
    public class ChartSummary {
        public String aggregate;
        public String axisBinding;
        public String column;
        private String[] aggregate_type_info = new String[]{'aggregate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] axisBinding_type_info = new String[]{'axisBinding','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] column_type_info = new String[]{'column','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'aggregate','axisBinding','column'};
    }
    public class InstalledPackage extends Metadata {
        public String type = 'InstalledPackage';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String password;
        public String versionNumber;
        private String[] password_type_info = new String[]{'password','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] versionNumber_type_info = new String[]{'versionNumber','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'password','versionNumber'};
    }
    public class checkRetrieveStatus_element {
        public String asyncProcessId;
        public Boolean includeZip;
        private String[] asyncProcessId_type_info = new String[]{'asyncProcessId','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] includeZip_type_info = new String[]{'includeZip','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'asyncProcessId','includeZip'};
    }
    public class Country {
        public Boolean active;
        public String integrationValue;
        public String isoCode;
        public String label;
        public Boolean orgDefault;
        public Boolean standard;
        public MetadataService.State[] states;
        public Boolean visible;
        private String[] active_type_info = new String[]{'active','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] integrationValue_type_info = new String[]{'integrationValue','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] isoCode_type_info = new String[]{'isoCode','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] orgDefault_type_info = new String[]{'orgDefault','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] standard_type_info = new String[]{'standard','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] states_type_info = new String[]{'states','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] visible_type_info = new String[]{'visible','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'active','integrationValue','isoCode','label','orgDefault','standard','states','visible'};
    }
    public class ObjectUsage {
        public String[] object_x;
        private String[] object_x_type_info = new String[]{'object','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'object_x'};
    }
    public class Package_x extends Metadata {
        public String type = 'Package_x';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String apiAccessLevel;
        public String description;
        public String namespacePrefix;
        public MetadataService.ProfileObjectPermissions[] objectPermissions;
        public String postInstallClass;
        public String setupWeblink;
        public MetadataService.PackageTypeMembers[] types;
        public String uninstallClass;
        public String version;
        private String[] apiAccessLevel_type_info = new String[]{'apiAccessLevel','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] namespacePrefix_type_info = new String[]{'namespacePrefix','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] objectPermissions_type_info = new String[]{'objectPermissions','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] postInstallClass_type_info = new String[]{'postInstallClass','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] setupWeblink_type_info = new String[]{'setupWeblink','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] types_type_info = new String[]{'types','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] uninstallClass_type_info = new String[]{'uninstallClass','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] version_type_info = new String[]{'version','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'apiAccessLevel','description','namespacePrefix','objectPermissions','postInstallClass','setupWeblink','types','uninstallClass','version'};
    }
    public class SharingReasonTranslation {
        public String label;
        public String name;
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'label','name'};
    }
    public class CustomDataTypeComponentTranslation {
        public String developerSuffix;
        public String label;
        private String[] developerSuffix_type_info = new String[]{'developerSuffix','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'developerSuffix','label'};
    }
    public class FeedLayoutComponent {
        public String componentType;
        public Integer height;
        public String page_x;
        private String[] componentType_type_info = new String[]{'componentType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] height_type_info = new String[]{'height','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] page_x_type_info = new String[]{'page','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'componentType','height','page_x'};
    }
    public class FlowCondition extends FlowBaseElement {
        public String type = 'FlowCondition';
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        public String leftValueReference;
        public String operator;
        public MetadataService.FlowElementReferenceOrValue rightValue;
        private String[] leftValueReference_type_info = new String[]{'leftValueReference','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] operator_type_info = new String[]{'operator','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] rightValue_type_info = new String[]{'rightValue','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'processMetadataValues', 'leftValueReference','operator','rightValue'};
    }
    public class CallCenterSection {
        public MetadataService.CallCenterItem[] items;
        public String label;
        public String name;
        private String[] items_type_info = new String[]{'items','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'items','label','name'};
    }
    public class CustomApplication extends Metadata {
        public String type = 'CustomApplication';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public MetadataService.CustomApplicationComponents customApplicationComponents;
        public String defaultLandingTab;
        public String description;
        public String detailPageRefreshMethod;
        public MetadataService.DomainWhitelist domainWhitelist;
        public Boolean enableCustomizeMyTabs;
        public Boolean enableKeyboardShortcuts;
        public Boolean enableListViewReskin;
        public Boolean enableMultiMonitorComponents;
        public Boolean enablePinTabs;
        public String footerColor;
        public String headerColor;
        public Boolean isServiceCloudConsole;
        public MetadataService.KeyboardShortcuts keyboardShortcuts;
        public String label;
        public MetadataService.ListPlacement listPlacement;
        public String listRefreshMethod;
        public MetadataService.LiveAgentConfig liveAgentConfig;
        public String logo;
        public String primaryTabColor;
        public MetadataService.PushNotifications pushNotifications;
        public Boolean saveUserSessions;
        public String[] tab;
        public MetadataService.WorkspaceMappings workspaceMappings;
        private String[] customApplicationComponents_type_info = new String[]{'customApplicationComponents','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] defaultLandingTab_type_info = new String[]{'defaultLandingTab','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] detailPageRefreshMethod_type_info = new String[]{'detailPageRefreshMethod','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] domainWhitelist_type_info = new String[]{'domainWhitelist','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableCustomizeMyTabs_type_info = new String[]{'enableCustomizeMyTabs','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableKeyboardShortcuts_type_info = new String[]{'enableKeyboardShortcuts','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableListViewReskin_type_info = new String[]{'enableListViewReskin','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableMultiMonitorComponents_type_info = new String[]{'enableMultiMonitorComponents','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enablePinTabs_type_info = new String[]{'enablePinTabs','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] footerColor_type_info = new String[]{'footerColor','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] headerColor_type_info = new String[]{'headerColor','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] isServiceCloudConsole_type_info = new String[]{'isServiceCloudConsole','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] keyboardShortcuts_type_info = new String[]{'keyboardShortcuts','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] listPlacement_type_info = new String[]{'listPlacement','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] listRefreshMethod_type_info = new String[]{'listRefreshMethod','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] liveAgentConfig_type_info = new String[]{'liveAgentConfig','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] logo_type_info = new String[]{'logo','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] primaryTabColor_type_info = new String[]{'primaryTabColor','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] pushNotifications_type_info = new String[]{'pushNotifications','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] saveUserSessions_type_info = new String[]{'saveUserSessions','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] tab_type_info = new String[]{'tab','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] workspaceMappings_type_info = new String[]{'workspaceMappings','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'customApplicationComponents','defaultLandingTab','description','detailPageRefreshMethod','domainWhitelist','enableCustomizeMyTabs','enableKeyboardShortcuts','enableListViewReskin','enableMultiMonitorComponents','enablePinTabs','footerColor','headerColor','isServiceCloudConsole','keyboardShortcuts','label','listPlacement','listRefreshMethod','liveAgentConfig','logo','primaryTabColor','pushNotifications','saveUserSessions','tab','workspaceMappings'};
    }
    public class DescribeMetadataResult {
        public MetadataService.DescribeMetadataObject[] metadataObjects;
        public String organizationNamespace;
        public Boolean partialSaveAllowed;
        public Boolean testRequired;
        private String[] metadataObjects_type_info = new String[]{'metadataObjects','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] organizationNamespace_type_info = new String[]{'organizationNamespace','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] partialSaveAllowed_type_info = new String[]{'partialSaveAllowed','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] testRequired_type_info = new String[]{'testRequired','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'metadataObjects','organizationNamespace','partialSaveAllowed','testRequired'};
    }
    public class LeadConvertSettings {
        public Boolean allowOwnerChange;
        public String opportunityCreationOptions;
        private String[] allowOwnerChange_type_info = new String[]{'allowOwnerChange','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] opportunityCreationOptions_type_info = new String[]{'opportunityCreationOptions','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'allowOwnerChange','opportunityCreationOptions'};
    }
    public class ReportType extends Metadata {
        public String type = 'ReportType';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Boolean autogenerated;
        public String baseObject;
        public String category;
        public Boolean deployed;
        public String description;
        public MetadataService.ObjectRelationship join_x;
        public String label;
        public MetadataService.ReportLayoutSection[] sections;
        private String[] autogenerated_type_info = new String[]{'autogenerated','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] baseObject_type_info = new String[]{'baseObject','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] category_type_info = new String[]{'category','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] deployed_type_info = new String[]{'deployed','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] join_x_type_info = new String[]{'join','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] sections_type_info = new String[]{'sections','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'autogenerated','baseObject','category','deployed','description','join_x','label','sections'};
    }
    public class deleteMetadataResponse_element {
        public MetadataService.DeleteResult[] result;
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class CodeLocation {
        public Integer column;
        public Integer line;
        public Integer numExecutions;
        public Double time_x;
        private String[] column_type_info = new String[]{'column','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] line_type_info = new String[]{'line','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] numExecutions_type_info = new String[]{'numExecutions','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] time_x_type_info = new String[]{'time','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'column','line','numExecutions','time_x'};
    }
    public class PermissionSetApplicationVisibility {
        public String application;
        public Boolean visible;
        private String[] application_type_info = new String[]{'application','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] visible_type_info = new String[]{'visible','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'application','visible'};
    }
    public class StandardFieldTranslation {
        public String label;
        public String name;
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'label','name'};
    }
    public class RoleOrTerritory extends Metadata {
        public String type = 'RoleOrTerritory';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String caseAccessLevel;
        public String contactAccessLevel;
        public String description;
        public Boolean mayForecastManagerShare;
        public String name;
        public String opportunityAccessLevel;
        private String[] caseAccessLevel_type_info = new String[]{'caseAccessLevel','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] contactAccessLevel_type_info = new String[]{'contactAccessLevel','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] mayForecastManagerShare_type_info = new String[]{'mayForecastManagerShare','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] opportunityAccessLevel_type_info = new String[]{'opportunityAccessLevel','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'caseAccessLevel','contactAccessLevel','description','mayForecastManagerShare','name','opportunityAccessLevel'};
    }
    public class FlowSubflowInputAssignment extends FlowBaseElement {
        public String type = 'FlowSubflowInputAssignment';
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        public String name;
        public MetadataService.FlowElementReferenceOrValue value;
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] value_type_info = new String[]{'value','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'processMetadataValues', 'name','value'};
    }
    public class LiveChatButtonSkills {
        public String[] skill;
        private String[] skill_type_info = new String[]{'skill','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'skill'};
    }
    public class RemoteSiteSetting extends Metadata {
        public String type = 'RemoteSiteSetting';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String description;
        public Boolean disableProtocolSecurity;
        public Boolean isActive;
        public String url;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] disableProtocolSecurity_type_info = new String[]{'disableProtocolSecurity','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] isActive_type_info = new String[]{'isActive','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] url_type_info = new String[]{'url','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'description','disableProtocolSecurity','isActive','url'};
    }
    public class ConnectedAppOauthConfig {
        public String callbackUrl;
        public String certificate;
        public String consumerKey;
        public String consumerSecret;
        public String[] scopes;
        private String[] callbackUrl_type_info = new String[]{'callbackUrl','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] certificate_type_info = new String[]{'certificate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] consumerKey_type_info = new String[]{'consumerKey','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] consumerSecret_type_info = new String[]{'consumerSecret','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] scopes_type_info = new String[]{'scopes','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'callbackUrl','certificate','consumerKey','consumerSecret','scopes'};
    }
    public class VisualizationResource {
        public String description;
        public String file;
        public Integer rank;
        public String type_x;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] file_type_info = new String[]{'file','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] rank_type_info = new String[]{'rank','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] type_x_type_info = new String[]{'type','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'description','file','rank','type_x'};
    }
    public class NextAutomatedApprover {
        public Boolean useApproverFieldOfRecordOwner;
        public String userHierarchyField;
        private String[] useApproverFieldOfRecordOwner_type_info = new String[]{'useApproverFieldOfRecordOwner','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] userHierarchyField_type_info = new String[]{'userHierarchyField','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'useApproverFieldOfRecordOwner','userHierarchyField'};
    }
    public class Territory2Rule {
        public Boolean active;
        public String booleanFilter;
        public String name;
        public String objectType;
        public MetadataService.Territory2RuleItem[] ruleItems;
        private String[] active_type_info = new String[]{'active','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] booleanFilter_type_info = new String[]{'booleanFilter','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] objectType_type_info = new String[]{'objectType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] ruleItems_type_info = new String[]{'ruleItems','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'active','booleanFilter','name','objectType','ruleItems'};
    }
    public class RetrieveMessage {
        public String fileName;
        public String problem;
        private String[] fileName_type_info = new String[]{'fileName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] problem_type_info = new String[]{'problem','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'fileName','problem'};
    }
    public class ForecastingCategoryMapping {
        public String forecastingItemCategoryApiName;
        public MetadataService.WeightedSourceCategory[] weightedSourceCategories;
        private String[] forecastingItemCategoryApiName_type_info = new String[]{'forecastingItemCategoryApiName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] weightedSourceCategories_type_info = new String[]{'weightedSourceCategories','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'forecastingItemCategoryApiName','weightedSourceCategories'};
    }
    public class HistoryRetentionPolicy {
        public Integer archiveAfterMonths;
        public Integer archiveRetentionYears;
        public String description;
        public Integer gracePeriodDays;
        private String[] gracePeriodDays_type_info = new String[]{'gracePeriodDays','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};        
        private String[] archiveAfterMonths_type_info = new String[]{'archiveAfterMonths','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] archiveRetentionYears_type_info = new String[]{'archiveRetentionYears','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'archiveAfterMonths','archiveRetentionYears','gracePeriodDays','description'};
    }
    public class WorkspaceMappings {
        public MetadataService.WorkspaceMapping[] mapping;
        private String[] mapping_type_info = new String[]{'mapping','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'mapping'};
    }
    public class FlowFormula extends FlowElement {
        public String type = 'FlowFormula';
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        public String description;
        public String name;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        public String dataType;
        public String expression;
        public Integer scale;
        private String[] dataType_type_info = new String[]{'dataType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] expression_type_info = new String[]{'expression','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] scale_type_info = new String[]{'scale','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'processMetadataValues','description','name', 'dataType','expression','scale'};
    }
    public class Picklist {
        public String controllingField;
        public MetadataService.PicklistValue[] picklistValues;
        public Boolean sorted;
        private String[] controllingField_type_info = new String[]{'controllingField','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] picklistValues_type_info = new String[]{'picklistValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] sorted_type_info = new String[]{'sorted','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'controllingField','picklistValues','sorted'};
    }
    public class deploy_element {
        public String ZipFile;
        public MetadataService.DeployOptions DeployOptions;
        private String[] ZipFile_type_info = new String[]{'ZipFile','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] DeployOptions_type_info = new String[]{'DeployOptions','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'ZipFile','DeployOptions'};
    }
    public class ReportTypeSectionTranslation {
        public MetadataService.ReportTypeColumnTranslation[] columns;
        public String label;
        public String name;
        private String[] columns_type_info = new String[]{'columns','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'columns','label','name'};
    }
    public class PersonalJourneySettings extends Metadata {
        public String type = 'PersonalJourneySettings';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Boolean enableExactTargetForSalesforceApps;
        private String[] enableExactTargetForSalesforceApps_type_info = new String[]{'enableExactTargetForSalesforceApps','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'enableExactTargetForSalesforceApps'};
    }
    public class CustomPermission extends Metadata {
        public String type = 'CustomPermission';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String connectedApp;
        public String description;
        public String label;
        public MetadataService.CustomPermissionDependencyRequired[] requiredPermission;
        private String[] connectedApp_type_info = new String[]{'connectedApp','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] requiredPermission_type_info = new String[]{'requiredPermission','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'connectedApp','description','label','requiredPermission'};
    }
    public class AgentConfigSkills {
        public String[] skill;
        private String[] skill_type_info = new String[]{'skill','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'skill'};
    }
    public class DeployResult {
        public String canceledBy;
        public String canceledByName;
        public Boolean checkOnly;
        public DateTime completedDate;
        public String createdBy;
        public String createdByName;
        public DateTime createdDate;
        public MetadataService.DeployDetails details;
        public Boolean done;
        public String errorMessage;
        public String errorStatusCode;
        public String id;
        public Boolean ignoreWarnings;
        public DateTime lastModifiedDate;
        public Integer numberComponentErrors;
        public Integer numberComponentsDeployed;
        public Integer numberComponentsTotal;
        public Integer numberTestErrors;
        public Integer numberTestsCompleted;
        public Integer numberTestsTotal;
        public Boolean rollbackOnError;
        public Boolean runTestsEnabled;
        public DateTime startDate;
        public String stateDetail;
        public String status;
        public Boolean success;
        private String[] canceledBy_type_info = new String[]{'canceledBy','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] canceledByName_type_info = new String[]{'canceledByName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] checkOnly_type_info = new String[]{'checkOnly','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] completedDate_type_info = new String[]{'completedDate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] createdBy_type_info = new String[]{'createdBy','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] createdByName_type_info = new String[]{'createdByName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] createdDate_type_info = new String[]{'createdDate','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] details_type_info = new String[]{'details','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] done_type_info = new String[]{'done','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] errorMessage_type_info = new String[]{'errorMessage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] errorStatusCode_type_info = new String[]{'errorStatusCode','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] id_type_info = new String[]{'id','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] ignoreWarnings_type_info = new String[]{'ignoreWarnings','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] lastModifiedDate_type_info = new String[]{'lastModifiedDate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] numberComponentErrors_type_info = new String[]{'numberComponentErrors','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] numberComponentsDeployed_type_info = new String[]{'numberComponentsDeployed','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] numberComponentsTotal_type_info = new String[]{'numberComponentsTotal','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] numberTestErrors_type_info = new String[]{'numberTestErrors','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] numberTestsCompleted_type_info = new String[]{'numberTestsCompleted','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] numberTestsTotal_type_info = new String[]{'numberTestsTotal','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] rollbackOnError_type_info = new String[]{'rollbackOnError','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] runTestsEnabled_type_info = new String[]{'runTestsEnabled','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] startDate_type_info = new String[]{'startDate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] stateDetail_type_info = new String[]{'stateDetail','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] status_type_info = new String[]{'status','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] success_type_info = new String[]{'success','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'canceledBy','canceledByName','checkOnly','completedDate','createdBy','createdByName','createdDate','details','done','errorMessage','errorStatusCode','id','ignoreWarnings','lastModifiedDate','numberComponentErrors','numberComponentsDeployed','numberComponentsTotal','numberTestErrors','numberTestsCompleted','numberTestsTotal','rollbackOnError','runTestsEnabled','startDate','stateDetail','status','success'};
    }
    public class IdeaReputationLevel {
        public String name;
        public Integer value;
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] value_type_info = new String[]{'value','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'name','value'};
    }
    public class PagesToOpen {
        public String[] pageToOpen;
        private String[] pageToOpen_type_info = new String[]{'pageToOpen','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'pageToOpen'};
    }
    public class WorkflowTimeTrigger {
        public MetadataService.WorkflowActionReference[] actions;
        public String offsetFromField;
        public String timeLength;
        public String workflowTimeTriggerUnit;
        private String[] actions_type_info = new String[]{'actions','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] offsetFromField_type_info = new String[]{'offsetFromField','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] timeLength_type_info = new String[]{'timeLength','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] workflowTimeTriggerUnit_type_info = new String[]{'workflowTimeTriggerUnit','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'actions','offsetFromField','timeLength','workflowTimeTriggerUnit'};
    }
    public class AutoResponseRules extends Metadata {
        public String type = 'AutoResponseRules';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public MetadataService.AutoResponseRule[] autoResponseRule;
        private String[] autoResponseRule_type_info = new String[]{'autoResponseRule','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'autoResponseRule'};
    }
    public class LayoutTranslation {
        public String layout;
        public String layoutType;
        public MetadataService.LayoutSectionTranslation[] sections;
        private String[] layout_type_info = new String[]{'layout','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] layoutType_type_info = new String[]{'layoutType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] sections_type_info = new String[]{'sections','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'layout','layoutType','sections'};
    }
    public class DashboardFolder extends Folder {
        public String type = 'DashboardFolder';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String accessType;
        public MetadataService.FolderShare[] folderShares;
        public String name;
        public String publicFolderAccess;
        public MetadataService.SharedTo sharedTo;
        private String[] accessType_type_info = new String[]{'accessType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] folderShares_type_info = new String[]{'folderShares','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] publicFolderAccess_type_info = new String[]{'publicFolderAccess','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] sharedTo_type_info = new String[]{'sharedTo','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName','accessType','folderShares','name','publicFolderAccess','sharedTo'};
    }
    public class ForecastingSettings extends Metadata {
        public String type = 'ForecastingSettings';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String displayCurrency;
        public Boolean enableForecasts;
        public MetadataService.ForecastingCategoryMapping[] forecastingCategoryMappings;
        public MetadataService.ForecastingTypeSettings[] forecastingTypeSettings;
        private String[] displayCurrency_type_info = new String[]{'displayCurrency','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableForecasts_type_info = new String[]{'enableForecasts','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] forecastingCategoryMappings_type_info = new String[]{'forecastingCategoryMappings','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] forecastingTypeSettings_type_info = new String[]{'forecastingTypeSettings','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'displayCurrency','enableForecasts','forecastingCategoryMappings','forecastingTypeSettings'};
    }
    public class ReportAggregateReference {
        public String aggregate;
        private String[] aggregate_type_info = new String[]{'aggregate','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'aggregate'};
    }
    public class DashboardFilterOption {
        public String operator;
        public String[] values;
        private String[] operator_type_info = new String[]{'operator','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] values_type_info = new String[]{'values','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'operator','values'};
    }
    public class FlowConstant extends FlowElement {
        public String type = 'FlowConstant';
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        public String description;
        public String name;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        public String dataType;
        public MetadataService.FlowElementReferenceOrValue value;
        private String[] dataType_type_info = new String[]{'dataType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] value_type_info = new String[]{'value','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'processMetadataValues','description','name', 'dataType','value'};
    }
    public class ConnectedAppSamlConfig {
        public String acsUrl;
        public String certificate;
        public String encryptionCertificate;
        public String encryptionType;
        public String entityUrl;
        public String issuer;
        public String samlNameIdFormat;
        public String samlSubjectCustomAttr;
        public String samlSubjectType;
        private String[] acsUrl_type_info = new String[]{'acsUrl','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] certificate_type_info = new String[]{'certificate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] encryptionCertificate_type_info = new String[]{'encryptionCertificate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] encryptionType_type_info = new String[]{'encryptionType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] entityUrl_type_info = new String[]{'entityUrl','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] issuer_type_info = new String[]{'issuer','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] samlNameIdFormat_type_info = new String[]{'samlNameIdFormat','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] samlSubjectCustomAttr_type_info = new String[]{'samlSubjectCustomAttr','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] samlSubjectType_type_info = new String[]{'samlSubjectType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'acsUrl','certificate','encryptionCertificate','encryptionType','entityUrl','issuer','samlNameIdFormat','samlSubjectCustomAttr','samlSubjectType'};
    }
    public class LiveChatSensitiveDataRule {
        public String actionType;
        public String description;
        public Integer enforceOn;
        public Boolean isEnabled;
        public String pattern;
        public String replacement;
        private String[] actionType_type_info = new String[]{'actionType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enforceOn_type_info = new String[]{'enforceOn','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] isEnabled_type_info = new String[]{'isEnabled','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] pattern_type_info = new String[]{'pattern','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] replacement_type_info = new String[]{'replacement','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'actionType','description','enforceOn','isEnabled','pattern','replacement'};
    }
    public class ApprovalStepRejectBehavior {
        public String type_x;
        private String[] type_x_type_info = new String[]{'type','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'type_x'};
    }
    public class XOrgHubSharedObject {
        public String[] fields;
        public String name;
        private String[] fields_type_info = new String[]{'fields','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'fields','name'};
    }
    public class createMetadata_element {
        public MetadataService.Metadata[] metadata;
        private String[] metadata_type_info = new String[]{'metadata','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'metadata'};
    }
    public class CustomPageWebLinkTranslation {
        public String label;
        public String name;
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'label','name'};
    }
    public class describeMetadataResponse_element {
        public MetadataService.DescribeMetadataResult result;
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class CustomPermissionDependencyRequired {
        public String customPermission;
        public Boolean dependency;
        private String[] customPermission_type_info = new String[]{'customPermission','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] dependency_type_info = new String[]{'dependency','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'customPermission','dependency'};
    }
    public class ProfileFieldLevelSecurity {
        public Boolean editable;
        public String field;
        public Boolean readable;
        private String[] editable_type_info = new String[]{'editable','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] field_type_info = new String[]{'field','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] readable_type_info = new String[]{'readable','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'editable','field','readable'};
    }
    public class checkDeployStatus_element {
        public String asyncProcessId;
        public Boolean includeDetails;
        private String[] asyncProcessId_type_info = new String[]{'asyncProcessId','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] includeDetails_type_info = new String[]{'includeDetails','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'asyncProcessId','includeDetails'};
    }
    public virtual class MetadataWithContent extends Metadata {
        public String content;
    }
    public class FlowActionCallInputParameter extends FlowBaseElement {
        public String type = 'FlowActionCallInputParameter';
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        public String name;
        public MetadataService.FlowElementReferenceOrValue value;
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] value_type_info = new String[]{'value','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'processMetadataValues', 'name','value'};
    }
    public class SkillUserAssignments {
        public String[] user_x;
        private String[] user_x_type_info = new String[]{'user','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'user_x'};
    }
    public class checkDeployStatusResponse_element {
        public MetadataService.DeployResult result;
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class FlowRecordUpdate extends FlowNode {
        public String type = 'FlowRecordUpdate';
        public MetadataService.FlowMetadataValue[] processMetadataValues;
        private String[] processMetadataValues_type_info = new String[]{'processMetadataValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        public String description;
        public String name;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        public String label;
        public Integer locationX;
        public Integer locationY;
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] locationX_type_info = new String[]{'locationX','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] locationY_type_info = new String[]{'locationY','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        public MetadataService.FlowConnector connector;
        public MetadataService.FlowConnector faultConnector;
        public MetadataService.FlowRecordFilter[] filters;
        public MetadataService.FlowInputFieldAssignment[] inputAssignments;
        public String inputReference;
        public String object_x;
        private String[] connector_type_info = new String[]{'connector','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] faultConnector_type_info = new String[]{'faultConnector','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] filters_type_info = new String[]{'filters','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] inputAssignments_type_info = new String[]{'inputAssignments','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] inputReference_type_info = new String[]{'inputReference','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] object_x_type_info = new String[]{'object','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'processMetadataValues','description','name','label','locationX','locationY', 'connector','faultConnector','filters','inputAssignments','inputReference','object_x'};
    }
    public class DashboardComponent {
        public Boolean autoselectColumnsFromReport;
        public String chartAxisRange;
        public Double chartAxisRangeMax;
        public Double chartAxisRangeMin;
        public MetadataService.ChartSummary[] chartSummary;
        public String componentType;
        public MetadataService.DashboardFilterColumn[] dashboardFilterColumns;
        public MetadataService.DashboardTableColumn[] dashboardTableColumn;
        public String displayUnits;
        public String drillDownUrl;
        public Boolean drillEnabled;
        public Boolean drillToDetailEnabled;
        public Boolean enableHover;
        public Boolean expandOthers;
        public String footer;
        public Double gaugeMax;
        public Double gaugeMin;
        public String[] groupingColumn;
        public String header;
        public Double indicatorBreakpoint1;
        public Double indicatorBreakpoint2;
        public String indicatorHighColor;
        public String indicatorLowColor;
        public String indicatorMiddleColor;
        public String legendPosition;
        public Integer maxValuesDisplayed;
        public String metricLabel;
        public String page_x;
        public Integer pageHeightInPixels;
        public String report;
        public String scontrol;
        public Integer scontrolHeightInPixels;
        public Boolean showPercentage;
        public Boolean showPicturesOnCharts;
        public Boolean showPicturesOnTables;
        public Boolean showTotal;
        public Boolean showValues;
        public String sortBy;
        public String title;
        public Boolean useReportChart;
        private String[] autoselectColumnsFromReport_type_info = new String[]{'autoselectColumnsFromReport','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] chartAxisRange_type_info = new String[]{'chartAxisRange','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] chartAxisRangeMax_type_info = new String[]{'chartAxisRangeMax','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] chartAxisRangeMin_type_info = new String[]{'chartAxisRangeMin','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] chartSummary_type_info = new String[]{'chartSummary','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] componentType_type_info = new String[]{'componentType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] dashboardFilterColumns_type_info = new String[]{'dashboardFilterColumns','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] dashboardTableColumn_type_info = new String[]{'dashboardTableColumn','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] displayUnits_type_info = new String[]{'displayUnits','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] drillDownUrl_type_info = new String[]{'drillDownUrl','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] drillEnabled_type_info = new String[]{'drillEnabled','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] drillToDetailEnabled_type_info = new String[]{'drillToDetailEnabled','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableHover_type_info = new String[]{'enableHover','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] expandOthers_type_info = new String[]{'expandOthers','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] footer_type_info = new String[]{'footer','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] gaugeMax_type_info = new String[]{'gaugeMax','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] gaugeMin_type_info = new String[]{'gaugeMin','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] groupingColumn_type_info = new String[]{'groupingColumn','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] header_type_info = new String[]{'header','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] indicatorBreakpoint1_type_info = new String[]{'indicatorBreakpoint1','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] indicatorBreakpoint2_type_info = new String[]{'indicatorBreakpoint2','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] indicatorHighColor_type_info = new String[]{'indicatorHighColor','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] indicatorLowColor_type_info = new String[]{'indicatorLowColor','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] indicatorMiddleColor_type_info = new String[]{'indicatorMiddleColor','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] legendPosition_type_info = new String[]{'legendPosition','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] maxValuesDisplayed_type_info = new String[]{'maxValuesDisplayed','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] metricLabel_type_info = new String[]{'metricLabel','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] page_x_type_info = new String[]{'page','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] pageHeightInPixels_type_info = new String[]{'pageHeightInPixels','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] report_type_info = new String[]{'report','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] scontrol_type_info = new String[]{'scontrol','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] scontrolHeightInPixels_type_info = new String[]{'scontrolHeightInPixels','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showPercentage_type_info = new String[]{'showPercentage','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showPicturesOnCharts_type_info = new String[]{'showPicturesOnCharts','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showPicturesOnTables_type_info = new String[]{'showPicturesOnTables','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showTotal_type_info = new String[]{'showTotal','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showValues_type_info = new String[]{'showValues','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] sortBy_type_info = new String[]{'sortBy','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] title_type_info = new String[]{'title','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] useReportChart_type_info = new String[]{'useReportChart','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'autoselectColumnsFromReport','chartAxisRange','chartAxisRangeMax','chartAxisRangeMin','chartSummary','componentType','dashboardFilterColumns','dashboardTableColumn','displayUnits','drillDownUrl','drillEnabled','drillToDetailEnabled','enableHover','expandOthers','footer','gaugeMax','gaugeMin','groupingColumn','header','indicatorBreakpoint1','indicatorBreakpoint2','indicatorHighColor','indicatorLowColor','indicatorMiddleColor','legendPosition','maxValuesDisplayed','metricLabel','page_x','pageHeightInPixels','report','scontrol','scontrolHeightInPixels','showPercentage','showPicturesOnCharts','showPicturesOnTables','showTotal','showValues','sortBy','title','useReportChart'};
    }
    public class ReportColorRange {
        public String aggregate;
        public String columnName;
        public Double highBreakpoint;
        public String highColor;
        public Double lowBreakpoint;
        public String lowColor;
        public String midColor;
        private String[] aggregate_type_info = new String[]{'aggregate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] columnName_type_info = new String[]{'columnName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] highBreakpoint_type_info = new String[]{'highBreakpoint','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] highColor_type_info = new String[]{'highColor','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] lowBreakpoint_type_info = new String[]{'lowBreakpoint','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] lowColor_type_info = new String[]{'lowColor','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] midColor_type_info = new String[]{'midColor','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'aggregate','columnName','highBreakpoint','highColor','lowBreakpoint','lowColor','midColor'};
    }
    public class SummaryLayout {
        public String masterLabel;
        public Integer sizeX;
        public Integer sizeY;
        public Integer sizeZ;
        public MetadataService.SummaryLayoutItem[] summaryLayoutItems;
        public String summaryLayoutStyle;
        private String[] masterLabel_type_info = new String[]{'masterLabel','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] sizeX_type_info = new String[]{'sizeX','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] sizeY_type_info = new String[]{'sizeY','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] sizeZ_type_info = new String[]{'sizeZ','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] summaryLayoutItems_type_info = new String[]{'summaryLayoutItems','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] summaryLayoutStyle_type_info = new String[]{'summaryLayoutStyle','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'masterLabel','sizeX','sizeY','sizeZ','summaryLayoutItems','summaryLayoutStyle'};
    }
    public class QuickActionLayout {
        public String layoutSectionStyle;
        public MetadataService.QuickActionLayoutColumn[] quickActionLayoutColumns;
        private String[] layoutSectionStyle_type_info = new String[]{'layoutSectionStyle','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] quickActionLayoutColumns_type_info = new String[]{'quickActionLayoutColumns','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'layoutSectionStyle','quickActionLayoutColumns'};
    }
    public class Territory2Type extends Metadata {
        public String type = 'Territory2Type';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String description;
        public String name;
        public Integer priority;
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] priority_type_info = new String[]{'priority','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'description','name','priority'};
    }
    public class listMetadataResponse_element {
        public MetadataService.FileProperties[] result;
        private String[] result_type_info = new String[]{'result','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'result'};
    }
    public class SamlSsoConfig extends Metadata {
        public String type = 'SamlSsoConfig';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public String attributeName;
        public String attributeNameIdFormat;
        public String decryptionCertificate;
        public String errorUrl;
        public String executionUserId;
        public String identityLocation;
        public String identityMapping;
        public String issuer;
        public String loginUrl;
        public String logoutUrl;
        public String name;
        public String oauthTokenEndpoint;
        public Boolean redirectBinding;
        public String requestSignatureMethod;
        public String salesforceLoginUrl;
        public String samlEntityId;
        public String samlJitHandlerId;
        public String samlVersion;
        public Boolean userProvisioning;
        public String validationCert;
        private String[] attributeName_type_info = new String[]{'attributeName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] attributeNameIdFormat_type_info = new String[]{'attributeNameIdFormat','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] decryptionCertificate_type_info = new String[]{'decryptionCertificate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] errorUrl_type_info = new String[]{'errorUrl','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] executionUserId_type_info = new String[]{'executionUserId','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] identityLocation_type_info = new String[]{'identityLocation','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] identityMapping_type_info = new String[]{'identityMapping','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] issuer_type_info = new String[]{'issuer','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] loginUrl_type_info = new String[]{'loginUrl','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] logoutUrl_type_info = new String[]{'logoutUrl','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] oauthTokenEndpoint_type_info = new String[]{'oauthTokenEndpoint','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] redirectBinding_type_info = new String[]{'redirectBinding','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] requestSignatureMethod_type_info = new String[]{'requestSignatureMethod','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] salesforceLoginUrl_type_info = new String[]{'salesforceLoginUrl','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] samlEntityId_type_info = new String[]{'samlEntityId','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] samlJitHandlerId_type_info = new String[]{'samlJitHandlerId','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] samlVersion_type_info = new String[]{'samlVersion','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] userProvisioning_type_info = new String[]{'userProvisioning','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] validationCert_type_info = new String[]{'validationCert','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'attributeName','attributeNameIdFormat','decryptionCertificate','errorUrl','executionUserId','identityLocation','identityMapping','issuer','loginUrl','logoutUrl','name','oauthTokenEndpoint','redirectBinding','requestSignatureMethod','salesforceLoginUrl','samlEntityId','samlJitHandlerId','samlVersion','userProvisioning','validationCert'};
    }
    public class describeValueType_element {
        public String type_x;
        private String[] type_x_type_info = new String[]{'type','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'type_x'};
    }
    public class ReputationLevels {
        public MetadataService.ChatterAnswersReputationLevel[] chatterAnswersReputationLevels;
        public MetadataService.IdeaReputationLevel[] ideaReputationLevels;
        private String[] chatterAnswersReputationLevels_type_info = new String[]{'chatterAnswersReputationLevels','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] ideaReputationLevels_type_info = new String[]{'ideaReputationLevels','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'chatterAnswersReputationLevels','ideaReputationLevels'};
    }
    public virtual class FlowBaseElement {
        public MetadataService.FlowMetadataValue[] processMetadataValues;
    }
    public class SidebarComponent {
        public String componentType;
        public Integer height;
        public String label;
        public String lookup;
        public String page_x;
        public MetadataService.RelatedList[] relatedLists;
        public String unit;
        public Integer width;
        private String[] componentType_type_info = new String[]{'componentType','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] height_type_info = new String[]{'height','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] lookup_type_info = new String[]{'lookup','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] page_x_type_info = new String[]{'page','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] relatedLists_type_info = new String[]{'relatedLists','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] unit_type_info = new String[]{'unit','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] width_type_info = new String[]{'width','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'componentType','height','label','lookup','page_x','relatedLists','unit','width'};
    }
    public class TransactionSecurityNotification {
        public Boolean inApp;
        public Boolean sendEmail;
        public String user_x;
        private String[] inApp_type_info = new String[]{'inApp','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] sendEmail_type_info = new String[]{'sendEmail','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] user_x_type_info = new String[]{'user','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'inApp','sendEmail','user_x'};
    }
    public class ReportColumn {
        public String[] aggregateTypes;
        public String field;
        public Boolean reverseColors;
        public Boolean showChanges;
        private String[] aggregateTypes_type_info = new String[]{'aggregateTypes','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] field_type_info = new String[]{'field','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] reverseColors_type_info = new String[]{'reverseColors','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] showChanges_type_info = new String[]{'showChanges','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'aggregateTypes','field','reverseColors','showChanges'};
    }
    public class BusinessHoursSettings extends Metadata {
        public String type = 'BusinessHoursSettings';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public MetadataService.BusinessHoursEntry[] businessHours;
        public MetadataService.Holiday[] holidays;
        private String[] businessHours_type_info = new String[]{'businessHours','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] holidays_type_info = new String[]{'holidays','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'businessHours','holidays'};
    }
    public class FieldSetItem {
        public String field;
        public Boolean isFieldManaged;
        public Boolean isRequired;
        private String[] field_type_info = new String[]{'field','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] isFieldManaged_type_info = new String[]{'isFieldManaged','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] isRequired_type_info = new String[]{'isRequired','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'field','isFieldManaged','isRequired'};
    }
    public class ProfileUserPermission {
        public Boolean enabled;
        public String name;
        private String[] enabled_type_info = new String[]{'enabled','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'enabled','name'};
    }
    public class FindSimilarOppFilter {
        public String[] similarOpportunitiesDisplayColumns;
        public String[] similarOpportunitiesMatchFields;
        private String[] similarOpportunitiesDisplayColumns_type_info = new String[]{'similarOpportunitiesDisplayColumns','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] similarOpportunitiesMatchFields_type_info = new String[]{'similarOpportunitiesMatchFields','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'similarOpportunitiesDisplayColumns','similarOpportunitiesMatchFields'};
    }
    public class ReportAggregate {
        public String acrossGroupingContext;
        public String calculatedFormula;
        public String datatype;
        public String description;
        public String developerName;
        public String downGroupingContext;
        public Boolean isActive;
        public Boolean isCrossBlock;
        public String masterLabel;
        public String reportType;
        public Integer scale;
        private String[] acrossGroupingContext_type_info = new String[]{'acrossGroupingContext','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] calculatedFormula_type_info = new String[]{'calculatedFormula','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] datatype_type_info = new String[]{'datatype','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] developerName_type_info = new String[]{'developerName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] downGroupingContext_type_info = new String[]{'downGroupingContext','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] isActive_type_info = new String[]{'isActive','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] isCrossBlock_type_info = new String[]{'isCrossBlock','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] masterLabel_type_info = new String[]{'masterLabel','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] reportType_type_info = new String[]{'reportType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] scale_type_info = new String[]{'scale','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'acrossGroupingContext','calculatedFormula','datatype','description','developerName','downGroupingContext','isActive','isCrossBlock','masterLabel','reportType','scale'};
    }
    public class ContractSettings extends Metadata {
        public String type = 'ContractSettings';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Boolean autoCalculateEndDate;
        public String autoExpirationDelay;
        public String autoExpirationRecipient;
        public Boolean autoExpireContracts;
        public Boolean enableContractHistoryTracking;
        public Boolean notifyOwnersOnContractExpiration;
        private String[] autoCalculateEndDate_type_info = new String[]{'autoCalculateEndDate','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] autoExpirationDelay_type_info = new String[]{'autoExpirationDelay','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] autoExpirationRecipient_type_info = new String[]{'autoExpirationRecipient','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] autoExpireContracts_type_info = new String[]{'autoExpireContracts','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] enableContractHistoryTracking_type_info = new String[]{'enableContractHistoryTracking','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] notifyOwnersOnContractExpiration_type_info = new String[]{'notifyOwnersOnContractExpiration','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'autoCalculateEndDate','autoExpirationDelay','autoExpirationRecipient','autoExpireContracts','enableContractHistoryTracking','notifyOwnersOnContractExpiration'};
    }
    public class EscalationRules extends Metadata {
        public String type = 'EscalationRules';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public MetadataService.EscalationRule[] escalationRule;
        private String[] escalationRule_type_info = new String[]{'escalationRule','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'escalationRule'};
    }
    public class NetworkTabSet {
        public String[] customTab;
        public String defaultTab;
        public String[] standardTab;
        private String[] customTab_type_info = new String[]{'customTab','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] defaultTab_type_info = new String[]{'defaultTab','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] standardTab_type_info = new String[]{'standardTab','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'customTab','defaultTab','standardTab'};
    }
    public class CustomField extends Metadata {
        public String type = 'CustomField';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public Boolean caseSensitive;
        public String customDataType;
        public String defaultValue;
        public String deleteConstraint;
        public Boolean deprecated;
        public String description;
        public String displayFormat;
        public Boolean encrypted;
        public Boolean escapeMarkup;
        public String externalDeveloperName;
        public Boolean externalId;
        public String fieldManageability;
        public String formula;
        public String formulaTreatBlanksAs;
        public String inlineHelpText;
        public Boolean isConvertLeadDisabled;
        public Boolean isFilteringDisabled;
        public Boolean isNameField;
        public Boolean isSortingDisabled;
        public String label;
        public Integer length;
        public MetadataService.LookupFilter lookupFilter;
        public String maskChar;
        public String maskType;
        public MetadataService.Picklist picklist;
        public Boolean populateExistingRows;
        public Integer precision;
        public String referenceTargetField;
        public String referenceTo;
        public String relationshipLabel;
        public String relationshipName;
        public Integer relationshipOrder;
        public Boolean reparentableMasterDetail;
        public Boolean required;
        public Boolean restrictedAdminField;
        public Integer scale;
        public Integer startingNumber;
        public Boolean stripMarkup;
        public String summarizedField;
        public MetadataService.FilterItem[] summaryFilterItems;
        public String summaryForeignKey;
        public String summaryOperation;
        public Boolean trackFeedHistory;
        public Boolean trackHistory;
        public Boolean trackTrending;
        public String type_x;
        public Boolean unique;
        public Integer visibleLines;
        public Boolean writeRequiresMasterRead;
        public Boolean displayLocationInDecimal;
        private String[] displayLocationInDecimal_type_info = new String[]{'displayLocationInDecimal','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};        
        private String[] caseSensitive_type_info = new String[]{'caseSensitive','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] customDataType_type_info = new String[]{'customDataType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] defaultValue_type_info = new String[]{'defaultValue','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] deleteConstraint_type_info = new String[]{'deleteConstraint','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] deprecated_type_info = new String[]{'deprecated','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] description_type_info = new String[]{'description','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] displayFormat_type_info = new String[]{'displayFormat','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] encrypted_type_info = new String[]{'encrypted','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] escapeMarkup_type_info = new String[]{'escapeMarkup','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] externalDeveloperName_type_info = new String[]{'externalDeveloperName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] externalId_type_info = new String[]{'externalId','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] fieldManageability_type_info = new String[]{'fieldManageability','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] formula_type_info = new String[]{'formula','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] formulaTreatBlanksAs_type_info = new String[]{'formulaTreatBlanksAs','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] inlineHelpText_type_info = new String[]{'inlineHelpText','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] isConvertLeadDisabled_type_info = new String[]{'isConvertLeadDisabled','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] isFilteringDisabled_type_info = new String[]{'isFilteringDisabled','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] isNameField_type_info = new String[]{'isNameField','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] isSortingDisabled_type_info = new String[]{'isSortingDisabled','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] label_type_info = new String[]{'label','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] length_type_info = new String[]{'length','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] lookupFilter_type_info = new String[]{'lookupFilter','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] maskChar_type_info = new String[]{'maskChar','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] maskType_type_info = new String[]{'maskType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] picklist_type_info = new String[]{'picklist','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] populateExistingRows_type_info = new String[]{'populateExistingRows','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] precision_type_info = new String[]{'precision','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] referenceTargetField_type_info = new String[]{'referenceTargetField','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] referenceTo_type_info = new String[]{'referenceTo','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] relationshipLabel_type_info = new String[]{'relationshipLabel','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] relationshipName_type_info = new String[]{'relationshipName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] relationshipOrder_type_info = new String[]{'relationshipOrder','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] reparentableMasterDetail_type_info = new String[]{'reparentableMasterDetail','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] required_type_info = new String[]{'required','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] restrictedAdminField_type_info = new String[]{'restrictedAdminField','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] scale_type_info = new String[]{'scale','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] startingNumber_type_info = new String[]{'startingNumber','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] stripMarkup_type_info = new String[]{'stripMarkup','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] summarizedField_type_info = new String[]{'summarizedField','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] summaryFilterItems_type_info = new String[]{'summaryFilterItems','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] summaryForeignKey_type_info = new String[]{'summaryForeignKey','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] summaryOperation_type_info = new String[]{'summaryOperation','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] trackFeedHistory_type_info = new String[]{'trackFeedHistory','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] trackHistory_type_info = new String[]{'trackHistory','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] trackTrending_type_info = new String[]{'trackTrending','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] type_x_type_info = new String[]{'type','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] unique_type_info = new String[]{'unique','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] visibleLines_type_info = new String[]{'visibleLines','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] writeRequiresMasterRead_type_info = new String[]{'writeRequiresMasterRead','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'caseSensitive','customDataType','defaultValue','deleteConstraint','deprecated','description','displayFormat','displayLocationInDecimal','encrypted','escapeMarkup','externalDeveloperName','externalId','fieldManageability','formula','formulaTreatBlanksAs','inlineHelpText','isConvertLeadDisabled','isFilteringDisabled','isNameField','isSortingDisabled','label','length','lookupFilter','maskChar','maskType','picklist','populateExistingRows','precision','referenceTargetField','referenceTo','relationshipLabel','relationshipName','relationshipOrder','reparentableMasterDetail','required','restrictedAdminField','scale','startingNumber','stripMarkup','summarizedField','summaryFilterItems','summaryForeignKey','summaryOperation','trackFeedHistory','trackHistory','trackTrending','type_x','unique','visibleLines','writeRequiresMasterRead'};
    }
    public class MatchingRuleItem {
        public String blankValueBehavior;
        public String fieldName;
        public String matchingMethod;
        private String[] blankValueBehavior_type_info = new String[]{'blankValueBehavior','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] fieldName_type_info = new String[]{'fieldName','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] matchingMethod_type_info = new String[]{'matchingMethod','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'blankValueBehavior','fieldName','matchingMethod'};
    }
    public class RuleEntry {
        public String assignedTo;
        public String assignedToType;
        public String booleanFilter;
        public String businessHours;
        public String businessHoursSource;
        public MetadataService.FilterItem[] criteriaItems;
        public Boolean disableEscalationWhenModified;
        public MetadataService.EscalationAction[] escalationAction;
        public String escalationStartTime;
        public String formula;
        public Boolean notifyCcRecipients;
        public Boolean overrideExistingTeams;
        public String replyToEmail;
        public String senderEmail;
        public String senderName;
        public String[] team;
        public String template;
        private String[] assignedTo_type_info = new String[]{'assignedTo','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] assignedToType_type_info = new String[]{'assignedToType','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] booleanFilter_type_info = new String[]{'booleanFilter','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] businessHours_type_info = new String[]{'businessHours','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] businessHoursSource_type_info = new String[]{'businessHoursSource','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] criteriaItems_type_info = new String[]{'criteriaItems','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] disableEscalationWhenModified_type_info = new String[]{'disableEscalationWhenModified','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] escalationAction_type_info = new String[]{'escalationAction','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] escalationStartTime_type_info = new String[]{'escalationStartTime','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] formula_type_info = new String[]{'formula','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] notifyCcRecipients_type_info = new String[]{'notifyCcRecipients','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] overrideExistingTeams_type_info = new String[]{'overrideExistingTeams','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] replyToEmail_type_info = new String[]{'replyToEmail','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] senderEmail_type_info = new String[]{'senderEmail','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] senderName_type_info = new String[]{'senderName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] team_type_info = new String[]{'team','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] template_type_info = new String[]{'template','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'assignedTo','assignedToType','booleanFilter','businessHours','businessHoursSource','criteriaItems','disableEscalationWhenModified','escalationAction','escalationStartTime','formula','notifyCcRecipients','overrideExistingTeams','replyToEmail','senderEmail','senderName','team','template'};
    }
    public class CustomObjectTranslation extends Metadata {
        public String type = 'CustomObjectTranslation';
        public String fullName;
        private String[] fullName_type_info = new String[]{'fullName','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        public MetadataService.ObjectNameCaseValue[] caseValues;
        public MetadataService.CustomFieldTranslation[] fields;
        public String gender;
        public MetadataService.LayoutTranslation[] layouts;
        public String nameFieldLabel;
        public MetadataService.QuickActionTranslation[] quickActions;
        public MetadataService.RecordTypeTranslation[] recordTypes;
        public MetadataService.SharingReasonTranslation[] sharingReasons;
        public MetadataService.StandardFieldTranslation[] standardFields;
        public String startsWith;
        public MetadataService.ValidationRuleTranslation[] validationRules;
        public MetadataService.WebLinkTranslation[] webLinks;
        public MetadataService.WorkflowTaskTranslation[] workflowTasks;
        private String[] caseValues_type_info = new String[]{'caseValues','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] fields_type_info = new String[]{'fields','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] gender_type_info = new String[]{'gender','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] layouts_type_info = new String[]{'layouts','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] nameFieldLabel_type_info = new String[]{'nameFieldLabel','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] quickActions_type_info = new String[]{'quickActions','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] recordTypes_type_info = new String[]{'recordTypes','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] sharingReasons_type_info = new String[]{'sharingReasons','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] standardFields_type_info = new String[]{'standardFields','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] startsWith_type_info = new String[]{'startsWith','http://soap.sforce.com/2006/04/metadata',null,'0','1','false'};
        private String[] validationRules_type_info = new String[]{'validationRules','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] webLinks_type_info = new String[]{'webLinks','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] workflowTasks_type_info = new String[]{'workflowTasks','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] type_att_info = new String[]{'xsi:type'};
        private String[] field_order_type_info = new String[]{'fullName', 'caseValues','fields','gender','layouts','nameFieldLabel','quickActions','recordTypes','sharingReasons','standardFields','startsWith','validationRules','webLinks','workflowTasks'};
    }
    public class ForecastingTypeSettings {
        public Boolean active;
        public MetadataService.AdjustmentsSettings adjustmentsSettings;
        public String[] displayedCategoryApiNames;
        public MetadataService.ForecastRangeSettings forecastRangeSettings;
        public String[] forecastedCategoryApiNames;
        public String[] managerAdjustableCategoryApiNames;
        public String name;
        public MetadataService.OpportunityListFieldsSelectedSettings opportunityListFieldsSelectedSettings;
        public String[] ownerAdjustableCategoryApiNames;
        public MetadataService.QuotasSettings quotasSettings;
        private String[] active_type_info = new String[]{'active','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] adjustmentsSettings_type_info = new String[]{'adjustmentsSettings','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] displayedCategoryApiNames_type_info = new String[]{'displayedCategoryApiNames','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] forecastRangeSettings_type_info = new String[]{'forecastRangeSettings','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] forecastedCategoryApiNames_type_info = new String[]{'forecastedCategoryApiNames','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] managerAdjustableCategoryApiNames_type_info = new String[]{'managerAdjustableCategoryApiNames','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] name_type_info = new String[]{'name','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] opportunityListFieldsSelectedSettings_type_info = new String[]{'opportunityListFieldsSelectedSettings','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] ownerAdjustableCategoryApiNames_type_info = new String[]{'ownerAdjustableCategoryApiNames','http://soap.sforce.com/2006/04/metadata',null,'0','-1','false'};
        private String[] quotasSettings_type_info = new String[]{'quotasSettings','http://soap.sforce.com/2006/04/metadata',null,'1','1','false'};
        private String[] apex_schema_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata','true','false'};
        private String[] field_order_type_info = new String[]{'active','adjustmentsSettings','displayedCategoryApiNames','forecastRangeSettings','forecastedCategoryApiNames','managerAdjustableCategoryApiNames','name','opportunityListFieldsSelectedSettings','ownerAdjustableCategoryApiNames','quotasSettings'};
    }
    public class MetadataPort {
        public String endpoint_x = URL.getSalesforceBaseUrl().toExternalForm() + '/services/Soap/m/35.0';
        public Map<String,String> inputHttpHeaders_x;
        public Map<String,String> outputHttpHeaders_x;
        public String clientCertName_x;
        public String clientCert_x;
        public String clientCertPasswd_x;
        public Integer timeout_x;
        public MetadataService.SessionHeader_element SessionHeader;
        public MetadataService.DebuggingInfo_element DebuggingInfo;
        public MetadataService.DebuggingHeader_element DebuggingHeader;
        public MetadataService.CallOptions_element CallOptions;
        public MetadataService.AllOrNoneHeader_element AllOrNoneHeader;
        private String SessionHeader_hns = 'SessionHeader=http://soap.sforce.com/2006/04/metadata';
        private String DebuggingInfo_hns = 'DebuggingInfo=http://soap.sforce.com/2006/04/metadata';
        private String DebuggingHeader_hns = 'DebuggingHeader=http://soap.sforce.com/2006/04/metadata';
        private String CallOptions_hns = 'CallOptions=http://soap.sforce.com/2006/04/metadata';
        private String AllOrNoneHeader_hns = 'AllOrNoneHeader=http://soap.sforce.com/2006/04/metadata';
        private String[] ns_map_type_info = new String[]{'http://soap.sforce.com/2006/04/metadata', 'MetadataService'};
        public MetadataService.DeleteResult[] deleteMetadata(String type_x,String[] fullNames) {
            MetadataService.deleteMetadata_element request_x = new MetadataService.deleteMetadata_element();
            request_x.type_x = type_x;
            request_x.fullNames = fullNames;
            MetadataService.deleteMetadataResponse_element response_x;
            Map<String, MetadataService.deleteMetadataResponse_element> response_map_x = new Map<String, MetadataService.deleteMetadataResponse_element>();
            response_map_x.put('response_x', response_x);
            WebServiceCallout.invoke(
              this,
              request_x,
              response_map_x,
              new String[]{endpoint_x,
              '',
              'http://soap.sforce.com/2006/04/metadata',
              'deleteMetadata',
              'http://soap.sforce.com/2006/04/metadata',
              'deleteMetadataResponse',
              'MetadataService.deleteMetadataResponse_element'}
            );
            response_x = response_map_x.get('response_x');
            return response_x.result;
        }
        public MetadataService.SaveResult renameMetadata(String type_x,String oldFullName,String newFullName) {
            MetadataService.renameMetadata_element request_x = new MetadataService.renameMetadata_element();
            request_x.type_x = type_x;
            request_x.oldFullName = oldFullName;
            request_x.newFullName = newFullName;
            MetadataService.renameMetadataResponse_element response_x;
            Map<String, MetadataService.renameMetadataResponse_element> response_map_x = new Map<String, MetadataService.renameMetadataResponse_element>();
            response_map_x.put('response_x', response_x);
            WebServiceCallout.invoke(
              this,
              request_x,
              response_map_x,
              new String[]{endpoint_x,
              '',
              'http://soap.sforce.com/2006/04/metadata',
              'renameMetadata',
              'http://soap.sforce.com/2006/04/metadata',
              'renameMetadataResponse',
              'MetadataService.renameMetadataResponse_element'}
            );
            response_x = response_map_x.get('response_x');
            return response_x.result;
        }
        public MetadataService.SaveResult[] updateMetadata(MetadataService.Metadata[] metadata) {
            MetadataService.updateMetadata_element request_x = new MetadataService.updateMetadata_element();
            request_x.metadata = metadata;
            MetadataService.updateMetadataResponse_element response_x;
            Map<String, MetadataService.updateMetadataResponse_element> response_map_x = new Map<String, MetadataService.updateMetadataResponse_element>();
            response_map_x.put('response_x', response_x);
            WebServiceCallout.invoke(
              this,
              request_x,
              response_map_x,
              new String[]{endpoint_x,
              '',
              'http://soap.sforce.com/2006/04/metadata',
              'updateMetadata',
              'http://soap.sforce.com/2006/04/metadata',
              'updateMetadataResponse',
              'MetadataService.updateMetadataResponse_element'}
            );
            response_x = response_map_x.get('response_x');
            return response_x.result;
        }
        public MetadataService.DescribeMetadataResult describeMetadata(Double asOfVersion) {
            MetadataService.describeMetadata_element request_x = new MetadataService.describeMetadata_element();
            request_x.asOfVersion = asOfVersion;
            MetadataService.describeMetadataResponse_element response_x;
            Map<String, MetadataService.describeMetadataResponse_element> response_map_x = new Map<String, MetadataService.describeMetadataResponse_element>();
            response_map_x.put('response_x', response_x);
            WebServiceCallout.invoke(
              this,
              request_x,
              response_map_x,
              new String[]{endpoint_x,
              '',
              'http://soap.sforce.com/2006/04/metadata',
              'describeMetadata',
              'http://soap.sforce.com/2006/04/metadata',
              'describeMetadataResponse',
              'MetadataService.describeMetadataResponse_element'}
            );
            response_x = response_map_x.get('response_x');
            return response_x.result;
        }
        public MetadataService.DeployResult checkDeployStatus(String asyncProcessId,Boolean includeDetails) {
            MetadataService.checkDeployStatus_element request_x = new MetadataService.checkDeployStatus_element();
            request_x.asyncProcessId = asyncProcessId;
            request_x.includeDetails = includeDetails;
            MetadataService.checkDeployStatusResponse_element response_x;
            Map<String, MetadataService.checkDeployStatusResponse_element> response_map_x = new Map<String, MetadataService.checkDeployStatusResponse_element>();
            response_map_x.put('response_x', response_x);
            WebServiceCallout.invoke(
              this,
              request_x,
              response_map_x,
              new String[]{endpoint_x,
              '',
              'http://soap.sforce.com/2006/04/metadata',
              'checkDeployStatus',
              'http://soap.sforce.com/2006/04/metadata',
              'checkDeployStatusResponse',
              'MetadataService.checkDeployStatusResponse_element'}
            );
            response_x = response_map_x.get('response_x');
            return response_x.result;
        }
        public MetadataService.RetrieveResult checkRetrieveStatus(String asyncProcessId,Boolean includeZip) {
            MetadataService.checkRetrieveStatus_element request_x = new MetadataService.checkRetrieveStatus_element();
            request_x.asyncProcessId = asyncProcessId;
            request_x.includeZip = includeZip;
            MetadataService.checkRetrieveStatusResponse_element response_x;
            Map<String, MetadataService.checkRetrieveStatusResponse_element> response_map_x = new Map<String, MetadataService.checkRetrieveStatusResponse_element>();
            response_map_x.put('response_x', response_x);
            WebServiceCallout.invoke(
              this,
              request_x,
              response_map_x,
              new String[]{endpoint_x,
              '',
              'http://soap.sforce.com/2006/04/metadata',
              'checkRetrieveStatus',
              'http://soap.sforce.com/2006/04/metadata',
              'checkRetrieveStatusResponse',
              'MetadataService.checkRetrieveStatusResponse_element'}
            );
            response_x = response_map_x.get('response_x');
            return response_x.result;
        }
        public MetadataService.AsyncResult retrieve(MetadataService.RetrieveRequest retrieveRequest) {
            MetadataService.retrieve_element request_x = new MetadataService.retrieve_element();
            request_x.retrieveRequest = retrieveRequest;
            MetadataService.retrieveResponse_element response_x;
            Map<String, MetadataService.retrieveResponse_element> response_map_x = new Map<String, MetadataService.retrieveResponse_element>();
            response_map_x.put('response_x', response_x);
            WebServiceCallout.invoke(
              this,
              request_x,
              response_map_x,
              new String[]{endpoint_x,
              '',
              'http://soap.sforce.com/2006/04/metadata',
              'retrieve',
              'http://soap.sforce.com/2006/04/metadata',
              'retrieveResponse',
              'MetadataService.retrieveResponse_element'}
            );
            response_x = response_map_x.get('response_x');
            return response_x.result;
        }
        public MetadataService.CancelDeployResult cancelDeploy(String String_x) {
            MetadataService.cancelDeploy_element request_x = new MetadataService.cancelDeploy_element();
            request_x.String_x = String_x;
            MetadataService.cancelDeployResponse_element response_x;
            Map<String, MetadataService.cancelDeployResponse_element> response_map_x = new Map<String, MetadataService.cancelDeployResponse_element>();
            response_map_x.put('response_x', response_x);
            WebServiceCallout.invoke(
              this,
              request_x,
              response_map_x,
              new String[]{endpoint_x,
              '',
              'http://soap.sforce.com/2006/04/metadata',
              'cancelDeploy',
              'http://soap.sforce.com/2006/04/metadata',
              'cancelDeployResponse',
              'MetadataService.cancelDeployResponse_element'}
            );
            response_x = response_map_x.get('response_x');
            return response_x.result;
        }
        public String deployRecentValidation(String validationId) {
            MetadataService.deployRecentValidation_element request_x = new MetadataService.deployRecentValidation_element();
            request_x.validationId = validationId;
            MetadataService.deployRecentValidationResponse_element response_x;
            Map<String, MetadataService.deployRecentValidationResponse_element> response_map_x = new Map<String, MetadataService.deployRecentValidationResponse_element>();
            response_map_x.put('response_x', response_x);
            WebServiceCallout.invoke(
              this,
              request_x,
              response_map_x,
              new String[]{endpoint_x,
              '',
              'http://soap.sforce.com/2006/04/metadata',
              'deployRecentValidation',
              'http://soap.sforce.com/2006/04/metadata',
              'deployRecentValidationResponse',
              'MetadataService.deployRecentValidationResponse_element'}
            );
            response_x = response_map_x.get('response_x');
            return response_x.result;
        }
        public MetadataService.DescribeValueTypeResult describeValueType(String type_x) {
            MetadataService.describeValueType_element request_x = new MetadataService.describeValueType_element();
            request_x.type_x = type_x;
            MetadataService.describeValueTypeResponse_element response_x;
            Map<String, MetadataService.describeValueTypeResponse_element> response_map_x = new Map<String, MetadataService.describeValueTypeResponse_element>();
            response_map_x.put('response_x', response_x);
            WebServiceCallout.invoke(
              this,
              request_x,
              response_map_x,
              new String[]{endpoint_x,
              '',
              'http://soap.sforce.com/2006/04/metadata',
              'describeValueType',
              'http://soap.sforce.com/2006/04/metadata',
              'describeValueTypeResponse',
              'MetadataService.describeValueTypeResponse_element'}
            );
            response_x = response_map_x.get('response_x');
            return response_x.result;
        }
        public MetadataService.SaveResult[] createMetadata(MetadataService.Metadata[] metadata) {
            MetadataService.createMetadata_element request_x = new MetadataService.createMetadata_element();
            request_x.metadata = metadata;
            MetadataService.createMetadataResponse_element response_x;
            Map<String, MetadataService.createMetadataResponse_element> response_map_x = new Map<String, MetadataService.createMetadataResponse_element>();
            response_map_x.put('response_x', response_x);
            WebServiceCallout.invoke(
              this,
              request_x,
              response_map_x,
              new String[]{endpoint_x,
              '',
              'http://soap.sforce.com/2006/04/metadata',
              'createMetadata',
              'http://soap.sforce.com/2006/04/metadata',
              'createMetadataResponse',
              'MetadataService.createMetadataResponse_element'}
            );
            response_x = response_map_x.get('response_x');
            return response_x.result;
        }
        public MetadataService.AsyncResult deploy(String ZipFile,MetadataService.DeployOptions DeployOptions) {
            MetadataService.deploy_element request_x = new MetadataService.deploy_element();
            request_x.ZipFile = ZipFile;
            request_x.DeployOptions = DeployOptions;
            MetadataService.deployResponse_element response_x;
            Map<String, MetadataService.deployResponse_element> response_map_x = new Map<String, MetadataService.deployResponse_element>();
            response_map_x.put('response_x', response_x);
            WebServiceCallout.invoke(
              this,
              request_x,
              response_map_x,
              new String[]{endpoint_x,
              '',
              'http://soap.sforce.com/2006/04/metadata',
              'deploy',
              'http://soap.sforce.com/2006/04/metadata',
              'deployResponse',
              'MetadataService.deployResponse_element'}
            );
            response_x = response_map_x.get('response_x');
            return response_x.result;
        }
        public MetadataService.IReadResult readMetadata(String type_x,String[] fullNames) {
            MetadataService.readMetadata_element request_x = new MetadataService.readMetadata_element();
            request_x.type_x = type_x;
            request_x.fullNames = fullNames;
            MetadataService.IReadResponseElement response_x;
            Map<String, MetadataService.IReadResponseElement> response_map_x = new Map<String, MetadataService.IReadResponseElement>();
            response_map_x.put('response_x', response_x);
            WebServiceCallout.invoke(
              this,
              request_x,
              response_map_x,
              new String[]{endpoint_x,
              '',
              'http://soap.sforce.com/2006/04/metadata',
              'readMetadata',
              'http://soap.sforce.com/2006/04/metadata',
              'readMetadataResponse',
              'MetadataService.read' + type_x + 'Response_element'}
            );
            response_x = response_map_x.get('response_x');
            return response_x.getResult();
        }
        public MetadataService.UpsertResult[] upsertMetadata(MetadataService.Metadata[] metadata) {
            MetadataService.upsertMetadata_element request_x = new MetadataService.upsertMetadata_element();
            request_x.metadata = metadata;
            MetadataService.upsertMetadataResponse_element response_x;
            Map<String, MetadataService.upsertMetadataResponse_element> response_map_x = new Map<String, MetadataService.upsertMetadataResponse_element>();
            response_map_x.put('response_x', response_x);
            WebServiceCallout.invoke(
              this,
              request_x,
              response_map_x,
              new String[]{endpoint_x,
              '',
              'http://soap.sforce.com/2006/04/metadata',
              'upsertMetadata',
              'http://soap.sforce.com/2006/04/metadata',
              'upsertMetadataResponse',
              'MetadataService.upsertMetadataResponse_element'}
            );
            response_x = response_map_x.get('response_x');
            return response_x.result;
        }
        public MetadataService.FileProperties[] listMetadata(MetadataService.ListMetadataQuery[] queries,Double asOfVersion) {
            MetadataService.listMetadata_element request_x = new MetadataService.listMetadata_element();
            request_x.queries = queries;
            request_x.asOfVersion = asOfVersion;
            MetadataService.listMetadataResponse_element response_x;
            Map<String, MetadataService.listMetadataResponse_element> response_map_x = new Map<String, MetadataService.listMetadataResponse_element>();
            response_map_x.put('response_x', response_x);
            WebServiceCallout.invoke(
              this,
              request_x,
              response_map_x,
              new String[]{endpoint_x,
              '',
              'http://soap.sforce.com/2006/04/metadata',
              'listMetadata',
              'http://soap.sforce.com/2006/04/metadata',
              'listMetadataResponse',
              'MetadataService.listMetadataResponse_element'}
            );
            response_x = response_map_x.get('response_x');
            return response_x.result;
        }
    }
}